/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],N=0,D=J.length;N<D;N++)e[N]=ie[J[N]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class N{static get(){const R=new Map,L=new Map,A=new Map,k=new Map;function h($,w){$.has(w.detail)||$.set(w.detail,-w.timestamp)}function a($,w){const P=$.get(w.detail);P&&(P>=0||$.set(w.detail,P+w.timestamp))}let v=[];typeof J=="function"&&typeof J.getStats=="function"&&(v=J.getStats().slice(0).sort(($,w)=>$.timestamp-w.timestamp));for(const $ of v)switch($.type){case 10:h(R,$);break;case 11:case 12:a(R,$);break;case 21:h(L,$);break;case 22:a(L,$);break;case 33:h(A,$);break;case 34:a(A,$);break;case 31:h(k,$);break;case 32:a(k,$);break}let E=0;A.forEach($=>E+=$);function d($){const w=[];return $.forEach((P,b)=>w.push([b,P])),w}return{amdLoad:d(R),amdInvoke:d(L),nodeRequire:d(A),nodeEval:d(k),nodeRequireTotal:E}}static toMarkdownTable(R,L){let A="";const k=[];return R.forEach((h,a)=>{k[a]=h.length}),L.forEach(h=>{h.forEach((a,v)=>{typeof a>"u"&&(a=h[v]="-");const E=a.toString().length;k[v]=Math.max(E,k[v])})}),R.forEach((h,a)=>{A+=`| ${h+" ".repeat(k[a]-h.toString().length)} `}),A+=`|
`,R.forEach((h,a)=>{A+=`| ${"-".repeat(k[a])} `}),A+=`|
`,L.forEach(h=>{h.forEach((a,v)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(k[v]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=N}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function N(A){return(k,h,a)=>{let v=null,E=null;if(typeof a.value=="function"?(v="value",E=a.value):typeof a.get=="function"&&(v="get",E=a.get),!E)throw new Error("not supported");a[v]=A(E,h)}}function D(A,k,h){let a=null,v=null;if(typeof h.value=="function"?(a="value",v=h.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",v=h.get),!v)throw new Error("not supported");const E=`$memoize$${k}`;h[a]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,d)}),this[E]}}e.$zh=D;function R(A,k,h){return N((a,v)=>{const E=`$debounce$${v}`,d=`$debounce$result$${v}`;return function(...$){this[d]||(this[d]=h?h():void 0),clearTimeout(this[E]),k&&(this[d]=k(this[d],...$),$=[this[d]]),this[E]=setTimeout(()=>{a.apply(this,$),this[d]=h?h():void 0},A)}})}e.$Ah=R;function L(A,k,h){return N((a,v)=>{const E=`$throttle$timer$${v}`,d=`$throttle$result$${v}`,$=`$throttle$lastRun$${v}`,w=`$throttle$pending$${v}`;return function(...P){if(this[d]||(this[d]=h?h():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),k&&(this[d]=k(this[d],...P)),this[w])return;const b=this[$]+A;b<=Date.now()?(this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0):(this[w]=!0,this[E]=setTimeout(()=>{this[w]=!1,this[$]=Date.now(),a.apply(this,[this[d]]),this[d]=h?h():void 0},b-Date.now()))}})}e.$Bh=L}),define(ie[71],ne([0,1,7]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(a,v){if(!a)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=D;function R(a,v="Unreachable"){throw new Error(v)}e.$6c=R;function L(a){if(!a)throw new N.$cb("Assertion Failed")}e.$7c=L;function A(a){a||(0,N.$1)(new N.$cb("Assertion Failed"))}e.$8c=A;function k(a){if(!a()){debugger;a(),(0,N.$1)(new N.$cb("Assertion Failed"))}}e.$9c=k;function h(a,v){let E=0;for(;E<a.length-1;){const d=a[E],$=a[E+1];if(!v(d,$))return!1;E++}return!0}e.$0c=h}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var N;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(N||(e.ScanError=N={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,I=0;function O(re){let he=0,ce=0;for(;he<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)ce=ce*16+ae-48;else if(ae>=65&&ae<=70)ce=ce*16+ae-65+10;else if(ae>=97&&ae<=102)ce=ce*16+ae-97+10;else break;t++,he++}return he<re&&(ce=-1),ce}function y(re){t=re,s="",o=0,l=16,I=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return I=3,i.substring(re,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;he=t}else I=3;return i.substring(re,he)}function W(){let re="",he=t;for(;;){if(t>=n){re+=i.substring(he,t),I=2;break}const ce=i.charCodeAt(t);if(ce===34){re+=i.substring(he,t),t++;break}if(ce===92){if(re+=i.substring(he,t),t++,t>=n){I=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const q=O(4);q>=0?re+=String.fromCharCode(q):I=4;break}default:I=5}he=t;continue}if(ce>=0&&ce<=31)if(h(ce)){re+=i.substring(he,t),I=2;break}else I=6;t++}return re}function te(){if(s="",I=0,o=t,t>=n)return o=n,l=17;let re=i.charCodeAt(t);if(k(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(k(re));return l=15}if(h(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(re){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=W(),l=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!h(i.charCodeAt(t));)t++;return s=i.substring(he,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=n-1;let ae=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,I=1),s=i.substring(he,t),l=13}return s+=String.fromCharCode(re),t++,l=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),l=11;default:for(;t<n&&_(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(re),t++,l=16}}function _(re){if(k(re)||h(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=te();while(re>=12&&re<=15);return re}return{setPosition:y,getPosition:()=>t,scan:r?oe:te,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>I}}e.$dn=A;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function h(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var v;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(v||(v={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function I(O,y,j,W){o.value=O,o.offset=y,o.length=j,o.type=W,o.colonOffset=void 0,s=o}try{m(i,{onObjectBegin:(O,y)=>{if(r<=O)throw n;s=void 0,l=r>O,t.push("")},onObjectProperty:(O,y,j)=>{if(r<y||(I(O,y,j,"property"),t[t.length-1]=O,r<=y+j))throw n},onObjectEnd:(O,y)=>{if(r<=O)throw n;s=void 0,t.pop()},onArrayBegin:(O,y)=>{if(r<=O)throw n;s=void 0,t.push(0)},onArrayEnd:(O,y)=>{if(r<=O)throw n;s=void 0,t.pop()},onLiteralValue:(O,y,j)=>{if(r<y||(I(O,y,j,g(O)),r<=y+j))throw n},onSeparator:(O,y,j)=>{if(r<=y)throw n;if(O===":"&&s&&s.type==="property")s.colonOffset=y,l=!1,s=void 0;else if(O===","){const W=t[t.length-1];typeof W=="number"?t[t.length-1]=W+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(O){if(O!==n)throw O}return{path:t,previousNode:s,isAtPropertyKey:l,matches:O=>{let y=0;for(let j=0;y<O.length&&j<t.length;j++)if(O[y]===t[j]||O[y]==="*")y++;else if(O[y]!=="**")return!1;return y===O.length}}}e.$en=E;function d(i,r=[],t=L.DEFAULT){let n=null,s=[];const o=[];function l(O){Array.isArray(s)?s.push(O):n!==null&&(s[n]=O)}return m(i,{onObjectBegin:()=>{const O={};l(O),o.push(s),s=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const O=[];l(O),o.push(s),s=O,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(O,y,j)=>{r.push({error:O,offset:y,length:j})}},t),s[0]}e.$fn=d;function $(i,r=[],t=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(O){n.type==="property"&&(n.length=O-n.offset,n=n.parent)}function o(O){return n.children.push(O),O}m(i,{onObjectBegin:O=>{n=o({type:"object",offset:O,length:-1,parent:n,children:[]})},onObjectProperty:(O,y,j)=>{n=o({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:O,offset:y,length:j,parent:n})},onObjectEnd:(O,y)=>{n.length=O+y-n.offset,n=n.parent,s(O+y)},onArrayBegin:(O,y)=>{n=o({type:"array",offset:O,length:-1,parent:n,children:[]})},onArrayEnd:(O,y)=>{n.length=O+y-n.offset,n=n.parent,s(O+y)},onLiteralValue:(O,y,j)=>{o({type:g(O),offset:y,length:j,parent:n,value:O}),s(y+j)},onSeparator:(O,y,j)=>{n.type==="property"&&(O===":"?n.colonOffset=y:O===","&&s(y))},onError:(O,y,j)=>{r.push({error:O,offset:y,length:j})}},t);const I=n.children[0];return I&&delete I.parent,I}e.$gn=$;function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$hn=w;function P(i){if(!i.parent||!i.parent.children)return[];const r=P(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$in=P;function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=b(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$jn=b;function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$kn=c;function p(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=p(n[s],r,t);if(o)return o}return i}}e.$ln=p;function m(i,r,t=L.DEFAULT){const n=A(i,!1);function s(Y){return Y?()=>Y(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Y){return Y?Q=>Y(Q,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),I=o(r.onObjectProperty),O=s(r.onObjectEnd),y=s(r.onArrayBegin),j=s(r.onArrayEnd),W=o(r.onLiteralValue),te=o(r.onSeparator),_=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const Y=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Y){case 12:case 13:re?ae(10):_();break;case 16:ae(1);break;case 15:case 14:break;default:return Y}}}function ae(Y,Q=[],F=[]){if(oe(Y),Q.length+F.length>0){let C=n.getToken();for(;C!==17;){if(Q.indexOf(C)!==-1){ce();break}else if(F.indexOf(C)!==-1)break;C=ce()}}}function q(Y){const Q=n.getTokenValue();return Y?W(Q):I(Q),ce(),!0}function Z(){switch(n.getToken()){case 11:{let Y=0;try{Y=JSON.parse(n.getTokenValue()),typeof Y!="number"&&(ae(2),Y=0)}catch{ae(2)}W(Y);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ce(),!0}function M(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(te(":"),ce(),X()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function U(){l(),ce();let Y=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),te(","),ce(),n.getToken()===2&&he)break}else Y&&ae(6,[],[]);M()||ae(4,[],[2,5]),Y=!0}return O(),n.getToken()!==2?ae(7,[2],[]):ce(),!0}function V(){y(),ce();let Y=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Y||ae(4,[],[]),te(","),ce(),n.getToken()===4&&he)break}else Y&&ae(6,[],[]);X()||ae(4,[],[4,5]),Y=!0}return j(),n.getToken()!==4?ae(8,[4],[]):ce(),!0}function X(){switch(n.getToken()){case 3:return V();case 1:return U();case 10:return q(!0);default:return Z()}}return ce(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):X()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$mn=m;function u(i,r){const t=A(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$nn=u;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$on=g}),define(ie[72],ne([0,1,38]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=void 0;function D(a,v,E){let d,$,w,P,b;if(v){for(P=v.offset,b=P+v.length,w=P;w>0&&!h(a,w-1);)w--;let l=b;for(;l<a.length&&!h(a,l);)l++;$=a.substring(w,l),d=A($,E)}else $=a,d=0,w=0,P=0,b=a.length;const c=k(E,a);let p=!1,m=0,u;E.insertSpaces?u=L(" ",E.tabSize||4):u="	";const g=(0,N.$dn)($,!1);let i=!1;function r(){return c+L(u,d+m)}function t(){let l=g.scan();for(p=!1;l===15||l===14;)p=p||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,I,O){!i&&I<b&&O>P&&a.substring(I,O)!==l&&n.push({offset:I,length:O-I,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,I=L(u,d);s(I,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,I=t(),O="";for(;!p&&(I===12||I===13);){const j=g.getTokenOffset()+w;s(" ",l,j),l=g.getTokenOffset()+g.getTokenLength()+w,O=I===12?r():"",I=t()}if(I===2)o!==1&&(m--,O=r());else if(I===4)o!==3&&(m--,O=r());else{switch(o){case 3:case 1:m++,O=r();break;case 5:case 12:O=r();break;case 13:p?O=r():O=" ";break;case 6:O=" ";break;case 10:if(I===6){O="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?O=" ":I!==5&&I!==17&&(i=!0);break;case 16:i=!0;break}p&&(I===12||I===13)&&(O=r())}const y=g.getTokenOffset()+w;s(O,l,y),o=I}return n}e.$pn=D;function R(a,v){const E=JSON.stringify(a,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?E.replace(/\r\n|\r|\n/g,v.eol):E}e.$qn=R;function L(a,v){let E="";for(let d=0;d<v;d++)E+=a;return E}function A(a,v){let E=0,d=0;const $=v.tabSize||4;for(;E<a.length;){const w=a.charAt(E);if(w===" ")d++;else if(w==="	")d+=$;else break;E++}return Math.floor(d/$)}function k(a,v){for(let E=0;E<v.length;E++){const d=v.charAt(E);if(d==="\r")return E+1<v.length&&v.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}e.$rn=k;function h(a,v){return`\r
`.indexOf(a.charAt(v))!==-1}e.$sn=h}),define(ie[73],ne([0,1,38,72]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=e.$un=e.$tn=void 0;function R(a,v,E){return L(a,v,void 0,E)}e.$tn=R;function L(a,v,E,d,$){const w=v.slice(),P=[],b=(0,N.$gn)(a,P);let c,p;for(;w.length>0&&(p=w.pop(),c=(0,N.$hn)(b,w),c===void 0&&E!==void 0);)typeof p=="string"?E={[p]:E}:E=[E];if(c)if(c.type==="object"&&typeof p=="string"&&Array.isArray(c.children)){const m=(0,N.$hn)(c,[p]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const u=c.children.indexOf(m.parent);let g,i=m.parent.offset+m.parent.length;if(u>0){const r=c.children[u-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return A(a,{offset:g,length:i-g,content:""},d)}else return A(a,{offset:m.offset,length:m.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const u=`${JSON.stringify(p)}: ${JSON.stringify(E)}`,g=$?$(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+u}}else c.children.length===0?i={offset:c.offset+1,length:0,content:u}:i={offset:c.offset+1,length:0,content:u+","};return A(a,i,d)}}else if(c.type==="array"&&typeof p=="number"&&Array.isArray(c.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let u;if(c.children.length===0||p===0)u={offset:c.offset+1,length:0,content:c.children.length===0?m:m+","};else{const g=p===-1||p>c.children.length?c.children.length:p,i=c.children[g-1];u={offset:i.offset+i.length,length:0,content:","+m}}return A(a,u,d)}else{const m=p,u=c.children[m];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===m){const i=c.children[m-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:u.offset,length:c.children[m+1].offset-u.offset,content:""};return A(a,g,d)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${c.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(E)},d)}}e.$un=L;function A(a,v,E){let d=k(a,v),$=v.offset,w=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;$>0&&!(0,D.$sn)(d,$-1);)$--;for(;w<d.length&&!(0,D.$sn)(d,w);)w++}const P=(0,D.$pn)(d,{offset:$,length:w-$},E);for(let c=P.length-1;c>=0;c--){const p=P[c];d=k(d,p),$=Math.min($,p.offset),w=Math.max(w,p.offset+p.length),w+=p.content.length-p.length}const b=a.length-(d.length-w)-$;return[{offset:$,length:b,content:d.substring($,w)}]}e.$vn=A;function k(a,v){return a.substring(0,v.offset)+v.content+a.substring(v.offset+v.length)}e.$wn=k;function h(a,v){const E=v.slice(0).sort(($,w)=>{const P=$.offset-w.offset;return P===0?$.length-w.length:P});let d=a.length;for(let $=E.length-1;$>=0;$--){const w=E[$];if(w.offset+w.length<=d)a=k(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}e.$xn=h}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function N(k,h,a){return Math.min(Math.max(k,h),a)}e.$9l=N;function D(k,h){return(h+k%h)%h}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=R;class L{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=L;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const a=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=A}),function(){function J(R){const L=[];typeof R=="number"&&L.push("code/timeOrigin",R);function A(h){L.push(h,Date.now())}function k(){const h=[];for(let a=0;a<L.length;a+=2)h.push({name:L[a],startTime:L[a+1]});return h}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(R+A.startTime)});return L}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function N(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return N(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=N(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=N(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var N=e();for(var D in N)(typeof exports=="object"?exports:J)[D]=N[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function N(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,N),R.l=!0,R.exports}return N.m=J,N.c=e,N.d=function(D,R,L){N.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:L})},N.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},N.t=function(D,R){if(1&R&&(D=N(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var L=Object.create(null);if(N.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)N.d(L,A,function(k){return D[k]}.bind(null,A));return L},N.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return N.d(R,"a",R),R},N.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},N.p="",N(N.s=0)}([function(J,e,N){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],h=e.src=[],a=0,v=a++;h[v]="0|[1-9]\\d*";var E=a++;h[E]="[0-9]+";var d=a++;h[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=a++;h[$]="("+h[v]+")\\.("+h[v]+")\\.("+h[v]+")";var w=a++;h[w]="("+h[E]+")\\.("+h[E]+")\\.("+h[E]+")";var P=a++;h[P]="(?:"+h[v]+"|"+h[d]+")";var b=a++;h[b]="(?:"+h[E]+"|"+h[d]+")";var c=a++;h[c]="(?:-("+h[P]+"(?:\\."+h[P]+")*))";var p=a++;h[p]="(?:-?("+h[b]+"(?:\\."+h[b]+")*))";var m=a++;h[m]="[0-9A-Za-z-]+";var u=a++;h[u]="(?:\\+("+h[m]+"(?:\\."+h[m]+")*))";var g=a++,i="v?"+h[$]+h[c]+"?"+h[u]+"?";h[g]="^"+i+"$";var r="[v=\\s]*"+h[w]+h[p]+"?"+h[u]+"?",t=a++;h[t]="^"+r+"$";var n=a++;h[n]="((?:<|>)?=?)";var s=a++;h[s]=h[E]+"|x|X|\\*";var o=a++;h[o]=h[v]+"|x|X|\\*";var l=a++;h[l]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[u]+"?)?)?";var I=a++;h[I]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[p]+")?"+h[u]+"?)?)?";var O=a++;h[O]="^"+h[n]+"\\s*"+h[l]+"$";var y=a++;h[y]="^"+h[n]+"\\s*"+h[I]+"$";var j=a++;h[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=a++;h[W]="(?:~>?)";var te=a++;h[te]="(\\s*)"+h[W]+"\\s+",k[te]=new RegExp(h[te],"g");var _=a++;h[_]="^"+h[W]+h[l]+"$";var oe=a++;h[oe]="^"+h[W]+h[I]+"$";var re=a++;h[re]="(?:\\^)";var he=a++;h[he]="(\\s*)"+h[re]+"\\s+",k[he]=new RegExp(h[he],"g");var ce=a++;h[ce]="^"+h[re]+h[l]+"$";var ae=a++;h[ae]="^"+h[re]+h[I]+"$";var q=a++;h[q]="^"+h[n]+"\\s*("+r+")$|^$";var Z=a++;h[Z]="^"+h[n]+"\\s*("+i+")$|^$";var M=a++;h[M]="(\\s*)"+h[n]+"\\s*("+r+"|"+h[l]+")",k[M]=new RegExp(h[M],"g");var U=a++;h[U]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var V=a++;h[V]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var X=a++;h[X]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)R(Y,h[Y]),k[Y]||(k[Y]=new RegExp(h[Y]));function Q(B,K){if(B instanceof F)return B;if(typeof B!="string"||B.length>L||!(K?k[t]:k[g]).test(B))return null;try{return new F(B,K)}catch{return null}}function F(B,K){if(B instanceof F){if(B.loose===K)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof F))return new F(B,K);R("SemVer",B,K),this.loose=K;var x=B.trim().match(K?k[t]:k[g]);if(!x)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<A)return ye}return ge}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=Q,e.valid=function(B,K){var x=Q(B,K);return x?x.version:null},e.clean=function(B,K){var x=Q(B.trim().replace(/^[=v]+/,""),K);return x?x.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(B){return R("SemVer.compare",this.version,this.loose,B),B instanceof F||(B=new F(B,this.loose)),this.compareMain(B)||this.comparePre(B)},F.prototype.compareMain=function(B){return B instanceof F||(B=new F(B,this.loose)),f(this.major,B.major)||f(this.minor,B.minor)||f(this.patch,B.patch)},F.prototype.comparePre=function(B){if(B instanceof F||(B=new F(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var K=0;do{var x=this.prerelease[K],ge=B.prerelease[K];if(R("prerelease compare",K,x,ge),x===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(x===void 0)return-1;if(x!==ge)return f(x,ge)}while(++K)},F.prototype.inc=function(B,K){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,K,x,ge){typeof x=="string"&&(ge=x,x=void 0);try{return new F(B,x).inc(K,ge).version}catch{return null}},e.diff=function(B,K){if(H(B,K))return null;var x=Q(B),ge=Q(K);if(x.prerelease.length||ge.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==ge[ye])return ye},e.compareIdentifiers=f;var C=/^[0-9]+$/;function f(B,K){var x=C.test(B),ge=C.test(K);return x&&ge&&(B=+B,K=+K),x&&!ge?-1:ge&&!x?1:B<K?-1:B>K?1:0}function S(B,K,x){return new F(B,x).compare(new F(K,x))}function z(B,K,x){return S(B,K,x)>0}function T(B,K,x){return S(B,K,x)<0}function H(B,K,x){return S(B,K,x)===0}function G(B,K,x){return S(B,K,x)!==0}function ee(B,K,x){return S(B,K,x)>=0}function ue(B,K,x){return S(B,K,x)<=0}function fe(B,K,x,ge){var ye;switch(K){case"===":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B===x;break;case"!==":typeof B=="object"&&(B=B.version),typeof x=="object"&&(x=x.version),ye=B!==x;break;case"":case"=":case"==":ye=H(B,x,ge);break;case"!=":ye=G(B,x,ge);break;case">":ye=z(B,x,ge);break;case">=":ye=ee(B,x,ge);break;case"<":ye=T(B,x,ge);break;case"<=":ye=ue(B,x,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ye}function me(B,K){if(B instanceof me){if(B.loose===K)return B;B=B.value}if(!(this instanceof me))return new me(B,K);R("comparator",B,K),this.loose=K,this.parse(B),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(B,K){return f(K,B)},e.major=function(B,K){return new F(B,K).major},e.minor=function(B,K){return new F(B,K).minor},e.patch=function(B,K){return new F(B,K).patch},e.compare=S,e.compareLoose=function(B,K){return S(B,K,!0)},e.rcompare=function(B,K,x){return S(K,B,x)},e.sort=function(B,K){return B.sort(function(x,ge){return e.compare(x,ge,K)})},e.rsort=function(B,K){return B.sort(function(x,ge){return e.rcompare(x,ge,K)})},e.gt=z,e.lt=T,e.eq=H,e.neq=G,e.gte=ee,e.lte=ue,e.cmp=fe,e.Comparator=me;var we={};function de(B,K){if(B instanceof de)return B.loose===K?B:new de(B.raw,K);if(B instanceof me)return new de(B.value,K);if(!(this instanceof de))return new de(B,K);if(this.loose=K,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function le(B){return!B||B.toLowerCase()==="x"||B==="*"}function pe(B,K,x,ge,ye,De,Se,ze,Ie,Ne,Ue,Oe,Ae){return((K=le(x)?"":le(ge)?">="+x+".0.0":le(ye)?">="+x+"."+ge+".0":">="+K)+" "+(ze=le(Ie)?"":le(Ne)?"<"+(+Ie+1)+".0.0":le(Ue)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Ue+"-"+Oe:"<="+ze)).trim()}function be(B,K){for(var x=0;x<B.length;x++)if(!B[x].test(K))return!1;if(K.prerelease.length){for(x=0;x<B.length;x++)if(R(B[x].semver),B[x].semver!==we&&B[x].semver.prerelease.length>0){var ge=B[x].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function ke(B,K,x){try{K=new de(K,x)}catch{return!1}return K.test(B)}function je(B,K,x,ge){var ye,De,Se,ze,Ie;switch(B=new F(B,ge),K=new de(K,ge),x){case">":ye=z,De=ue,Se=T,ze=">",Ie=">=";break;case"<":ye=T,De=ee,Se=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(B,K,ge))return!1;for(var Ne=0;Ne<K.set.length;++Ne){var Ue=K.set[Ne],Oe=null,Ae=null;if(Ue.forEach(function(Ce){Ce.semver===we&&(Ce=new me(">=0.0.0")),Oe=Oe||Ce,Ae=Ae||Ce,ye(Ce.semver,Oe.semver,ge)?Oe=Ce:Se(Ce.semver,Ae.semver,ge)&&(Ae=Ce)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(B,Ae.semver)||Ae.operator===Ie&&Se(B,Ae.semver))return!1}return!0}me.prototype.parse=function(B){var K=this.loose?k[q]:k[Z],x=B.match(K);if(!x)throw new TypeError("Invalid comparator: "+B);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new F(x[2],this.loose):this.semver=we},me.prototype.toString=function(){return this.value},me.prototype.test=function(B){return R("Comparator.test",B,this.loose),this.semver===we||(typeof B=="string"&&(B=new F(B,this.loose)),fe(B,this.operator,this.semver,this.loose))},me.prototype.intersects=function(B,K){if(!(B instanceof me))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new de(B.value,K),ke(this.value,x,K);if(B.operator==="")return x=new de(this.value,K),ke(B.semver,x,K);var ge=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),De=this.semver.version===B.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),ze=fe(this.semver,"<",B.semver,K)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Ie=fe(this.semver,">",B.semver,K)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ge||ye||De&&Se||ze||Ie},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(B){var K=this.loose;B=B.trim(),R("range",B,K);var x=K?k[V]:k[U];B=B.replace(x,pe),R("hyphen replace",B),B=B.replace(k[M],"$1$2$3"),R("comparator trim",B,k[M]),B=(B=(B=B.replace(k[te],"$1~")).replace(k[he],"$1^")).split(/\s+/).join(" ");var ge=K?k[q]:k[Z],ye=B.split(" ").map(function(De){return function(Se,ze){return R("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ae){R("caret",Oe,Ae);var Ce=Ae?k[ae]:k[ce];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re){var Fe;return R("caret",Oe,Le,ve,Ee,Pe,Re),le(ve)?Fe="":le(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":le(Pe)?Fe=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+Re+" <"+(+ve+1)+".0.0"):(R("no pr"),Fe=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+Ee+"."+(+Pe+1):">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Pe+" <"+(+ve+1)+".0.0"),R("caret return",Fe),Fe})}(Ue,Ne)}).join(" ")}(Se,ze),R("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Ue){return function(Oe,Ae){var Ce=Ae?k[oe]:k[_];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re){var Fe;return R("tilde",Oe,Le,ve,Ee,Pe,Re),le(ve)?Fe="":le(Ee)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":le(Pe)?Fe=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+ve+"."+Ee+"."+Pe+Re+" <"+ve+"."+(+Ee+1)+".0"):Fe=">="+ve+"."+Ee+"."+Pe+" <"+ve+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Ue,Ne)}).join(" ")}(Se,ze),R("tildes",Se),Se=function(Ie,Ne){return R("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Ue){return function(Oe,Ae){Oe=Oe.trim();var Ce=Ae?k[y]:k[O];return Oe.replace(Ce,function(Le,ve,Ee,Pe,Re,Fe){R("xRange",Oe,Le,ve,Ee,Pe,Re,Fe);var qe=le(Ee),Te=qe||le(Pe),Me=Te||le(Re);return ve==="="&&Me&&(ve=""),qe?Le=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Me?(Te&&(Pe=0),Me&&(Re=0),ve===">"?(ve=">=",Te?(Ee=+Ee+1,Pe=0,Re=0):Me&&(Pe=+Pe+1,Re=0)):ve==="<="&&(ve="<",Te?Ee=+Ee+1:Pe=+Pe+1),Le=ve+Ee+"."+Pe+"."+Re):Te?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Me&&(Le=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Le),Le})}(Ue,Ne)}).join(" ")}(Se,ze),R("xrange",Se),Se=function(Ie,Ne){return R("replaceStars",Ie,Ne),Ie.trim().replace(k[X],"")}(Se,ze),R("stars",Se),Se}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new me(De,K)})},de.prototype.intersects=function(B,K){if(!(B instanceof de))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(ge){return B.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(B,K){return new de(B,K).set.map(function(x){return x.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},de.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new F(B,this.loose));for(var K=0;K<this.set.length;K++)if(be(this.set[K],B))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(B,K,x){var ge=null,ye=null;try{var De=new de(K,x)}catch{return null}return B.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==-1||(ye=new F(ge=Se,x)))}),ge},e.minSatisfying=function(B,K,x){var ge=null,ye=null;try{var De=new de(K,x)}catch{return null}return B.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==1||(ye=new F(ge=Se,x)))}),ge},e.validRange=function(B,K){try{return new de(B,K).range||"*"}catch{return null}},e.ltr=function(B,K,x){return je(B,K,"<",x)},e.gtr=function(B,K,x){return je(B,K,">",x)},e.outside=je,e.prerelease=function(B,K){var x=Q(B,K);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(B,K,x){return B=new de(B,x),K=new de(K,x),B.intersects(K)},e.coerce=function(B){if(B instanceof F)return B;if(typeof B!="string")return null;var K=B.match(k[j]);return K==null?null:Q((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,N(1))},function(J,e){var N,D,R=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k(b){if(N===setTimeout)return setTimeout(b,0);if((N===L||!N)&&setTimeout)return N=setTimeout,setTimeout(b,0);try{return N(b,0)}catch{try{return N.call(null,b,0)}catch{return N.call(this,b,0)}}}(function(){try{N=typeof setTimeout=="function"?setTimeout:L}catch{N=L}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,a=[],v=!1,E=-1;function d(){v&&h&&(v=!1,h.length?a=h.concat(a):E=-1,a.length&&$())}function $(){if(!v){var b=k(d);v=!0;for(var c=a.length;c;){for(h=a,a=[];++E<c;)h&&h[E].run();E=-1,c=a.length}h=null,v=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(b)}}function w(b,c){this.fun=b,this.array=c}function P(){}R.nextTick=function(b){var c=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)c[p-1]=arguments[p];a.push(new w(b,c)),a.length!==1||v||k($)},w.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=P,R.addListener=P,R.once=P,R.off=P,R.removeListener=P,R.removeAllListeners=P,R.emit=P,R.prependListener=P,R.prependOnceListener=P,R.listeners=function(b){return[]},R.binding=function(b){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(b){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;class D{constructor(k,h,a){this.level=k,this.key=h,this.value=a,this.forward=[]}}const R=void 0;class L{constructor(k,h=2**16){this.comparator=k,this[N]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(k){return!!L.g(this,k,this.comparator)}get(k){return L.g(this,k,this.comparator)?.value}set(k,h){return L.h(this,k,h,this.comparator)&&(this.f+=1),this}delete(k){const h=L.k(this,k,this.comparator);return h&&(this.f-=1),h}forEach(k,h){let a=this.e.forward[0];for(;a;)k.call(h,a.value,a.key,this),a=a.forward[0]}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",h=this.e.forward[0];for(;h;)k+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return k}static g(k,h,a){let v=k.e;for(let E=k.d-1;E>=0;E--)for(;v.forward[E]&&a(v.forward[E].key,h)<0;)v=v.forward[E];if(v=v.forward[0],v&&a(v.key,h)===0)return v}static h(k,h,a,v){const E=[];let d=k.e;for(let $=k.d-1;$>=0;$--){for(;d.forward[$]&&v(d.forward[$].key,h)<0;)d=d.forward[$];E[$]=d}if(d=d.forward[0],d&&v(d.key,h)===0)return d.value=a,!1;{const $=L.j(k);if($>k.d){for(let w=k.d;w<$;w++)E[w]=k.e;k.d=$}d=new D($,h,a);for(let w=0;w<$;w++)d.forward[w]=E[w].forward[w],E[w].forward[w]=d;return!0}}static j(k,h=.5){let a=1;for(;Math.random()<h&&a<k.c;)a+=1;return a}static k(k,h,a){const v=[];let E=k.e;for(let d=k.d-1;d>=0;d--){for(;E.forward[d]&&a(E.forward[d].key,h)<0;)E=E.forward[d];v[d]=E}if(E=E.forward[0],!E||a(E.key,h)!==0)return!1;for(let d=0;d<k.d&&v[d].forward[d]===E;d++)v[d].forward[d]=E.forward[d];for(;k.d>0&&k.e.forward[k.d-1]===R;)k.d-=1;return!0}}e.$3r=L}),define(ie[46],ne([0,1,7,2]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function R(u){const g=u;return g?typeof g.read=="function":!1}e.$8d=R;function L(u){const g=u;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$9d=L;function A(u){const g=u;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$0d=A;function k(u,g){return new h(u,g)}e.$$d=k;class h{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,N.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(u,g){const i=[];let r;for(;(r=u.read())!==null;)i.push(r);return g(i)}e.$_d=a;function v(u,g,i){const r=[];let t;for(;(t=u.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return u.read()}}}e.$ae=v;function E(u,g){return new Promise((i,r)=>{const t=[];d(u,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$be=E;function d(u,g,i){u.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),u.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),u.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$ce=d;function $(u,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=I=>{if(n.push(I),n.length>g)return t.dispose(),u.pause(),i({stream:u,buffer:n,ended:!1})},o=I=>(t.dispose(),r(I)),l=()=>(t.dispose(),i({stream:u,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>u.removeListener("error",o))),u.on("error",o),t.add((0,D.$Rc)(()=>u.removeListener("end",l))),u.on("end",l),t.add((0,D.$Rc)(()=>u.removeListener("data",s))),u.on("data",s)})}e.$de=$;function w(u,g){const i=k(g);return i.end(u),i}e.$ee=w;function P(){const u=k(()=>{throw new Error("not supported")});return u.end(),u}e.$fe=P;function b(u){let g=!1;return{read:()=>g?null:(g=!0,u)}}e.$ge=b;function c(u,g,i){const r=k(i);return d(u,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$he=c;function p(u,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([u,t]):u)}}}e.$ie=p;function m(u,g,i){let r=!1;const t=k(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([u,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(u)),t.end()}}),t}e.$je=m}),define(ie[14],ne([0,1,166,46]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const R=typeof Buffer<"u",L=new N.$V(()=>new Uint8Array(256));let A,k;class h{static alloc(j){return R?new h(Buffer.allocUnsafe(j)):new h(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new h(j)}static fromString(j,W){return!(W?.dontUseNodeBuffer||!1)&&R?new h(Buffer.from(j)):(A||(A=new TextEncoder),new h(A.encode(j)))}static fromByteArray(j){const W=h.alloc(j.length);for(let te=0,_=j.length;te<_;te++)W.buffer[te]=j[te];return W}static concat(j,W){if(typeof W>"u"){W=0;for(let oe=0,re=j.length;oe<re;oe++)W+=j[oe].byteLength}const te=h.alloc(W);let _=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];te.set(he,_),_+=he.byteLength}return te}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=h.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,W){return new h(this.buffer.subarray(j,W))}set(j,W){if(j instanceof h)this.buffer.set(j.buffer,W);else if(j instanceof Uint8Array)this.buffer.set(j,W);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),W);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return d(this.buffer,j)}writeUInt32BE(j,W){$(this.buffer,j,W)}readUInt32LE(j){return w(this.buffer,j)}writeUInt32LE(j,W){P(this.buffer,j,W)}readUInt8(j){return b(this.buffer,j)}writeUInt8(j,W){c(this.buffer,j,W)}indexOf(j,W=0){return a(this.buffer,j instanceof h?j.buffer:j,W)}}e.$ke=h;function a(y,j,W=0){const te=j.byteLength,_=y.byteLength;if(te===0)return 0;if(te===1)return y.indexOf(j[0]);if(te>_-W)return-1;const oe=L.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=W+j.length-1,he=re,ce=-1;for(;re<_;)if(y[re]===j[he]){if(he===0){ce=re;break}re--,he--}else re+=Math.max(j.length-he,oe[y[re]]),he=j.length-1;return ce}e.$le=a;function v(y,j){return y[j+0]<<0>>>0|y[j+1]<<8>>>0}e.$me=v;function E(y,j,W){y[W+0]=j&255,j=j>>>8,y[W+1]=j&255}e.$ne=E;function d(y,j){return y[j]*2**24+y[j+1]*2**16+y[j+2]*2**8+y[j+3]}e.$oe=d;function $(y,j,W){y[W+3]=j,j=j>>>8,y[W+2]=j,j=j>>>8,y[W+1]=j,j=j>>>8,y[W]=j}e.$pe=$;function w(y,j){return y[j+0]<<0>>>0|y[j+1]<<8>>>0|y[j+2]<<16>>>0|y[j+3]<<24>>>0}e.$qe=w;function P(y,j,W){y[W+0]=j&255,j=j>>>8,y[W+1]=j&255,j=j>>>8,y[W+2]=j&255,j=j>>>8,y[W+3]=j&255}e.$re=P;function b(y,j){return y[j]}e.$se=b;function c(y,j,W){y[W]=j}e.$te=c;function p(y){return D.$_d(y,j=>h.concat(j))}e.$ue=p;function m(y){return D.$ge(y)}e.$ve=m;function u(y){return D.$be(y,j=>h.concat(j))}e.$we=u;async function g(y){return y.ended?h.concat(y.buffer):h.concat([...y.buffer,await u(y.stream)])}e.$xe=g;function i(y){return D.$ee(y,j=>h.concat(j))}e.$ye=i;function r(y){return D.$he(y,{data:j=>typeof j=="string"?h.fromString(j):h.wrap(j)},j=>h.concat(j))}e.$ze=r;function t(y){return D.$$d(j=>h.concat(j),y)}e.$Ae=t;function n(y,j){return D.$ie(y,j,W=>h.concat(W))}e.$Be=n;function s(y,j){return D.$je(y,j,W=>h.concat(W))}e.$Ce=s;function o(y){let j=0,W=0,te=0;const _=new Uint8Array(Math.floor(y.length/4*3)),oe=he=>{switch(W){case 3:_[te++]=j|he,W=0;break;case 2:_[te++]=j|he>>>2,j=he<<6,W=3;break;case 1:_[te++]=j|he>>>4,j=he<<4,W=2;break;default:j=he<<2,W=1}};for(let he=0;he<y.length;he++){const ce=y.charCodeAt(he);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${y[he]}`)}}const re=te;for(;W>0;)oe(0);return h.wrap(_).slice(0,re)}e.$De=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:y},j=!0,W=!1){const te=W?I:l;let _="";const oe=y.byteLength%3;let re=0;for(;re<y.byteLength-oe;re+=3){const he=y[re+0],ce=y[re+1],ae=y[re+2];_+=te[he>>>2],_+=te[(he<<4|ce>>>4)&63],_+=te[(ce<<2|ae>>>6)&63],_+=te[ae&63]}if(oe===1){const he=y[re+0];_+=te[he>>>2],_+=te[he<<4&63],j&&(_+="==")}else if(oe===2){const he=y[re+0],ce=y[re+1];_+=te[he>>>2],_+=te[(he<<4|ce>>>4)&63],_+=te[ce<<2&63],j&&(_+="=")}return _}e.$Ee=O}),define(ie[43],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=void 0;function D(c){return R(c,0)}e.$Vi=D;function R(c,p){switch(typeof c){case"object":return c===null?L(349,p):Array.isArray(c)?h(c,p):a(c,p);case"string":return k(c,p);case"boolean":return A(c,p);case"number":return L(c,p);case"undefined":return L(937,p);default:return L(617,p)}}e.$Wi=R;function L(c,p){return(p<<5)-p+c|0}e.$Xi=L;function A(c,p){return L(c?433:863,p)}function k(c,p){p=L(149417,p);for(let m=0,u=c.length;m<u;m++)p=L(c.charCodeAt(m),p);return p}e.$Yi=k;function h(c,p){return p=L(104579,p),c.reduce((m,u)=>R(u,m),p)}function a(c,p){return p=L(181387,p),Object.keys(c).sort().reduce((m,u)=>(m=k(u,m),R(c[u],m)),p)}class v{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=R(p,this.g),this.g}}e.$Zi=v;var E;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(c,p,m=32){const u=m-p,g=~((1<<u)-1);return(c<<p|(g&c)>>>u)>>>0}function $(c,p=0,m=c.byteLength,u=0){for(let g=0;g<m;g++)c[p+g]=u}function w(c,p,m="0"){for(;c.length<p;)c=m+c;return c}function P(c,p=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(m=>m.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),p/4)}e.$1i=P;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const m=p.length;if(m===0)return;const u=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=p.charCodeAt(0),t=0);;){let n=r;if(N.$ef(r))if(t+1<m){const s=p.charCodeAt(t+1);N.$ff(s)?(t++,n=N.$gf(r,s)):n=65533}else{i=r;break}else N.$ff(r)&&(n=65533);if(g=this.w(u,g,n),t++,t<m)r=p.charCodeAt(t);else break}this.r=g,this.u=i}w(p,m,u){return u<128?p[m++]=u:u<2048?(p[m++]=192|(u&1984)>>>6,p[m++]=128|(u&63)>>>0):u<65536?(p[m++]=224|(u&61440)>>>12,p[m++]=128|(u&4032)>>>6,p[m++]=128|(u&63)>>>0):(p[m++]=240|(u&1835008)>>>18,p[m++]=128|(u&258048)>>>12,p[m++]=128|(u&4032)>>>6,p[m++]=128|(u&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),P(this.h)+P(this.l)+P(this.m)+P(this.n)+P(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=b.g,m=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,m.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,d(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let u=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(u,5)+n+t+s+p.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=u,u=o;this.h=this.h+u&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$2i=b}),define(ie[54],ne([0,1,30]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const L="error",A="warning",k="warn",h="info",a="ignore";function v(d){return d?N.$af(L,d)?R.Error:N.$af(A,d)||N.$af(k,d)?R.Warning:N.$af(h,d)?R.Info:R.Ignore:R.Ignore}R.fromValue=v;function E(d){switch(d){case R.Error:return L;case R.Warning:return A;case R.Info:return h;default:return a}}R.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([m,u])=>{p[m]=u&&typeof u=="object"?D(u):u}),p}e.$yn=D;function R(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const u in m)if(L.call(m,u)){const g=m[u];typeof g=="object"&&!Object.isFrozen(g)&&!(0,N.$Mf)(g)&&p.push(g)}}return c}e.$zn=R;const L=Object.prototype.hasOwnProperty;function A(c,p){return k(c,p,new Set)}e.$An=A;function k(c,p,m){if((0,N.$Sf)(c))return c;const u=p(c);if(typeof u<"u")return u;if(Array.isArray(c)){const g=[];for(const i of c)g.push(k(i,p,m));return g}if((0,N.$Lf)(c)){if(m.has(c))throw new Error("Cannot clone recursive data-structure");m.add(c);const g={};for(const i in c)L.call(c,i)&&(g[i]=k(c[i],p,m));return m.delete(c),g}return c}function h(c,p,m=!0){return(0,N.$Lf)(c)?((0,N.$Lf)(p)&&Object.keys(p).forEach(u=>{u in c?m&&((0,N.$Lf)(c[u])&&(0,N.$Lf)(p[u])?h(c[u],p[u],m):c[u]=p[u]):c[u]=p[u]}),c):p}e.$Bn=h;function a(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let m,u;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(m=0;m<c.length;m++)if(!a(c[m],p[m]))return!1}else{const g=[];for(u in c)g.push(u);g.sort();const i=[];for(u in p)i.push(u);if(i.sort(),!a(g,i))return!1;for(m=0;m<g.length;m++)if(!a(c[g[m]],p[g[m]]))return!1}return!0}e.$Cn=a;function v(c){const p=new Set;return JSON.stringify(c,(m,u)=>{if((0,N.$Lf)(u)||Array.isArray(u)){if(p.has(u))return"[Circular]";p.add(u)}return u})}e.$Dn=v;function E(c,p){const m=Object.create(null);return!c||!p||Object.keys(p).forEach(g=>{const i=c[g],r=p[g];a(i,r)||(m[g]=r)}),m}e.$En=E;function d(c,p){const m=p.toLowerCase(),u=Object.keys(c).find(g=>g.toLowerCase()===m);return u?c[u]:c[p]}e.$Fn=d;function $(c,p){const m=Object.create(null);for(const[u,g]of Object.entries(c))p(u,g)&&(m[u]=g);return m}e.$Gn=$;function w(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}e.$Hn=w;function P(c){const p=[];for(const m of w(c))typeof c[m]=="function"&&p.push(m);return p}e.$In=P;function b(c,p){const m=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},u={};for(const g of c)u[g]=m(g);return u}e.$Jn=b}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const N=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return N.test(R)}e.$qg=D,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){R(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let h=0,a="";return a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+="-",a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a+=A[L[h++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const k=A.replace(/\-/g,":").toLowerCase();return!D.has(k)}function L(){const A=(0,N.networkInterfaces)();for(const k in A){const h=A[k];if(h){for(const{mac:a}of h)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$_m=L}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const D=60,R=D*60,L=R*24,A=L*7,k=L*30,h=L*365;function a(d,$,w,P){typeof d!="number"&&(d=d.getTime());const b=Math.round((new Date().getTime()-d)/1e3);if(b<-30)return(0,N.localize)(0,null,a(new Date().getTime()+b*1e3,!1));if(!P&&b<30)return(0,N.localize)(1,null);let c;return b<D?(c=b,$?c===1?w?(0,N.localize)(2,null,c):(0,N.localize)(3,null,c):w?(0,N.localize)(4,null,c):(0,N.localize)(5,null,c):c===1?w?(0,N.localize)(6,null,c):(0,N.localize)(7,null,c):w?(0,N.localize)(8,null,c):(0,N.localize)(9,null,c)):b<R?(c=Math.floor(b/D),$?c===1?w?(0,N.localize)(10,null,c):(0,N.localize)(11,null,c):w?(0,N.localize)(12,null,c):(0,N.localize)(13,null,c):c===1?w?(0,N.localize)(14,null,c):(0,N.localize)(15,null,c):w?(0,N.localize)(16,null,c):(0,N.localize)(17,null,c)):b<L?(c=Math.floor(b/R),$?c===1?w?(0,N.localize)(18,null,c):(0,N.localize)(19,null,c):w?(0,N.localize)(20,null,c):(0,N.localize)(21,null,c):c===1?w?(0,N.localize)(22,null,c):(0,N.localize)(23,null,c):w?(0,N.localize)(24,null,c):(0,N.localize)(25,null,c)):b<A?(c=Math.floor(b/L),$?c===1?(0,N.localize)(26,null,c):(0,N.localize)(27,null,c):c===1?(0,N.localize)(28,null,c):(0,N.localize)(29,null,c)):b<k?(c=Math.floor(b/A),$?c===1?w?(0,N.localize)(30,null,c):(0,N.localize)(31,null,c):w?(0,N.localize)(32,null,c):(0,N.localize)(33,null,c):c===1?w?(0,N.localize)(34,null,c):(0,N.localize)(35,null,c):w?(0,N.localize)(36,null,c):(0,N.localize)(37,null,c)):b<h?(c=Math.floor(b/k),$?c===1?w?(0,N.localize)(38,null,c):(0,N.localize)(39,null,c):w?(0,N.localize)(40,null,c):(0,N.localize)(41,null,c):c===1?w?(0,N.localize)(42,null,c):(0,N.localize)(43,null,c):w?(0,N.localize)(44,null,c):(0,N.localize)(45,null,c)):(c=Math.floor(b/h),$?c===1?w?(0,N.localize)(46,null,c):(0,N.localize)(47,null,c):w?(0,N.localize)(48,null,c):(0,N.localize)(49,null,c):c===1?w?(0,N.localize)(50,null,c):(0,N.localize)(51,null,c):w?(0,N.localize)(52,null,c):(0,N.localize)(53,null,c))}e.$xm=a;function v(d,$){const w=Math.abs(d/1e3);return w<1?$?(0,N.localize)(54,null,d):(0,N.localize)(55,null,d):w<D?$?(0,N.localize)(56,null,Math.round(d)/1e3):(0,N.localize)(57,null,Math.round(d)/1e3):w<R?$?(0,N.localize)(58,null,Math.round(d/(1e3*D))):(0,N.localize)(59,null,Math.round(d/(1e3*D))):w<L?$?(0,N.localize)(60,null,Math.round(d/(1e3*R))):(0,N.localize)(61,null,Math.round(d/(1e3*R))):(0,N.localize)(62,null,Math.round(d/(1e3*L)))}e.$ym=v;function E(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=E}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function L(E,d){return d&&(E.stack||E.stacktrace)?R.localize(0,null,k(E),A(E.stack)||A(E.stacktrace)):k(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function h(E=null,d=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const $=N.$Hb(E),w=h($[0],d);return $.length>1?R.localize(4,null,w,$.length):w}if(D.$Jf(E))return E;if(E.detail){const $=E.detail;if($.error)return L($.error,d);if($.exception)return L($.exception,d)}return E.stack?L(E,d):E.message?E.message:R.localize(5,null)}e.$Si=h;function a(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$Ti=a;function v(E,d){let $;return typeof E=="string"?$=new Error(E):$=E,$.actions=d,$}e.$Ui=v}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;function D(R){switch(R){case 1:return(0,N.localize)(0,null);case 2:return(0,N.localize)(1,null);case 3:return(0,N.localize)(2,null);case 4:return(0,N.localize)(3,null);case 5:return(0,N.localize)(4,null);case 6:return(0,N.localize)(5,null);case 7:return(0,N.localize)(6,null);case 8:return(0,N.localize)(7,null);case 9:return(0,N.localize)(8,null);default:return""}}e.$Zp=D}),define(ie[55],ne([0,1,12]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0;var D;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function L(k,...h){const a=h.reduce((d,$)=>(d[$]=!0,d),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(d=>!a[d]).forEach(d=>{for(let $=0;$<v.length;$++)if(d.search(v[$])!==-1){delete k[d];break}})}e.$Tl=L;function A(k){k&&(delete k.DEBUG,N.$j&&delete k.DYLD_LIBRARY_PATH,N.$k&&delete k.LD_PRELOAD)}e.$Ul=A}),define(ie[82],ne([0,1,11]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$qq=e.$pq=e.$oq=void 0;function D(a){const v=a;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.$oq=D;function R(a){const v=[];let E;try{const d=JSON.parse(a.arguments),$=d[d.length-1];$&&$.__$stack&&(d.pop(),E=$.__$stack),v.push(...d)}catch{v.push("Unable to log remote console arguments",a.arguments)}return{args:v,stack:E}}e.$pq=R;function L(a){if(typeof a!="string")return L(R(a).stack);const v=a;if(v){const E=A(v),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:N.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$qq=L;function A(a){if(!a)return a;const v=a.indexOf(`
`);return v===-1?a:a.substring(0,v)}function k(a,v){const{args:E,stack:d}=R(a),$=typeof E[0]=="string"&&E.length===1;let w=A(d);w&&(w=`(${w.trim()})`);let P=[];if(typeof E[0]=="string"?w&&$?P=[`%c[${v}] %c${E[0]} %c${w}`,h("blue"),h(""),h("grey")]:P=[`%c[${v}] %c${E[0]}`,h("blue"),h(""),...E.slice(1)]:P=[`%c[${v}]%`,h("blue"),...E],w&&!$&&P.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,P)}e.log=k;function h(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function R(h){return JSON.stringify(h,A)}e.$Ch=R;function L(h){let a=JSON.parse(h);return a=k(a),a}e.$Dh=L;function A(h,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function k(h,a=0){if(!h||a>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof N.$ke||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let v=0;v<h.length;++v)h[v]=k(h[v],a+1);else for(const v in h)Object.hasOwnProperty.call(h,v)&&(h[v]=k(h[v],a+1))}return h}e.$Eh=k}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0;class A{constructor(d,$,w){this.id=d,this.dependencies=$,this.callback=w}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,$,w)=>{typeof d!="string"&&(w=$,$=d,d=null),(typeof $!="object"||!Array.isArray($))&&(w=$,$=null),this.c.push(new A(d,$,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const $=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!$)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(d){return new Promise(($,w)=>{const P=document.createElement("script");P.setAttribute("async","async"),P.setAttribute("type","text/javascript");const b=()=>{P.removeEventListener("load",c),P.removeEventListener("error",p)},c=m=>{b(),$(this.c.pop())},p=m=>{b(),w(m)};P.addEventListener("load",c),P.addEventListener("error",p),this.f&&(d=this.f.createScriptURL(d)),P.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(P)})}i(d){return new Promise(($,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),$(this.c.pop())}catch(P){w(P)}})}async j(d){try{const $=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,P=globalThis._VSCODE_NODE_MODULES.module,b=L.URI.parse(d).fsPath,c=$.readFileSync(b).toString(),p=P.wrap(c.replace(/^#!.*/,""));return new w.Script(p).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const h=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function v(E,d,$){if(N.$T){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const w=`${E}/${d}`;if(h.has(w))return h.get(w);let P;if(/^\w[\w\d+.-]*:\/\//.test(w))P=w;else{const m=`${$&&!R.$o?D.$mg:D.$lg}/${w}`;P=D.$pg.asBrowserUri(m).toString(!0)}const b=k.INSTANCE.load(P);return h.set(w,b),b}else return await new Promise((w,P)=>{J([E],w,P)})}e.$jD=v}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=void 0,e.$an=new class{c(d){return this.a||(this.a=D.$bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,$=0;const w=(0,N.networkInterfaces)();for(const P in w){const b=w[P];if(b)for(const{mac:c,internal:p}of b)p||($+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=$>0?d/$:0}return this.b}};let k;async function h(d){return k||(k=(async()=>await a(d)||R.$rg())()),k}e.$bn=h;async function a(d){try{const $=await new Promise((P,b)=>{J(["crypto"],P,b)}),w=(0,L.$_m)();return $.createHash("sha256").update(w,"utf8").digest("hex")}catch($){d($);return}}const v="Software\\Microsoft\\SQMClient";async function E(d){if(A.$i){const $=await new Promise((w,P)=>{J(["@vscode/windows-registry"],w,P)});try{return $.GetStringRegKey("HKEY_LOCAL_MACHINE",v,"MachineId")||""}catch(w){return d(w),""}}return""}e.$cn=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(h||(h={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:u=!1}={}){return u?a===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function $({useAlternateBitness:u=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:u});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await R.Promises.readdir(r)){let I=-1;if(g){const y=l.indexOf("-");if(y<0)continue;const j=l.substring(0,y);if(!L.test(j)||l.substring(y+1)!=="preview")continue;I=parseInt(j,10)}else{if(!L.test(l))continue;I=parseInt(l,10)}if(I<=t)continue;const O=D.$jc(r,l,"pwsh.exe");await R.SymlinkSupport.existsFile(O)&&(n=O,t=I)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=u?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function P(){const u=D.$jc(N.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function b(){const u=D.$jc(process.env.windir,a===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*c(){let u=await $();u&&(yield u),u=await $({useAlternateBitness:!0}),u&&(yield u),u=await w(),u&&(yield u),u=P(),u&&(yield u),u=await $({findPreview:!0}),u&&(yield u),u=await w({findPreview:!0}),u&&(yield u),u=await $({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=b(),u&&(yield u)}async function*p(){for await(const u of c())await u.exists()&&(yield u)}e.$Rl=p;async function m(){for await(const u of p())return u;return null}e.$Sl=m}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Wl=e.$Vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function h(E=R.env){return E.comspec||"cmd.exe"}e.$Vl=h;function a(E){let d=[],$=!1;const w=function(P){if($){d.push(P);return}(!E.send(P,c=>{if(c&&console.error(c),$=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(m=>w(m))}})||D.$i)&&($=!0)};return{send:w}}e.$Wl=a;var v;(function(E){async function d($,w,P){if(N.$ic($))return $;if(w===void 0&&(w=R.cwd()),N.$mc($)!=="."||(P===void 0&&A.$Jf(R.env.PATH)&&(P=R.env.PATH.split(N.$tc)),P===void 0||P.length===0))return N.$jc(w,$);async function c(p){if(await k.Promises.exists(p)){let m;try{m=await k.Promises.stat(p)}catch(u){u.message.startsWith("EACCES")&&(m=await k.Promises.lstat(p))}return m?!m.isDirectory():!1}return!1}for(const p of P){let m;if(N.$ic(p)?m=N.$jc(p,$):m=N.$jc(w,p,$),await c(m))return m;let u=m+".com";if(await c(u)||(u=m+".exe",await c(u)))return u}return N.$jc(w,$)}E.findExecutable=d})(v||(e.win32=v={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=void 0;async function A(E,d){return E===1?D.$i?v():L.$Vl(d):h(E,d)}e.$Xl=A;let k=null;function h(E,d){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!k){let $;if(D.$i)$="/bin/bash";else{if($=d.SHELL,!$)try{$=(0,N.userInfo)().shell}catch{}$||($="sh"),$==="/bin/false"&&($="/bin/bash")}k=$}return k}let a=null;async function v(){return a||(a=(await(0,R.$Sl)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,N,D){var R=arguments.length,L=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,N):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,N,D);else for(var k=J.length-1;k>=0;k--)(A=J[k])&&(L=(R<3?A(L):R>3?A(e,N,L):A(e,N))||L);return R>3&&L&&Object.defineProperty(e,N,L),L};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,N,D,R,L,A,k,h,a,v,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qh=e.ProxyChannel=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.RequestInitiator=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;var $;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})($||($={}));function w(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var P;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(P||(P={}));function b(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(c||(c={}));function p(M){let U=0;for(let V=0;;V+=7){const X=M.read(1);if(U|=(X.buffer[0]&127)<<V,!(X.buffer[0]&128))return U}}const m=t(0);function u(M,U){if(U===0){M.write(m);return}let V=0;for(let Y=U;Y!==0;Y=Y>>>7)V++;const X=R.$ke.alloc(V);for(let Y=0;U!==0;Y++)X.buffer[Y]=U&127,U=U>>>7,U>0&&(X.buffer[Y]|=128);M.write(X)}class g{constructor(U){this.b=U,this.a=0}read(U){const V=this.b.slice(this.a,this.a+U);return this.a+=V.byteLength,V}}e.$Fh=g;class i{constructor(){this.a=[]}get buffer(){return R.$ke.concat(this.a)}write(U){this.a.push(U)}}e.$Gh=i;var r;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(r||(r={}));function t(M){const U=R.$ke.alloc(1);return U.writeUInt8(M,0),U}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(M,U){if(typeof U>"u")M.write(n.Undefined);else if(typeof U=="string"){const V=R.$ke.fromString(U);M.write(n.String),u(M,V.byteLength),M.write(V)}else if(s&&Buffer.isBuffer(U)){const V=R.$ke.wrap(U);M.write(n.Buffer),u(M,V.byteLength),M.write(V)}else if(U instanceof R.$ke)M.write(n.VSBuffer),u(M,U.byteLength),M.write(U);else if(Array.isArray(U)){M.write(n.Array),u(M,U.length);for(const V of U)o(M,V)}else if(typeof U=="number"&&(U|0)===U)M.write(n.Uint),u(M,U);else{const V=R.$ke.fromString(JSON.stringify(U));M.write(n.Object),u(M,V.byteLength),M.write(V)}}e.$Hh=o;function l(M){switch(M.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return M.read(p(M)).toString();case r.Buffer:return M.read(p(M)).buffer;case r.VSBuffer:return M.read(p(M));case r.Array:{const V=p(M),X=[];for(let Y=0;Y<V;Y++)X.push(l(M));return X}case r.Object:return JSON.parse(M.read(p(M)).toString());case r.Int:return p(M)}}e.$Ih=l;class I{constructor(U,V,X=null,Y=1e3){this.h=U,this.j=V,this.k=X,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Q=>this.q(Q)),this.m({type:200})}registerChannel(U,V){this.b.set(U,V),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const V=this.o([U.type]);this.k?.logOutgoing(V,0,1,b(U.type));return}case 201:case 202:case 204:case 203:{const V=this.o([U.type,U.id],U.data);this.k?.logOutgoing(V,U.id,1,b(U.type),U.data);return}}}o(U,V=void 0){const X=new i;return o(X,U),o(X,V),this.p(X.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const V=new g(U),X=l(V),Y=l(V),Q=X[0];switch(Q){case 100:return this.k?.logIncoming(U.byteLength,X[1],1,`${w(Q)}: ${X[2]}.${X[3]}`,Y),this.s({type:Q,id:X[1],channelName:X[2],name:X[3],arg:Y});case 102:return this.k?.logIncoming(U.byteLength,X[1],1,`${w(Q)}: ${X[2]}.${X[3]}`,Y),this.t({type:Q,id:X[1],channelName:X[2],name:X[3],arg:Y});case 101:return this.k?.logIncoming(U.byteLength,X[1],1,`${w(Q)}`),this.u({type:Q,id:X[1]});case 103:return this.k?.logIncoming(U.byteLength,X[1],1,`${w(Q)}`),this.u({type:Q,id:X[1]})}}s(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const X=new L.$7d;let Y;try{Y=V.call(this.j,U.name,U.arg,X.token)}catch(C){Y=Promise.reject(C)}const Q=U.id;Y.then(C=>{this.m({id:Q,data:C,type:201})},C=>{C instanceof Error?this.m({id:Q,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:Q,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(U.id)});const F=(0,a.$Rc)(()=>X.cancel());this.d.set(U.id,F)}t(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const X=U.id,Q=V.listen(this.j,U.name,U.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(U.id,Q)}u(U){const V=this.d.get(U.id);V&&(V.dispose(),this.d.delete(U.id))}v(U){let V=this.g.get(U.channelName);V||(V=[],this.g.set(U.channelName,V));const X=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:U,timeoutTimer:X})}w(U){const V=this.g.get(U);if(V){for(const X of V)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Jh=I;var O;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class y{constructor(U,V=null){this.l=U,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=V}getChannel(U){const V=this;return{call(X,Y,Q){return V.a?Promise.reject(new k.$5):V.m(U,X,Y,Q)},listen(X,Y){return V.a?h.Event.None:V.o(U,X,Y)}}}m(U,V,X,Y=L.CancellationToken.None){const Q=this.g++,C={id:Q,type:100,channelName:U,name:V,arg:X};if(Y.isCancellationRequested)return Promise.reject(new k.$5);let f;return new Promise((z,T)=>{if(Y.isCancellationRequested)return T(new k.$5);const H=()=>{const fe=me=>{switch(me.type){case 201:this.f.delete(Q),z(me.data);break;case 202:{this.f.delete(Q);const we=new Error(me.data.message);we.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,we.name=me.data.name,T(we);break}case 203:this.f.delete(Q),T(me.data);break}};this.f.set(Q,fe),this.p(C)};let G=null;this.b===c.Idle?H():(G=(0,D.$Ug)(fe=>this.u()),G.then(()=>{G=null,H()}));const ee=()=>{G?(G.cancel(),G=null):this.p({id:Q,type:101}),T(new k.$5)},ue=Y.onCancellationRequested(ee);f=(0,a.$Qc)((0,a.$Rc)(ee),ue),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(U,V,X){const Y=this.g++,F={id:Y,type:102,channelName:U,name:V,arg:X};let C=null;const f=new h.$Wd({onWillAddFirstListener:()=>{C=(0,D.$Ug)(z=>this.u()),C.then(()=>{C=null,this.d.add(f),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(f),this.p({id:Y,type:103}))}}),S=z=>f.fire(z.data);return this.f.set(Y,S),f.event}p(U){switch(U.type){case 100:case 102:{const V=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(V,U.id,0,`${w(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const V=this.q([U.type,U.id]);this.j?.logOutgoing(V,U.id,0,w(U.type));return}}}q(U,V=void 0){const X=new i;return o(X,U),o(X,V),this.r(X.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const V=new g(U),X=l(V),Y=l(V),Q=X[0];switch(Q){case 200:return this.j?.logIncoming(U.byteLength,0,0,b(Q)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,X[1],0,b(Q),Y),this.t({type:X[0],id:X[1],data:Y})}}t(U){if(U.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Kh=y,$e([A.$zh],y.prototype,"onDidInitializePromise",null);class j{get connections(){const U=[];return this.f.forEach(V=>U.push(V)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$Wd,this.onDidAddConnection=this.g.event,this.h=new h.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(U(({protocol:V,onDidClientDisconnect:X})=>{const Y=h.Event.once(V.onMessage);this.j.add(Y(Q=>{const F=new g(Q),C=l(F),f=new I(V,C),S=new y(V);this.a.forEach((T,H)=>f.registerChannel(H,T));const z={channelServer:f,channelClient:S,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(X(()=>{f.dispose(),S.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(U,V){const X=this;return{call(Y,Q,F){let C;if((0,d.$Xf)(V)){const S=(0,N.$4b)(X.connections.filter(V));C=S?Promise.resolve(S):h.Event.toPromise(h.Event.filter(X.onDidAddConnection,V))}else C=V.routeCall(X,Y,Q);const f=C.then(S=>S.channelClient.getChannel(U));return te(f).call(Y,Q,F)},listen(Y,Q){if((0,d.$Xf)(V))return X.k(U,V,Y,Q);const F=V.routeEvent(X,Y,Q).then(C=>C.channelClient.getChannel(U));return te(F).listen(Y,Q)}}}k(U,V,X,Y){const Q=this;let F;const C=new h.$Wd({onWillAddFirstListener:()=>{F=new a.$Sc;const f=new h.$3d,S=new Map,z=H=>{const ee=H.channelClient.getChannel(U).listen(X,Y),ue=f.add(ee);S.set(H,ue)},T=H=>{const G=S.get(H);G&&(G.dispose(),S.delete(H))};Q.connections.filter(V).forEach(z),h.Event.filter(Q.onDidAddConnection,V)(z,void 0,F),Q.onDidRemoveConnection(T,void 0,F),f.event(C.fire,C,F),F.add(f)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(U,V){this.a.set(U,V);for(const X of this.f)X.channelServer.registerChannel(U,V)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Lh=j;class W{constructor(U,V,X=null){const Y=new i;o(Y,V),U.send(Y.buffer),this.a=new y(U,X),this.d=new I(U,V,X)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,V){this.d.registerChannel(U,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Mh=W;function te(M){return{call(U,V,X){return M.then(Y=>Y.call(U,V,X))},listen(U,V){const X=new h.$6d;return M.then(Y=>X.input=Y.listen(U,V)),X.event}}}e.$Nh=te;function _(M){let U=!1;return{call(V,X,Y){return U?M.call(V,X,Y):(0,D.$9g)(0).then(()=>U=!0).then(()=>M.call(V,X,Y))},listen(V,X){if(U)return M.listen(V,X);const Y=new h.$6d;return(0,D.$9g)(0).then(()=>U=!0).then(()=>Y.input=M.listen(V,X)),Y.event}}}e.$Oh=_;class oe{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const V of U.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$Ph=oe;var re;(function(M){function U(Q,F,C){const f=Q,S=C&&C.disableMarshalling,z=new Map;for(const T in f)X(T)&&z.set(T,h.Event.buffer(f[T],!0,void 0,F));return new class{listen(T,H,G){const ee=z.get(H);if(ee)return ee;if(Y(H)){const ue=f[H];if(typeof ue=="function")return ue.call(f,G)}throw new k.$bb(`Event not found: ${H}`)}call(T,H,G){const ee=f[H];if(typeof ee=="function"){if(!S&&Array.isArray(G))for(let fe=0;fe<G.length;fe++)G[fe]=(0,v.$Eh)(G[fe]);let ue=ee.apply(f,G);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new k.$bb(`Method not found: ${H}`)}}}M.fromService=U;function V(Q,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(f,S){if(typeof S=="string")return F?.properties?.has(S)?F.properties.get(S):Y(S)?function(z){return Q.listen(S,z)}:X(S)?Q.listen(S):async function(...z){let T;F&&!(0,d.$Sf)(F.context)?T=[F.context,...z]:T=z;const H=await Q.call(S,T);return C?H:(0,v.$Eh)(H)};throw new k.$bb(`Property not found: ${String(S)}`)}})}M.toService=V;function X(Q){return Q[0]==="o"&&Q[1]==="n"&&E.$_e(Q.charCodeAt(2))}function Y(Q){return/^onDynamic/.test(Q)&&E.$_e(Q.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const U=M.toString();if(U!=="[object Object]")return U}return M}function ae(M){return Array.isArray(M)?M.map(ce):ce(M)}function q(M,U,V,X,Y,Q,F){F=ae(F);const C=he[Y],f=C[X%C.length];let S=[`%c[${M}]%c[${String(U).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(Q)?(S=S.concat(F),S.push(")")):S.push(F),console.log.apply(console,S)}class Z{constructor(U,V){this.d=U,this.f=V,this.a=0,this.b=0}logOutgoing(U,V,X,Y,Q){this.b+=U,q(this.d,this.b,U,V,X,Y,Q)}logIncoming(U,V,X,Y,Q){this.a+=U,q(this.f,this.a,U,V,X,Y,Q)}}e.$Qh=Z}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=void 0;class w extends $.$Jh{constructor(c){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>R.$ke.wrap(Buffer.from(p,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$sq=w;class P{constructor(c,p){this.i=c,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$Wd,this.onDidProcessExit=this.h.event;const m=p&&p.timeout?p.timeout:6e4;this.b=new D.$5g(m),this.d=null,this.f=null}getChannel(c){const p=this;return{call(m,u,g){return p.k(c,m,u,g)},listen(m,u){return p.l(c,m,u)}}}k(c,p,m,u=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const g=this.n(c),i=(0,D.$Ug)(n=>g.call(p,m,n)),r=u.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,p,m){if(!this.b)return h.Event.None;this.b.cancel();let u;const g=new h.$Wd({onWillAddFirstListener:()=>{u=this.n(c).listen(p,m)(g.fire,g),this.c.add(u)},onDidRemoveLastListener:()=>{this.c.delete(u),u.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,v.$yn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,d.$Ul)(p.env),this.d=(0,N.fork)(this.i,c,p);const m=new h.$Wd;h.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$oq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}m.fire(R.$ke.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$Wl)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=m.event,t={send:i,onMessage:r};this.f=new $.$Kh(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(l=>(0,a.$Oc)(l)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(c){let p=this.g.get(c);return p||(p=this.m.getChannel(c),this.g.set(c,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$tq=P}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.StorageState=e.$rp=e.StorageHint=void 0;var k;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function h(d){const $=d;return $?.changed instanceof Map||$?.deleted instanceof Set}e.$rp=h;var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class v extends R.$Tc{static{this.a=100}constructor($,w=Object.create(null)){super(),this.r=$,this.s=w,this.b=this.B(new D.$Zd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new N.$6g(v.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((w,P)=>this.w(P,w)),$.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w($,w){if(this.c===a.Closed)return;let P=!1;(0,A.$Sf)(w)?P=this.f.delete($):this.f.get($)!==w&&(this.f.set($,w),P=!0),P&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,w){const P=this.f.get($);return(0,A.$Sf)(P)?w:P}getBoolean($,w){const P=this.get($);return(0,A.$Sf)(P)?w:P==="true"}getNumber($,w){const P=this.get($);return(0,A.$Sf)(P)?w:parseInt(P,10)}getObject($,w){const P=this.get($);return(0,A.$Sf)(P)?w:(0,L.$Dh)(P)}async set($,w,P=!1){if(this.c===a.Closed)return;if((0,A.$Sf)(w))return this.delete($,P);const b=(0,A.$Lf)(w)||Array.isArray(w)?(0,L.$Ch)(w):String(w);if(this.f.get($)!==b)return this.f.set($,b),this.j.set($,b),this.h.delete($),this.b.fire({key:$,external:P}),this.D()}async delete($,w=!1){if(!(this.c===a.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(this.z)return this.D($)}async D($){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$sp=v;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((w,P)=>this.a.set(P,w)),$.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$tp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=e.zip=e.$Op=e.$Np=void 0,e.$Np="end of central directory record signature not found";const h=new RegExp(e.$Np);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$Op=a;function v(u){const g=u.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(u){if(u instanceof a)return u;let g;return h.test(u.message)&&(g="CorruptZip"),new a(g,u)}function d(u,g,i,r,t,n){const s=R.$mc(g),o=R.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(k.localize(0,null,g)));const l=R.$jc(r,g);let I;return n.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((O,y)=>{if(!n.isCancellationRequested)try{I=(0,N.createWriteStream)(l,{mode:i}),I.once("close",()=>O()),I.once("error",y),u.once("error",y),u.pipe(I)}catch(j){y(j)}}))}function $(u,g,i,r){let t=(0,D.$Ug)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),u.close()});return new Promise((o,l)=>{const I=new D.$3g,O=y=>{y.isCancellationRequested||(n++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{r.isCancellationRequested||u.entryCount===n?o():l(new a("Incomplete",new Error(k.localize(1,null,n,u.entryCount))))},l)),u.readEntry(),u.on("entry",y=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(y.fileName)){O(r);return}const j=y.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const _=R.$jc(g,j);t=(0,D.$Ug)(oe=>A.Promises.mkdir(_,{recursive:!0}).then(()=>O(oe)).then(void 0,l));return}const W=P(u,y),te=v(y);t=(0,D.$Ug)(_=>I.queue(()=>W.then(oe=>d(oe,j,te,g,i,_).then(()=>O(_)))).then(null,l))})}).finally(()=>s.dispose())}async function w(u,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(u,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,L.$Uf)(s))})})}function P(u,g){return new Promise((i,r)=>{u.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,L.$Uf)(n))})})}async function b(u,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,N.createWriteStream)(u);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(u))})}e.zip=b;function c(u,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(u,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>$(s,g,{sourcePathRegex:t},r))}e.$Qp=c;function p(u,g){return w(u).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&P(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(k.localize(2,null,g))))}))}function m(u,g){return p(u,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$Rp=m}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),k=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,N.$8)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const E=this.d,d=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:v}),this.f.push($)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const E=this.c.substring(this.d,this.e),d=h.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,E=!1,d=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(k);return}const w=this.c.charCodeAt(v);if(E)E=!1;else if(w===47&&!d){v++;break}else w===91?d=!0:w===92?E=!0:w===93&&(d=!1);v++}for(;v<this.c.length&&h.a.has(this.c.charCodeAt(v));)v++;this.e=v;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=h}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0,e.$Am=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(R.$pg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.$Ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$Ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,N.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",$)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$Ig)(h.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$Ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$Ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$Ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=A.env.VSCODE_PORTABLE;return $?h.URI.file((0,L.$jc)($,"argv.json")):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,L.$kc)($):(0,L.$hc)((0,L.$jc)(R.$pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?h.URI.file((0,L.$kc)($)):h.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,L.$kc)($);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const P=A.env.VSCODE_PORTABLE;return P?(0,L.$jc)(P,"extensions"):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(w=>/^[^:/?#]+?:\/\//.test(w)?h.URI.parse(w):h.URI.file((0,L.$hc)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?h.URI.parse($):h.URI.file((0,L.$hc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$Am.test($))}get extensionLogLevel(){const $=[];for(const w of this.args.log||[]){const P=e.$Am.exec(w);P&&P[1]&&P[2]&&$.push([P[1],P[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,k.$Ig)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=A.env.VSCODE_PORTABLE;return $?h.URI.file((0,L.$jc)($,"policy.json")):(0,k.$Ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,w,P){this.a=$,this.b=w,this.c=P,this.editSessionId=this.args.editSessionId}}e.$Bm=a,$e([D.$zh],a.prototype,"appRoot",null),$e([D.$zh],a.prototype,"userHome",null),$e([D.$zh],a.prototype,"userDataPath",null),$e([D.$zh],a.prototype,"appSettingsHome",null),$e([D.$zh],a.prototype,"tmpDir",null),$e([D.$zh],a.prototype,"cacheHome",null),$e([D.$zh],a.prototype,"stateResource",null),$e([D.$zh],a.prototype,"userRoamingDataHome",null),$e([D.$zh],a.prototype,"userDataSyncHome",null),$e([D.$zh],a.prototype,"sync",null),$e([D.$zh],a.prototype,"machineSettingsResource",null),$e([D.$zh],a.prototype,"workspaceStorageHome",null),$e([D.$zh],a.prototype,"localHistoryHome",null),$e([D.$zh],a.prototype,"keyboardLayoutResource",null),$e([D.$zh],a.prototype,"argvResource",null),$e([D.$zh],a.prototype,"isExtensionDevelopment",null),$e([D.$zh],a.prototype,"untitledWorkspacesHome",null),$e([D.$zh],a.prototype,"builtinExtensionsPath",null),$e([D.$zh],a.prototype,"extensionsPath",null),$e([D.$zh],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$zh],a.prototype,"extensionDevelopmentKind",null),$e([D.$zh],a.prototype,"extensionTestsLocationURI",null),$e([D.$zh],a.prototype,"debugExtensionHost",null),$e([D.$zh],a.prototype,"logLevel",null),$e([D.$zh],a.prototype,"extensionLogLevel",null),$e([D.$zh],a.prototype,"serviceMachineIdResource",null),$e([D.$zh],a.prototype,"disableTelemetry",null),$e([D.$zh],a.prototype,"disableWorkspaceTrust",null),$e([D.$zh],a.prototype,"useInMemorySecretStorage",null),$e([D.$zh],a.prototype,"policyFile",null);function v(d,$){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,$,d.debugId,d.extensionEnvironment)}e.$Cm=v;function E(d,$,w,P,b,c){const m=Number($||d)||(P?null:w),u=m?!!$:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:m,break:u,debugId:b,env:g}}e.$Dm=E}),function(){"use strict";function J(e,N,D){function R(A,k){const h=L(A,k),a=[h];return e.isAbsolute(h)||a.unshift(D),e.resolve(...a)}function L(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,k);const v=A["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(N.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(N.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,k)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,N,D){return J(e,N,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),N=require("os");module.exports=J(e,N,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;class L extends D.$Bm{constructor(a,v){super(a,{homeDir:(0,N.homedir)(),tmpDir:(0,N.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,v.nameShort)},v)}}e.$Em=L;function A(h,a){return(0,D.$Dm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,a,h.extensionEnvironment)}e.$Fm=A;function k(h,a){return(0,D.$Dm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,a,h.extensionEnvironment)}e.$Gm=k}),define(ie[115],ne([0,1,3,97]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;function R(A,k,h,a){try{L(A,k,h,a)}catch(v){A.error(v?.message??v)}return k}e.$1p=R;function L(A,k,h,a){const v=(E,d,$)=>{const w=E[d];if((0,N.$Jf)(w)){const P=w,b=P.length;if(b>1&&P[0]==="%"&&P[b-1]==="%"){const c=P.substr(1,b-2);let p=h[c];p===void 0&&a&&(p=a[c]);const m=typeof p=="string"?p:p?.message,u=a?.[c],g=typeof u=="string"?u:u?.message;if(!m){g||A.warn(`[${k.name}]: ${(0,D.localize)(0,null,c)}`);return}if($&&(d==="title"||d==="category")&&g&&g!==m){const i={value:m,original:g};E[d]=i}else E[d]=m}}else if((0,N.$Lf)(w))for(const P in w)w.hasOwnProperty(P)&&(P==="commands"?v(w,P,!0):v(w,P,$));else if(Array.isArray(w))for(let P=0;P<w.length;P++)v(w,P,$)};for(const E in k)k.hasOwnProperty(E)&&v(k,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;function R(L){return(0,N.$Rp)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$9p=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||A.test(c)}e.$cp=h;function a(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=c.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$dp=a;function v(c){if(!c)return null;const p=c.majorBase,m=c.majorMustEqual,u=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(p===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=k.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:p,majorMustEqual:m,minorBase:u,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}e.$ep=v;function E(c,p,m){let u;typeof c=="string"?u=v(a(c)):u=c;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof m=="string"?i=v(a(m)):i=m,!u||!i)return!1;const r=u.majorBase,t=u.minorBase,n=u.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const I=i.notBefore;let O=i.majorMustEqual,y=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<I?!1:n>=l:(r===1&&s===0&&(!O||!y||!j)&&(s=1,o=0,l=0,O=!0,y=!1,j=!1),r<s?!1:r>s?!O:t<o?!1:t>o?!y:n<l?!1:n>l?!j:!(g&&g<I))}e.$fp=E;function d(c,p,m,u,g){const i=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return i.push([D.default.Error,R.localize(0,null)]),i;if(typeof u.name!="string")return i.push([D.default.Error,R.localize(1,null,"name")]),i;if(typeof u.version!="string")return i.push([D.default.Error,R.localize(2,null,"version")]),i;if(!u.engines)return i.push([D.default.Error,R.localize(3,null,"engines")]),i;if(typeof u.engines.vscode!="string")return i.push([D.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof u.extensionDependencies<"u"&&!b(u.extensionDependencies))return i.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof u.activationEvents<"u"){if(!b(u.activationEvents))return i.push([D.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof u.main>"u"&&typeof u.browser>"u")return i.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&i.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return i.push([D.default.Error,R.localize(9,null,"main")]),i;{const n=(0,N.$Ig)(m,u.main);(0,N.$Cg)(n,m)||i.push([D.default.Warning,R.localize(10,null,n.path,m.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return i.push([D.default.Error,R.localize(11,null,"browser")]),i;{const n=(0,N.$Ig)(m,u.browser);(0,N.$Cg)(n,m)||i.push([D.default.Warning,R.localize(12,null,n.path,m.path)])}}if(!L.valid(u.version))return i.push([D.default.Error,R.localize(13,null)]),i;const r=[];if(!$(c,p,u,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$gp=d;function $(c,p,m,u,g){return u||typeof m.main>"u"&&typeof m.browser>"u"?!0:P(c,p,m.engines.vscode,g)}e.$hp=$;function w(c,p,m){return c==="*"||P(p,m,c)}e.$ip=w;function P(c,p,m,u=[]){const g=v(a(m));if(!g)return u.push(R.localize(14,null,m)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return u.push(R.localize(15,null,m)),!1}else if(!g.majorMustEqual)return u.push(R.localize(16,null,m)),!1;return E(c,p,g)?!0:(u.push(R.localize(17,null,c,m)),!1)}function b(c){if(!Array.isArray(c))return!1;for(let p=0,m=c.length;p<m;p++)if(typeof c[p]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function R(L,A,k){let h=k&&k.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const v=(await A.readFile(L.serviceMachineIdResource)).value.toString();h=(0,D.$qg)(v)?v:null}catch{h=null}if(!h){h=(0,D.$rg)();try{await A.writeFile(L.serviceMachineIdResource,N.$ke.fromString(h))}catch{}}return k?.store("storage.serviceMachineId",h,-1,1),h}e.$Cp=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class N{constructor(R,L=[],A=!1){this.ctor=R,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$5h=N}),define(ie[118],ne([0,1,51]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const D=[];var R;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function L(k,h,a){h instanceof N.$5h||(h=new N.$5h(h,[],!!a)),D.push([k,h])}e.$1r=L;function A(){return D}e.$2r=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class N{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=N;class D{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const k=this.lookupOrInsertNode(L),h=this.lookupOrInsertNode(A);k.outgoing.set(h.key,h),h.incoming.set(k.key,k)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let k=this.a.get(A);return k||(k=new N(A,L),this.a.set(A,k)),k}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,k]of this.a)L.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const k=new Set([L]),h=this.c(A,k);if(h)return h}}c(L,A){for(const[k,h]of L.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const a=this.c(h,A);if(a)return a;A.delete(k)}}}e.$Fq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,R.$8h)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}e.$Ci=L;function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}e.$Di=A;var k;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=h;function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$Fi=a;function v(c,p){const m=Object.create(null);for(const u in c)E(m,u,c[u],p);return m}e.$Gi=v;function E(c,p,m,u){const g=p.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=m}catch{u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}else u(`Ignoring ${p} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Hi=E;function d(c,p){const m=p.split(".");$(c,m)}e.$Ii=d;function $(c,p){const m=p.shift();if(p.length===0){delete c[m];return}if(Object.keys(c).indexOf(m)!==-1){const u=c[m];typeof u=="object"&&!Array.isArray(u)&&($(u,p),Object.keys(u).length===0&&delete c[m])}}function w(c,p,m){function u(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=p.split("."),i=u(c,g);return typeof i>"u"?m:i}e.$Ji=w;function P(c,p,m){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in c?N.$Lf(c[u])&&N.$Lf(p[u])?P(c[u],p[u],m):m&&(c[u]=p[u]):c[u]=p[u])})}e.$Ki=P;function b(c){return c.replace(/[\[\]]/g,"")}e.$Li=b}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",N.$j),h.set("isLinux",N.$k),h.set("isWindows",N.$i),h.set("isWeb",N.$o),h.set("isMacNative",N.$j&&!N.$o),h.set("isEdge",N.$H),h.set("isFirefox",N.$F),h.set("isChrome",N.$E),h.set("isSafari",N.$G);function a(C,f){if(h.get(C)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(C,f)}e.$4i=a;const v=Object.prototype.hasOwnProperty;var E;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},$=(0,A.localize)(0,null),w=(0,A.localize)(1,null),P=(0,A.localize)(2,null),b=(0,A.localize)(3,null),c=(0,A.localize)(4,null),p=(0,A.localize)(5,null),m=(0,A.localize)(6,null),u=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new R.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const S=this.l();if(!this.E()){const z=this.D(),T=z.type===17?p:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:R.$3i.getLexeme(z),additionalInfo:T}),g.c}return S}catch(S){if(S!==g.c)throw S;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const S=this.o();f.push(S)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const S=this.s();f.push(S)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const S=this.l();return this.A(1,b),S?.negate()}case 17:return this.z(),W.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const S=this.l();return this.A(1,b),S}case 17:{const S=f.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const H=T.lexeme,G=H.lastIndexOf("/"),ee=G===H.length-1?void 0:this.w(H.substring(G+1));let ue;try{ue=new RegExp(H.substring(1,G),ee)}catch{throw this.B("REGEX",T)}return ce.create(S,ue)}switch(T.type){case 10:case 19:{const H=[T.lexeme];this.z();let G=this.D(),ee=0;for(let de=0;de<T.lexeme.length;de++)T.lexeme.charCodeAt(de)===40?ee++:T.lexeme.charCodeAt(de)===41&&ee--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?ee++:T.lexeme.charCodeAt(de)===41&&ee--}if(ee<0)break;H.push(R.$3i.getLexeme(G)),this.z(),G=this.D()}const ue=H.join(""),fe=ue.lastIndexOf("/"),me=fe===ue.length-1?void 0:this.w(ue.substring(fe+1));let we;try{we=new RegExp(ue.substring(1,fe),me)}catch{throw this.B("REGEX",T)}return i.regex(S,we)}case 18:{const H=T.lexeme;this.z();let G=null;if(!(0,D.$Ke)(H)){const ee=H.indexOf("/"),ue=H.lastIndexOf("/");if(ee!==ue&&ee>=0){const fe=H.slice(ee+1,ue),me=H[ue+1]==="i"?"i":"";try{G=new RegExp(fe,me)}catch{throw this.B("REGEX",T)}}}if(G===null)throw this.B("REGEX",T);return ce.create(S,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,P);const T=this.u();return i.notIn(S,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return i.equals(S,T);switch(T){case"true":return i.has(S);case"false":return i.not(S);default:return i.equals(S,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return i.notEquals(S,T);switch(T){case"true":return i.not(S);case"false":return i.has(S);default:return i.notEquals(S,T)}}case 5:return this.z(),re.create(S,this.u());case 6:return this.z(),he.create(S,this.u());case 7:return this.z(),_.create(S,this.u());case 8:return this.z(),oe.create(S,this.u());case 13:return this.z(),i.in(S,this.u());default:return i.has(S)}}case 20:throw this.h.push({message:m,offset:f.offset,lexeme:"",additionalInfo:u}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,S){if(this.C(f))return this.z();throw this.B(S,this.D())}B(f,S,z){const T=(0,A.localize)(8,null,f,R.$3i.getLexeme(S)),H=S.offset,G=R.$3i.getLexeme(S);return this.h.push({message:T,offset:H,lexeme:G,additionalInfo:z}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,S){return I.create(f,S)}static notEquals(f,S){return j.create(f,S)}static regex(f,S){return ce.create(f,S)}static in(f,S){return O.create(f,S)}static notIn(f,S){return y.create(f,S)}static not(f){return W.create(f)}static and(...f){return Z.create(f,null,!0)}static or(...f){return M.create(f,null,!0)}static greater(f,S){return _.create(f,S)}static greaterEquals(f,S){return oe.create(f,S)}static smaller(f,S){return re.create(f,S)}static smallerEquals(f,S){return he.create(f,S)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$6i=i;function r(C){const f=new g({regexParsingWithErrorRecovery:!1});return C.map(S=>(f.parse(S),f.lexingErrors.length>0?f.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$7i=r;function t(C,f){const S=C?C.substituteConstants():void 0,z=f?f.substituteConstants():void 0;return!S&&!z?!0:!S||!z?!1:S.equals(z)}e.$8i=t;function n(C,f){return C.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$9i=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$0i=o;class l{static create(f,S=null){const z=h.get(f);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new l(f,S)}constructor(f,S){this.key=f,this.c=S,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:V(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=h.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.$$i=l;class I{static create(f,S,z=null){if(typeof S=="boolean")return S?l.create(f,z):W.create(f,z);const T=h.get(f);return typeof T=="boolean"?S===(T?"true":"false")?o.INSTANCE:s.INSTANCE:new I(f,S,z)}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$_i=I;class O{static create(f,S){return new O(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:X(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.f),z=f.getValue(this.d);return Array.isArray(S)?S.includes(z):typeof z=="string"&&typeof S=="object"&&S!==null?v.call(S,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$aj=O;class y{static create(f,S){return new y(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=11,this.c=O.create(f,S)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=y;class j{static create(f,S,z=null){if(typeof S=="boolean")return S?W.create(f,z):l.create(f,z);const T=h.get(f);return typeof T=="boolean"?S===(T?"true":"false")?s.INSTANCE:o.INSTANCE:new j(f,S,z)}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const S=f?"true":"false";return this.d===S?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$cj=j;class W{static create(f,S=null){const z=h.get(f);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new W(f,S)}constructor(f,S){this.c=f,this.d=S,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:V(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=h.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$dj=W;function te(C,f){if(typeof C=="string"){const S=parseFloat(C);isNaN(S)||(C=S)}return typeof C=="string"||typeof C=="number"?f(C):s.INSTANCE}class _{static create(f,S,z=null){return te(S,T=>new _(f,T,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$ej=_;class oe{static create(f,S,z=null){return te(S,T=>new oe(f,T,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$fj=oe;class re{static create(f,S,z=null){return te(S,T=>new re(f,T,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$gj=re;class he{static create(f,S,z=null){return te(S,T=>new he(f,T,z))}constructor(f,S,z){this.c=f,this.d=S,this.f=z,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:X(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$hj=he;class ce{static create(f,S){return new ce(f,S)}constructor(f,S){this.d=f,this.f=S,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const S=this.f?this.f.source:"",z=f.f?f.f.source:"";return S<z?-1:S>z?1:0}equals(f){if(f.type===this.type){const S=this.f?this.f.source:"",z=f.f?f.f.source:"";return this.d===f.d&&S===z}return!1}substituteConstants(){return this}evaluate(f){const S=f.getValue(this.d);return this.f?this.f.test(S):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$ij=ce;class ae{static create(f){return new ae(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ae(this.c.map(f))}negate(){return this.c}}e.$jj=ae;function q(C){let f=null;for(let S=0,z=C.length;S<z;S++){const T=C[S].substituteConstants();if(C[S]!==T&&f===null){f=[];for(let H=0;H<S;H++)f[H]=C[H]}f!==null&&(f[S]=T)}return f===null?C:f}class Z{static create(f,S,z){return Z.d(f,S,z)}constructor(f,S){this.expr=f,this.c=S,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const T=n(this.expr[S],f.expr[S]);if(T!==0)return T}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=q(this.expr);return f===this.expr?this:Z.create(f,this.c,!1)}evaluate(f){for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].evaluate(f))return!1;return!0}static d(f,S,z){const T=[];let H=!1;for(const G of f)if(G){if(G.type===1){H=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){T.push(...G.expr);continue}T.push(G)}if(T.length===0&&H)return o.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(n);for(let G=1;G<T.length;G++)T[G-1].equals(T[G])&&(T.splice(G,1),G--);if(T.length===1)return T[0];for(;T.length>1;){const G=T[T.length-1];if(G.type!==9)break;T.pop();const ee=T.pop(),ue=T.length===0,fe=M.create(G.expr.map(me=>Z.create([me,ee],null,z)),null,ue);fe&&(T.push(fe),T.sort(n))}if(T.length===1)return T[0];if(z){for(let G=0;G<T.length;G++)for(let ee=G+1;ee<T.length;ee++)if(T[G].negate().equals(T[ee]))return s.INSTANCE;if(T.length===1)return T[0]}return new Z(T,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new Z(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());this.c=M.create(f,this,!0)}return this.c}}e.$kj=Z;class M{static create(f,S,z){return M.d(f,S,z)}constructor(f,S){this.expr=f,this.c=S,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let S=0,z=this.expr.length;S<z;S++){const T=n(this.expr[S],f.expr[S]);if(T!==0)return T}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let S=0,z=this.expr.length;S<z;S++)if(!this.expr[S].equals(f.expr[S]))return!1;return!0}return!1}substituteConstants(){const f=q(this.expr);return f===this.expr?this:M.create(f,this.c,!1)}evaluate(f){for(let S=0,z=this.expr.length;S<z;S++)if(this.expr[S].evaluate(f))return!0;return!1}static d(f,S,z){let T=[],H=!1;if(f){for(let G=0,ee=f.length;G<ee;G++){const ue=f[G];if(ue){if(ue.type===0){H=!0;continue}if(ue.type===1)return o.INSTANCE;if(ue.type===9){T=T.concat(ue.expr);continue}T.push(ue)}}if(T.length===0&&H)return s.INSTANCE;T.sort(n)}if(T.length!==0){if(T.length===1)return T[0];for(let G=1;G<T.length;G++)T[G-1].equals(T[G])&&(T.splice(G,1),G--);if(T.length===1)return T[0];if(z){for(let G=0;G<T.length;G++)for(let ee=G+1;ee<T.length;ee++)if(T[G].negate().equals(T[ee]))return o.INSTANCE;if(T.length===1)return T[0]}return new M(T,S)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const S of this.expr)f.push(...S.keys());return f}map(f){return new M(this.expr.map(S=>S.map(f)),null)}negate(){if(!this.c){const f=[];for(const S of this.expr)f.push(S.negate());for(;f.length>1;){const S=f.shift(),z=f.shift(),T=[];for(const H of F(S))for(const G of F(z))T.push(Z.create([H,G],null,!1));f.unshift(M.create(T,null,!1))}this.c=M.create(f,this,!0)}return this.c}}e.$lj=M;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(f,S,z){super(f,null),this.f=S,typeof z=="object"?U.d.push({...z,key:f}):z!==!0&&U.d.push({key:f,description:z,type:S!=null?typeof S:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return I.create(this.key,f)}notEqualsTo(f){return j.create(this.key,f)}}e.$mj=U,e.$nj=(0,L.$8h)("contextKeyService");function V(C,f){return C<f?-1:C>f?1:0}function X(C,f,S,z){return C<S?-1:C>S?1:f<z?-1:f>z?1:0}function Y(C,f){if(C.type===0||f.type===1)return!0;if(C.type===9)return f.type===9?Q(C.expr,f.expr):!1;if(f.type===9){for(const S of f.expr)if(Y(C,S))return!0;return!1}if(C.type===6){if(f.type===6)return Q(f.expr,C.expr);for(const S of C.expr)if(Y(S,f))return!0;return!1}return C.equals(f)}e.$oj=Y;function Q(C,f){let S=0,z=0;for(;S<C.length&&z<f.length;){const T=C[S].cmp(f[z]);if(T<0)return!1;T===0&&S++,z++}return S===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(ie[59],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go=(0,N.$8h)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,N.$8h)("environmentService"),e.$di=(0,N.$9h)(e.$ci)}),define(ie[21],ne([0,1,95,10]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function R(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=R;function L(m){switch(m){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=L;function A(m,u){switch(m){case 3:return u==="x64"?"win32-x64":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=A;function k(m,u){return u==="web"&&!m.includes("web")}e.$yo=k;function h(m,u,g){return k(u,g)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===g}e.$zo=h;function a(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.$Ao=a;var v;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var E;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var d;(function(m){m.Install="install",m.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var $;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Bo=(0,D.$8h)("extensionGalleryService");var w;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.DownloadSignature="DownloadSignature",m.UpdateMetadata="UpdateMetadata",m.Extract="Extract",m.Scanning="Scanning",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Signature="Signature",m.NotAllowed="NotAllowed",m.Gallery="Gallery",m.Unknown="Unknown",m.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var P;(function(m){m.UnknownError="UnknownError",m.PackageIsInvalidZip="PackageIsInvalidZip",m.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(P||(e.ExtensionSignaturetErrorCode=P={}));class b extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Co=b;var c;(function(m){m.Timeout="Timeout",m.Cancelled="Cancelled",m.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class p extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}e.$Do=p,e.$Eo=(0,D.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,D.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,D.$8h)("IExtensionTipsService"),e.$Jo=(0,N.localize2)(0,"Extensions"),e.$Ko=(0,N.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;async function A(v,E,d,$,w,P){let b;try{await k(v,E,d,$,w,P)}catch(c){b=c}finally{b&&w.errorTransformer&&(b=w.errorTransformer(b)),typeof b<"u"&&d.error(b),d.end()}}e.$dq=A;async function k(v,E,d,$,w,P){h(P);const b=await v.open(E,{create:!1});try{h(P);let c=0,p=0,m=w&&typeof w.length=="number"?w.length:void 0,u=N.$ke.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do p=await v.read(b,g,u.buffer,i,u.byteLength-i),g+=p,i+=p,c+=p,typeof m=="number"&&(m-=p),i===u.byteLength&&(await d.write($(u)),u=N.$ke.alloc(Math.min(w.bufferSize,typeof m=="number"?m:w.bufferSize)),i=0);while(p>0&&(typeof m!="number"||m>0)&&h(P)&&a(c,w));if(i>0){let r=i;typeof m=="number"&&(r=Math.min(i,m)),d.write($(u.slice(0,r)))}}catch(c){throw(0,L.$Gk)(c)}finally{await v.close(b)}}function h(v){if(v.isCancellationRequested)throw(0,D.$6)();return!0}function a(v,E){if(typeof E?.limits?.size=="number"&&v>E.limits.size)throw(0,L.$Fk)((0,R.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class k extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$Wd),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$Wd),this.onDidLogMessage=this.b.event,this.onDidError=N.Event.None,this.c=new Map,this.f=!1}async watch(a){const v=this.j(a),E=v.filter($=>{const w=this.c.get($.path);return w?!(0,D.$Sj)(w.request.excludes,$.excludes)||!(0,D.$Sj)(w.request.includes,$.includes):!0}),d=Array.from(this.c.values()).filter(({request:$})=>!v.find(w=>w.path===$.path&&(0,D.$Sj)(w.excludes,$.excludes)&&(0,D.$Sj)(w.includes,$.includes))).map(({request:$})=>$.path);E.length&&this.m(`Request to start watching: ${E.map($=>`${$.path} (excludes: ${$.excludes.length>0?$.excludes:"<none>"}, includes: ${$.includes&&$.includes.length>0?JSON.stringify($.includes):"<all>"}, correlationId: ${typeof $.correlationId=="number"?$.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const $ of d)this.h($);for(const $ of E)this.g($)}g(a){const v=new A.$zq(a,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:a,instance:v};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const v=this.c.get(a);v&&(this.c.delete(a),v.instance.dispose())}j(a){const v=new Map;for(const E of a){const d=L.$k?E.path:E.path.toLowerCase();let $=v.get(E.correlationId);$||($=new Map,v.set(E.correlationId,$)),$.set(d,E)}return Array.from(v.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,v]of this.c)v.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,v){return v?`[File Watcher (node.js)] ${a} (path: ${v.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$Bq=k}),define(ie[122],ne([0,1,61,121]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class R extends N.$hq{constructor(A,k,h){super(A,k,h),this.s()}r(A){return A.add(new D.$Bq)}}e.$Cq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class A extends L.$iq{constructor(h,a,v){super(h,a,v),this.s()}r(h){const a=h.add(new R.$tq(N.$pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(a.onDidProcessExit(({code:v,signal:E})=>this.t(`terminated by itself with code ${v}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Oh)(a.getChannel("watcher")))}}e.$uq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class N{constructor(...R){this.a=new Map;for(const[L,A]of R)this.set(L,A)}set(R,L){const A=this.a.get(R);return this.a.set(R,L),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$6h=N}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const v=!1;class E extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class d{constructor(b=new h.$6h,c=!1,p,m=v){this.f=b,this.g=c,this.h=p,this.i=m,this.o=new Set,this.f.set(k.$7h,this),this._globalGraph=m?p?._globalGraph??new A.$Fq(u=>u):void 0}createChild(b){return new d(b,this.g,this,this.i)}invokeFunction(b,...c){const p=w.traceInvocation(this.i,b);let m=!1;try{return b({get:g=>{if(m)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{m=!0,p.stop()}}createInstance(b,...c){let p,m;return b instanceof L.$5h?(p=w.traceCreation(this.i,b.ctor),m=this.j(b.ctor,b.staticArguments.concat(c),p)):(p=w.traceCreation(this.i,b),m=this.j(b,c,p)),p.stop(),m}j(b,c=[],p){const m=k._util.getServiceDependencies(b).sort((i,r)=>i.index-r.index),u=[];for(const i of m){const r=this.m(i.id,p);r||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${i.id}.`,!1),u.push(r)}const g=m.length>0?m[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${b.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(b,c.concat(u))}k(b,c){if(this.f.get(b)instanceof L.$5h)this.f.set(b,c);else if(this.h)this.h.k(b,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const c=this.f.get(b);return!c&&this.h?this.h.l(b):c}m(b,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const p=this.l(b);return p instanceof L.$5h?this.q(b,p,c.branch(b,!0)):(c.branch(b,!1),p)}q(b,c,p){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,c,p)}finally{this.o.delete(b)}}r(b,c,p){const m=new A.$Fq(i=>i.id.toString());let u=0;const g=[{id:b,desc:c,_trace:p}];for(;g.length;){const i=g.pop();if(m.lookupOrInsertNode(i),u++>1e3)throw new E(m);for(const r of k._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${b} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof L.$5h){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};m.insertEdge(i,n),g.push(n)}}}for(;;){const i=m.roots();if(i.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:r}of i){if(this.l(r.id)instanceof L.$5h){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}m.removeNode(r)}}return this.l(b)}s(b,c,p=[],m,u){if(this.f.get(b)instanceof L.$5h)return this.t(b,c,p,m,u);if(this.h)return this.h.s(b,c,p,m,u);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(b,c,p=[],m,u){if(m){const g=new d(void 0,this.g,this,this.i);g.c=String(b);const i=new Map,r=new N.$oh(()=>{const t=g.j(c,p,u);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$4c,i.set(n,l)),(O,y,j)=>{if(r.isInitialized)return r.value[n](O,y,j);{const W={listener:[O,y,j],disposable:void 0},te=l.push(W);return(0,R.$Rc)(()=>{te(),W.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,p,u)}u(b,c){if(c&&console.warn(b),this.g)throw new Error(b)}}e.$Gq=d;var $;(function(P){P[P.None=0]="None",P[P.Creation=1]="Creation",P[P.Invocation=2]="Invocation",P[P.Branch=3]="Branch"})($||($={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,c){return b?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(b,c){return b?new w(1,c.name):w.c}static{this.f=0}constructor(b,c){this.type=b,this.name=c,this.g=Date.now(),this.h=[]}branch(b,c){const p=new w(3,b.toString());return this.h.push([b,c,p]),p}stop(){const b=Date.now()-this.g;w.f+=b;let c=!1;function p(u,g){const i=[],r=new Array(u+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=p(u+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(b>2||c)&&w.all.add(m.join(`
`))}}e.$Hq=w});var se=this&&this.__param||function(J,e){return function(N,D){e(N,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,N,D,R,L,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function h(v){return v.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$ir=h,e.$jr=(0,k.$8h)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new N.$7d;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const w=d.firstPage.filter(P=>P.properties.localizedLanguages?.length&&P.tags.some(b=>b.startsWith("lp-"))).map(P=>{const b=P.properties.localizedLanguages?.[0],c=h(P);return{...this.f(c,b,P),extensionId:P.identifier.id,galleryExtension:P}});return w.push(this.f("en","English")),w}f(E,d,$){const w=d??E;let P;if(w!==E&&(P=`(${E})`),E.toLowerCase()===R.$w.toLowerCase()&&(P??="",P+=(0,L.localize)(0,null)),$?.installCount){P??="";const b=$.installCount;let c;b>1e6?c=`${Math.floor(b/1e5)/10}M`:b>1e3?c=`${Math.floor(b/1e3)}K`:c=String(b),P+=` $(cloud-download) ${c}`}return{id:E,label:w,description:P}}};e.$kr=a,e.$kr=a=$e([se(0,A.$Bo)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,N,D,R,L,A,k,h,a,v,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,d.$8h)("logService"),e.$qj=(0,d.$8h)("loggerService");function $(){return new Date().toISOString()}function w(O){return(0,a.$Nf)(O)}e.$rj=w;var P;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(P||(e.LogLevel=P={})),e.$sj=P.Info;function b(O,y,j){switch(y){case P.Trace:O.trace(j);break;case P.Debug:O.debug(j);break;case P.Info:O.info(j);break;case P.Warning:O.warn(j);break;case P.Error:O.error(j);break;case P.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=b;function c(O,y=!1){let j="";for(let W=0;W<O.length;W++){let te=O[W];if(te instanceof Error&&(te=(0,N.$Si)(te,y)),typeof te=="object")try{te=JSON.stringify(te)}catch{}j+=(W>0?" ":"")+te}return j}class p extends L.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new D.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==P.Off&&this.b<=y}}e.$uj=p;class m extends p{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...j){this.f(P.Trace)&&this.g(P.Trace,c([y,...j],!0))}debug(y,...j){this.f(P.Debug)&&this.g(P.Debug,c([y,...j]))}info(y,...j){this.f(P.Info)&&this.g(P.Info,c([y,...j]))}warn(y,...j){this.f(P.Warning)&&this.g(P.Warning,c([y,...j]))}error(y,...j){if(this.f(P.Error))if(y instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=y.stack,this.g(P.Error,c(W))}else this.g(P.Error,c([y,...j]))}flush(){}}e.$vj=m;class u extends p{constructor(y=e.$sj){super(),this.setLevel(y),this.g=!k.$i}trace(y,...j){this.f(P.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...j):console.log(`[main ${$()}]`,y,...j))}debug(y,...j){this.f(P.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...j):console.log(`[main ${$()}]`,y,...j))}info(y,...j){this.f(P.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...j):console.log(`[main ${$()}]`,y,...j))}warn(y,...j){this.f(P.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,y,...j):console.warn(`[main ${$()}]`,y,...j))}error(y,...j){this.f(P.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,y,...j):console.error(`[main ${$()}]`,y,...j))}flush(){}}e.$wj=u;class g extends p{constructor(y=e.$sj,j=!0){super(),this.g=j,this.setLevel(y)}trace(y,...j){this.f(P.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...j):console.log(y,...j))}debug(y,...j){this.f(P.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...j):console.log(y,...j))}info(y,...j){this.f(P.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...j):console.log(y,...j))}warn(y,...j){this.f(P.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...j):console.log(y,...j))}error(y,...j){this.f(P.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...j):console.error(y,...j))}flush(){}}e.$xj=g;class i extends p{constructor(y,j=e.$sj){super(),this.g=y,this.setLevel(j)}trace(y,...j){this.f(P.Trace)&&this.g.log(P.Trace,[this.h(y),...j])}debug(y,...j){this.f(P.Debug)&&this.g.log(P.Debug,[this.h(y),...j])}info(y,...j){this.f(P.Info)&&this.g.log(P.Info,[this.h(y),...j])}warn(y,...j){this.f(P.Warning)&&this.g.log(P.Warning,[this.h(y),...j])}error(y,...j){this.f(P.Error)&&this.g.log(P.Error,[this.h(y),...j])}h(y){return typeof y=="string"?y:(0,N.$Si)(y,this.f(P.Trace))}flush(){}}e.$yj=i;class r extends p{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const j of this.g)j.setLevel(y);super.setLevel(y)}trace(y,...j){for(const W of this.g)W.trace(y,...j)}debug(y,...j){for(const W of this.g)W.debug(y,...j)}info(y,...j){for(const W of this.g)W.info(y,...j)}warn(y,...j){for(const W of this.g)W.warn(y,...j)}error(y,...j){for(const W of this.g)W.error(y,...j)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$zj=r;class t extends L.$Tc{constructor(y,j,W){if(super(),this.h=y,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Wd),this.onDidChangeVisibility=this.g.event,W)for(const te of W)this.b.set(te.resource,{logger:void 0,info:te})}m(y){return(0,a.$Jf)(y)?[...this.b.values()].find(j=>j.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,j){const W=this.n(y),te=(0,a.$Jf)(y)?y:j?.id??(0,R.$Vi)(W.toString()).toString(16);let _=this.b.get(W)?.logger;const oe=j?.logLevel==="always"?P.Trace:j?.logLevel;_||(_=this.s(W,oe??this.getLogLevel(W)??this.h,{...j,id:te}));const re={logger:_,info:{resource:W,id:te,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(W,re),_}n(y){return(0,a.$Jf)(y)?(0,h.$Ig)(this.j,`${y}.log`):y}setLogLevel(y,j){if(v.URI.isUri(y)){const W=y,te=j,_=this.b.get(W);_&&te!==_.info.logLevel&&(_.info.logLevel=te===this.h?void 0:te,_.logger?.setLevel(te),this.b.set(_.info.resource,_),this.f.fire([W,te]))}else{this.h=y;for(const[W,te]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&te.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,j){const W=this.m(y);W&&j!==!W.info.hidden&&(W.info.hidden=!j,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,j]))}getLogLevel(y){let j;return y&&(j=this.b.get(y)?.info.logLevel),j??this.h}registerLogger(y){const j=this.b.get(y.resource);j?j.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const j=this.b.get(y);j&&(j.logger&&j.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$Wd().event}setLevel(y){}getLevel(){return P.Info}trace(y,...j){}debug(y,...j){}info(y,...j){}warn(y,...j){}error(y,...j){}critical(y,...j){}dispose(){}flush(){}}e.$Bj=n;class s extends n{}e.$Cj=s;function o(O){if(O.verbose)return P.Trace;if(typeof O.logLevel=="string"){const y=I(O.logLevel.toLowerCase());if(y!==void 0)return y}return e.$sj}e.$Dj=o;function l(O){switch(O){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Off:return"off"}}e.$Ej=l;function I(O){switch(O){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Error;case"off":return P.Off}}e.$Fj=I,e.$Gj=new E.$mj("logLevel",l(P.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=void 0,e.$Hp=(0,D.$8h)("IExtensionSignatureVerificationService");let L=class{constructor(k){this.b=k}c(){return this.a||(this.a=new Promise((k,h)=>J(["node-vsce-sign"],async a=>k(a),h))),this.a}async verify(k,h,a){let v;try{v=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,N.$0)(E)),!1}return v.verify(k,h,a)}};e.$Ip=L,e.$Ip=L=$e([se(0,R.$pj)],L)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class v extends A.$Tc{constructor(d,$){super(),this.a=d,this.b=$,this.c=this.B(new L.$Wd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Wd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$6g(0)),this.w=[],this.y=this.B(new D.$6g(0))}watch(d,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(d,$):this.z(d,$)}n(d,$){const w={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:$.recursive,correlationId:$.correlationId},P=(0,N.$Ub)(this.j,w);return this.r(),(0,A.$Rc)(()=>{P(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,R.$1)(d))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,h.$jq)($)),$=>this.G($),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const $ of this.j)(0,h.$fq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const $ of this.j)(0,h.$fq)($)&&d.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,$){const w={path:this.H(d),excludes:$.excludes,includes:$.includes,recursive:!1,correlationId:$.correlationId},P=(0,N.$Ub)(this.w,w);return this.C(),(0,A.$Rc)(()=>{P(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,R.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,h.$jq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,k.$hc)(d.fsPath)}}e.$nq=v}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;let g=class extends a.$Tc{static{u=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$Wd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Wd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Wd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Wd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Wd),this.Y=this.B(new A.$Wd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Wd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$eh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new b.$Lk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,$.$Mg)(r))throw new b.$Nk((0,P.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new m.$bb;throw n.message=(0,P.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,b.$yk)(t)||(0,b.$vk)(t)||(0,b.$zk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,b.$yk)(t)||(0,b.$vk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,b.$Ik)(n)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Nk((0,P.localize)(2,null,this.sb(r)),1):(0,b.$Gk)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,I=t?.resolveMetadata,O=await n.stat(r);let y;return this.t(n,r,O,void 0,!!I,(j,W)=>(y||(y=v.$bi.forUris(()=>!s),y.set(r,!0),o&&y.fill(!0,o)),y.get(j.resource)||y.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&l?W===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:I}=this.R(r),O={resource:t,name:I.basename(t),isFile:(n.type&b.FileType.File)!==0,isDirectory:(n.type&b.FileType.Directory)!==0,isSymbolicLink:(n.type&b.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&b.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Yk)({mtime:n.mtime,size:n.size}),children:void 0};if(O.isDirectory&&l(O,s)){try{const y=await r.readdir(t),j=await D.Promises.settled(y.map(async([W,te])=>{try{const _=I.joinPath(t,W),oe=o?await r.stat(_):{type:te};return await this.t(r,_,oe,y.length,o,l)}catch(_){return this.b.trace(_),null}}));O.children=(0,N.$Hb)(j)}catch(y){this.b.trace(y),O.children=[]}return O}return O}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new b.$Nk((0,P.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$ke.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new b.$Kk(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,b.$Bk)(s)&&!l?.atomic){const I=s.enforceAtomicWriteFile?.(r);I&&(l={...n,atomic:I})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let O;if((0,b.$vk)(s)&&!(t instanceof R.$ke))if((0,w.$9d)(t)){const y=await(0,w.$de)(t,3);y.ended?O=R.$ke.concat(y.buffer):O=y}else O=(0,w.$ae)(t,y=>R.$ke.concat(y),3);else O=t;!(0,b.$yk)(s)||(0,b.$vk)(s)&&O instanceof R.$ke||(0,b.$vk)(s)&&(0,b.$Bk)(s)&&l?.atomic?await this.hb(s,r,l,O):await this.db(s,r,l,O instanceof R.$ke?(0,R.$ve)(O):O),this.r.fire(new b.$Kk(r,4))}catch(I){throw new b.$Nk((0,P.localize)(4,null,this.sb(r),(0,b.$Gk)(I).toString()),(0,b.$Jk)(I),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,P.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,P.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,P.localize)(7,null,this.sb(t)));if(s)throw new Error((0,P.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&b.FileType.Directory)throw new b.$Nk((0,P.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==b.$Xk&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,b.$Yk)({mtime:n.mtime,size:l.size}))throw new b.$Nk((0,P.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const I=await this.C(r,t,n,s);o(I)}catch(I){l(I)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,R.$we)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new L.$7d(s);let l=n;(0,b.$Ak)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const I=this.J(t,l).then(y=>y,y=>{throw o.dispose(!0),y});let O;try{return typeof l?.etag=="string"&&l.etag!==b.$Xk&&await I,l?.atomic&&(0,b.$Ak)(r)||!((0,b.$yk)(r)||(0,b.$zk)(r))||(0,b.$vk)(r)&&l?.preferUnbuffered?O=this.I(r,t,l):(0,b.$zk)(r)?O=this.G(r,t,o.token,l):O=this.H(r,t,o.token,l),O.on("end",()=>o.dispose()),O.on("error",()=>o.dispose()),{...await I,value:O}}catch(y){throw O&&await(0,w.$be)(O),this.F(y,t,l)}}F(r,t,n){const s=(0,P.localize)(11,null,this.sb(t),(0,b.$Gk)(r).toString());return r instanceof b.$Pk?new b.$Pk(s,r.stat,n):r instanceof b.$Ok?new b.$Ok(s,r.fileOperationResult,r.size,r.options):new b.$Nk(s,(0,b.$Jk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$he)(o,{data:l=>l instanceof R.$ke?l:R.$ke.wrap(l),error:l=>this.F(l,t,s)},l=>R.$ke.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,R.$Ae)();return(0,c.$dq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$$d)(o=>R.$ke.concat(o));return(async()=>{try{let o;n?.atomic&&(0,b.$Ak)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(R.$ke.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new b.$Nk((0,P.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==b.$Xk&&t.etag===n.etag)throw new b.$Pk((0,P.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new b.$Ok((0,P.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),I=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,l==="move"?2:3,I)),I}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),I=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,l==="copy"?3:2,I)),I}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:I,isSameResourceWithDifferentPathCase:O}=await this.Q(r,t,n,s,o,l);if(I&&!O&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,b.$wk)(r))await r.copy(t,s,{overwrite:l});else{const y=await this.resolve(t);y.isDirectory?await this.P(r,y,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,b.$yk)(r)&&(0,b.$yk)(n))return this.jb(r,t,n,s);if((0,b.$yk)(r)&&(0,b.$vk)(n))return this.pb(r,t,n,s);if((0,b.$vk)(r)&&(0,b.$yk)(n))return this.nb(r,t,n,s);if((0,b.$vk)(r)&&(0,b.$vk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let I=!1;if(r===n){const{providerExtUri:y,isPathCaseSensitive:j}=this.R(r);if(j||(I=y.isEqual(t,s)),I&&o==="copy")throw new Error((0,P.localize)(15,null,this.sb(t),this.sb(s)));if(!I&&y.isEqualOrParent(s,t))throw new Error((0,P.localize)(16,null,this.sb(t),this.sb(s)))}const O=await this.exists(s);if(O&&!I){if(!l)throw new b.$Nk((0,P.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:y}=this.R(r);if(y.isEqualOrParent(t,s))throw new Error((0,P.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:O,isSameResourceWithDifferentPathCase:I}}R(r){const t=this.S(r);return{providerExtUri:t?$.$yg:$.$Ag,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$Kk(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&b.FileType.Directory))throw new Error((0,P.localize)(19,null,this.sb(t)));break}catch(o){if((0,b.$Ik)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,b.$Ik)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,P.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,P.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,P.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new b.$Nk((0,P.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const O=await this.resolve(r);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,P.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,b.$Ck)(n)&&!s?.atomic){const O=n.enforceAtomicDelete?.(r);O&&(s={...t,atomic:O})}const o=!!s?.useTrash,l=!!s?.recursive,I=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:I}),this.r.fire(new b.$Kk(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,b.$xk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,b.$wk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:u.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const I=await this.bb(r,t);s?(0,a.$Oc)(I):o=()=>(0,a.$Oc)(I)}catch(I){this.b.error(I)}})();const l=t.correlationId;if(typeof l=="number"){const I=n.add(new A.$Wd);return n.add(this.X.event(y=>{y.correlates(l)&&I.fire(y)})),{onDidChange:I.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,k.$Vi)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$9d)(s)||(0,w.$0d)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,b.$Gk)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$0d)(n)){if(n.buffer.length>0){const l=R.$ke.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,I)=>{(0,w.$ce)(o,{onData:async O=>{o.pause();try{await this.gb(r,t,O,O.byteLength,s,0)}catch(y){return I(y)}s+=O.byteLength,setTimeout(()=>o.resume())},onError:O=>I(O),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let I=0;for(;I<s;){const O=await r.write(t,o+I,n.buffer,l+I,s-I);I+=O}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof R.$ke?o=s:(0,w.$9d)(s)?o=await(0,R.$we)(s):(0,w.$0d)(s)?o=await(0,R.$xe)(s):o=(0,R.$ue)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const I=R.$ke.alloc(this.a);let O=0,y=0,j=0;do j=await r.read(o,O,I.buffer,y,I.byteLength-y),await this.gb(n,l,I,j,O,y),O+=j,y+=j,y===I.byteLength&&(y=0);while(j>0)}catch(I){throw(0,b.$Gk)(I)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,R.$ke.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$Gk)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,R.$we)(this.H(r,t,L.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new b.$Nk((0,P.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&b.FilePermission.Readonly)throw new b.$Nk((0,P.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$eq=g,e.$eq=g=u=$e([se(0,p.$pj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0,(()=>{try{(0,D.gracefulify)(N)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.$Si)(r)}`)}})();class i extends p.$nq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=k.Event.None,this.N=new L.$Ac(s=>d.$zg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:b.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Ig)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=b.FileType.Unknown:t.isFile()?s=b.FileType.File:t.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,n&&(s|=b.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new R.$7g;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,$.$$d)(l=>A.$ke.concat(l.map(I=>A.$ke.wrap(I))).buffer);return(0,c.$dq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Ig)((0,d.$Hg)(t),`${(0,d.$Fg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Sc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(I){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const I=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(I)){if(!s.overwrite)throw(0,b.$Fk)((0,P.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$Fk)((0,P.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(I){throw await this.gb(t,I)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,b.$tk)(n)&&!s&&(l=await this.O(t));let I;try{if((0,b.$tk)(n)&&n.unlock)try{const{stat:y}=await w.SymlinkSupport.stat(o);y.mode&128||await w.Promises.chmod(o,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let O;if((0,b.$tk)(n)){if(E.$i)try{await w.Promises.truncate(o,0),O="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}O||(O="w")}else O="r";I=await w.Promises.open(o,O)}catch(O){throw l?.dispose(),(0,b.$tk)(n)?await this.gb(t,O):this.fb(O)}if(this.U.set(I,0),(0,b.$tk)(n)&&this.X.set(I,t),l){const O=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${o})`),this.W.set(I,l),O&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${o})`),O.dispose())}return I}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const I=this.Z(t,n);let O=null;try{O=(await w.Promises.read(t,s,o,l,I)).bytesRead}catch(y){throw this.fb(y)}finally{this.$(t,I,O)}return O}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,R.$ph)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const I=this.Z(t,n);let O=null;try{O=(await w.Promises.write(t,s,o,l,I)).bytesWritten}catch(y){throw await this.gb(this.X.get(t),y)}finally{this.$(t,I,O)}return O}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,v.$jc)((0,v.$mc)(s),`${(0,v.$nc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:I,symbolicLink:O}=await w.SymlinkSupport.stat(s);l=I.isDirectory()&&!O}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(2,null,(0,v.$nc)(o),(0,v.$nc)((0,v.$mc)(l)),I.toString()))),this.fb(I)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,P.localize)(3,null,(0,v.$nc)(o),(0,v.$nc)((0,v.$mc)(l)),I.toString()))),this.fb(I)}}async bb(t,n,s,o){const l=this.H(t),I=this.H(n);let O=!1;if(!!(this.capabilities&1024)||(O=(0,h.$8f)(l,I,!0)),O){if(s==="copy")throw(0,b.$Fk)((0,P.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,b.$Fk)((0,P.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const W=await this.L(n);if(W){if(!o)throw(0,b.$Fk)((0,P.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);j.type&b.FileType.File&&W.type&b.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),I=!!(this.capabilities&1024);if((0,h.$8f)(o,l,!I))return;const O=new a.$Sc;try{O.add(await this.O(t)),O.add(await this.O(n)),s&&await w.Promises.mkdir((0,v.$mc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(y){if(y.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(y)}finally{O.dispose()}}t(t,n,s){return new u.$uq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Cq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof b.$Ek)return t;let n=t,s;switch(t.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Fk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,b.$Fk)(n,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Dq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=void 0;class R extends N.$Tc{constructor(A,k=[]){super(),this.a=new D.$zj([A,...k]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...k){this.a.trace(A,...k)}debug(A,...k){this.a.debug(A,...k)}info(A,...k){this.a.info(A,...k)}warn(A,...k){this.a.warn(A,...k)}error(A,...k){this.a.error(A,...k)}flush(){this.a.flush()}}e.$LO=R}),define(ie[130],ne([0,1,13,4]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function L(a,v,E,d,$){try{const w=await new Promise((b,c)=>{J(["@vscode/spdlog"],b,c)});w.setFlushOn(R.Trace);const P=await w.createAsyncRotatingLogger(a,v,E,d);return $?P.clearFormatters():P.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),P}catch(w){console.error(w)}return null}function A(a,v,E){switch(v){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function k(a,v){switch(v){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class h extends D.$vj{constructor(v,E,d,$,w){super(),this.m=[],this.setLevel(w),this.n=this.s(v,E,d,$),this.B(this.onDidChangeLogLevel(P=>{this.r&&k(this.r,P)}))}async s(v,E,d,$){const w=d?6:1,P=30/w*N.$1k.MB,b=await L(v,E,P,w,$);if(b){this.r=b,k(this.r,this.getLevel());for(const{level:c,message:p}of this.m)A(this.r,c,p);this.m=[]}}g(v,E){this.r?A(this.r,v,E):this.getLevel()<=v&&this.m.push({level:v,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$AO=h}),define(ie[131],ne([0,1,28,4,130]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;class L extends D.$Aj{s(k,h,a){return new R.$AO((0,N.$rg)(),k.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,h)}}e.$BO=L}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0,e.$Mn=(0,L.$8h)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new N.$Wd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const v=Object.keys(this.f).length;return this.f={...a,...this.f},v!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[d,$])=>({...E,[d]:$}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[v,E])=>({...a,[v]:{definition:E,value:this.g.get(v)}}),{})}}e.$Nn=A;class k{constructor(){this.onDidChange=N.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$On=k}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$b=void 0;function a(E,d){const $=[];for(const w of new Set(R.Iterable.concat(E.keys(),d.keys())))E.get(w)!==d.get(w)&&$.push(w);return $}let v=class extends h.$Nn{constructor(d,$,w){super(),this.m=d,this.n=$,this.s=w,this.c=this.B(new N.$6g(500));const P=D.Event.filter($.onDidFilesChange,b=>b.affects(d));this.B($.watch(d)),this.B(P(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const $=await this.n.readFile(this.m),w=JSON.parse($.value.toString());if(!(0,L.$Lf)(w))throw new Error("Policy file isn't a JSON object");for(const P of Object.keys(w))this.f[P]&&d.set(P,w[P])}catch($){$.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",$)}return d}async w(){const d=await this.u(),$=a(this.g,d);this.g=d,$.length>0&&this.h.fire($)}};e.$Z$b=v,e.$Z$b=v=$e([se(1,A.$sk),se(2,k.$pj)],v)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=void 0;let A=class extends N.$Nn{constructor(h,a){super(),this.m=h,this.n=a,this.a=new D.$2g,this.b=this.B(new R.$Uc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:a}=await new Promise((v,E)=>{J(["@vscode/policy-watcher"],v,E)});await this.a.queue(()=>new Promise((v,E)=>{try{this.b.value=a(this.n,h,d=>{this.t(d),v()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const a in h){const v=h[a];v===void 0?this.g.delete(a):this.g.set(a,v)}this.h.fire(Object.keys(h))}};e.$Y$b=A,e.$Y$b=A=$e([se(0,L.$pj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,N.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class R{constructor(){this.a=new Map}add(A,k){N.ok(D.$Jf(A)),N.ok(D.$Lf(k)),N.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Kn=new R}),define(ie[134],ne([0,1,6,36]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function R(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this.b=new N.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,a){this.a[R(h)]=a,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;D.$Kn.add(e.$Ln.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Pn={Configuration:"base.contributions.configuration"};var v;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const E=h.$Kn.as(k.$Ln.JSONContribution);class d{constructor(){this.h=new Set,this.i=new D.$Wd,this.onDidSchemaChange=this.i.event,this.j=new D.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$Zn.test(o)){const l=this.a.get(o),I=l?.valuesSources??new Map;if(s)for(const W of Object.keys(n[o]))I.set(W,s);const O={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:O,valuesSources:I});const y=(0,A.$Li)(o),j={type:"object",default:O,description:L.localize(1,null,y),$ref:e.$Wn,defaultDefaultValue:O,source:R.$Jf(s)?void 0:s,defaultValueSource:s};t.push(...P(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=R.$Jf(n)?n:n?.id,I=R.$Jf(o?.source)?o?.source:o?.source?.id;if(l===I)if(r.add(s),this.a.delete(s),e.$Zn.test(s))delete this.d[s],delete this.b.properties[s];else{const O=this.d[s];O&&(this.w(s,O),this.r(s,O))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=R.$Sf(i.scope)?s:i.scope;const l=i.properties;if(l)for(const O in l){const y=l[O];if(r&&m(O,y)){delete l[O];continue}if(y.source=t,y.defaultDefaultValue=l[O].default,this.w(O,y),e.$Zn.test(O)?y.scope=void 0:(y.scope=R.$Sf(y.scope)?s:y.scope,y.restricted=R.$Sf(y.restricted)?!!n?.includes(O):y.restricted),l[O].hasOwnProperty("included")&&!l[O].included){this.f[O]=l[O],delete l[O];continue}else this.d[O]=l[O],l[O].policy?.name&&this.e.set(l[O].policy.name,O);!l[O].deprecationMessage&&l[O].markdownDeprecationMessage&&(l[O].deprecationMessage=l[O].markdownDeprecationMessage),o.add(O)}const I=i.allOf;if(I)for(const O of I)this.p(O,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$Qn.properties[i]=r,r.scope){case 1:e.$Rn.properties[i]=r;break;case 2:e.$Sn.properties[i]=r;break;case 6:e.$Tn.properties[i]=r;break;case 3:e.$Un.properties[i]=r;break;case 4:e.$Vn.properties[i]=r;break;case 5:e.$Vn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$Qn.properties[i],r.scope){case 1:delete e.$Rn.properties[i];break;case 2:delete e.$Sn.properties[i];break;case 6:delete e.$Tn.properties[i];break;case 3:delete e.$Un.properties[i];break;case 4:case 5:delete e.$Vn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Wn};this.w(r,t),e.$Qn.properties[r]=t,e.$Rn.properties[r]=t,e.$Sn.properties[r]=t,e.$Tn.properties[r]=t,e.$Un.properties[r]=t,e.$Vn.properties[r]=t}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=i,e.$Rn.patternProperties[e.$Yn]=i,e.$Sn.patternProperties[e.$Yn]=i,e.$Tn.patternProperties[e.$Yn]=i,e.$Un.patternProperties[e.$Yn]=i,e.$Vn.patternProperties[e.$Yn]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.$Qf(n)&&(n=r.defaultDefaultValue,s=void 0),R.$Qf(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const $="\\[([^\\]]+)\\]",w=new RegExp($,"g");e.$Yn=`^(${$})+$`,e.$Zn=new RegExp(e.$Yn);function P(g){const i=[];if(e.$Zn.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,N.$Mb)(i)}e.$1n=P;function b(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$2n=b;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=c;const p=new d;h.$Kn.add(e.$Pn.Configuration,p);function m(g,i){return g.trim()?e.$Zn.test(g)?L.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$4n=m;function u(){const g=[],i=p.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$5n=u}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,N,D,R,L,A,k,h,a,v,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function $(r){return Object.isFrozen(r)?r:k.$zn(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new P("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,v.$Ji)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return $(s.rawConfiguration.getValue(t))},get override(){return n?$(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return $(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:I,keys:O}of s.rawConfiguration.overrides){const y=new w(l,O).getValue(t);y!==void 0&&o.push({identifiers:I,value:y})}return o.length?$(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,v.$Ji)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return N.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return N.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=k.$yn(this.contents),s=k.$yn(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const I of t)if(l.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(n,I.contents);for(const O of I.overrides){const[y]=s.filter(j=>N.$ub(j.identifiers,O.identifiers));y?(this.h(y.contents,O.contents),y.keys.push(...O.keys),y.keys=N.$Mb(y.keys)):s.push(k.$yn(O))}for(const O of I.keys)o.indexOf(O)===-1&&o.push(O)}return new w(n,o,s,l.every(I=>I instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of N.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const I=n[o];I&&(typeof l=="object"&&typeof I=="object"?(l=k.$yn(l),this.h(l,I)):l=I),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&h.$Lf(t[s])&&h.$Lf(n[s])){this.h(t[s],n[s]);continue}t[s]=k.$yn(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=k.$yn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,v.$Ii)(this.contents,t),E.$Zn.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>N.$ub(s.identifiers,(0,E.$1n)(t))),1))}j(t,n,s){(0,v.$Hi)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$Zn.test(t)&&this.overrides.push({identifiers:(0,E.$1n)(t),keys:Object.keys(this.contents[t]),contents:(0,v.$Gi)(this.contents[t],o=>console.error(o))})}}e.$6n=w;class P{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!h.$Sf(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:I,hasExcludedProperties:O}=this.h(t,n);this.b=new w(s,o,l,O?[t]:void 0),this.c=I||[]}g(t){let n={},s=null,o=[];const l=[],I=[];function O(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const y={onObjectBegin:()=>{const j={};O(j),l.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];O(j),l.push(o),o=j,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:O,onError:(j,W,te)=>{I.push({error:j,offset:W,length:te})}};if(t)try{R.$mn(t,y),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=d.$Kn.as(E.$Pn.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,v.$Gi)(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(t),O=this.j(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:l,keys:I,overrides:O,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const I={},O=[];for(const y in t)if(E.$Zn.test(y)&&s){const j=this.i(t[y],n,!1,o);I[y]=j.raw,l=l||j.hasExcludedProperties,O.push(...j.restricted)}else{const j=n[y],W=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&O.push(y),!o.exclude?.includes(y)&&(o.include?.includes(y)||(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&!(o.skipRestricted&&j?.restricted))?I[y]=t[y]:l=!0}return{raw:I,restricted:O,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$Zn.test(o)){const l={};for(const I in t[o])l[I]=t[o][I];s.push({identifiers:(0,E.$1n)(o),keys:Object.keys(l),contents:(0,v.$Gi)(l,n)})}return s}}e.$7n=P;class b extends L.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$Wd),this.onDidChange=this.b.event,this.a=new P(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=b;class c{constructor(t,n,s,o,l,I,O,y,j,W,te,_,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=I,this.g=O,this.h=y,this.i=j,this.j=W,this.k=te,this.l=_,this.m=oe}get value(){return $(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class p{constructor(t,n,s,o,l=new w,I=new w,O=new A.$Ac,y=new w,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=I,this.j=O,this.l=y,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),I=n.resource?this.m.get(n.resource)||this.l:this.l,O=new Set;for(const y of o.overrides)for(const j of y.identifiers)o.getOverrideValue(t,j)!==void 0&&O.add(j);return new c(t,n,o.getValue(t),O.size?[...O]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,I)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:I}=g(this.c,t);n=[...o,...l,...I]}for(const o of n)for(const l of(0,E.$1n)(o)){const I=this.c.getKeysForOverrideIdentifier(l),O=t.getKeysForOverrideIdentifier(l),y=[...O.filter(j=>I.indexOf(j)===-1),...I.filter(j=>O.indexOf(j)===-1),...I.filter(j=>!k.$Cn(this.c.override(l).getValue(j),t.override(l).getValue(j)))];s.push([l,y])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateApplicationConfiguration(t),{keys:I,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateLocalUserConfiguration(t),{keys:I,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateRemoteUserConfiguration(t),{keys:I,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateWorkspaceConfiguration(t),{keys:I,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:I,overrides:O}=g(s,n),y=[...o,...l,...I];return(y.length||!s)&&this.updateFolderConfiguration(t,n),{keys:y,overrides:O}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:I}=g(n,void 0);return{keys:[...s,...o,...l],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),I=this.w(t.workspace),O=t.folders.reduce((y,j)=>(y.set(a.URI.revive(j[0]),this.w(j[1])),y),new A.$Ac);return new p(n,s,o,l,new w,I,O,new w,new A.$Ac)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$9n=p;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,I])=>{const O=(0,A.$xc)(n,l,new Set);I.forEach(y=>O.add(y))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$0n=m;class u{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const I of l)this.affectedKeys.add(I);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const I=this.d.charCodeAt(l);if(I!==this.b&&I!==this.c)return!1;if(n){const O=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,y=this.g.getValue(t,n,this.h);return!k.$Cn(O,y)}return!0}}e.$$n=u;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],I=r?.getAllOverrideIdentifiers()||[],O=t?.getAllOverrideIdentifiers()||[];if(t){const y=O.filter(j=>!I.includes(j));for(const j of y)l.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const y=I.filter(j=>!O.includes(j));for(const j of y)l.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const y of I)if(O.includes(y)){const j=i({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:t.getOverrideValue(void 0,y)||{},keys:t.getKeysForOverrideIdentifier(y)});l.push([y,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const I=(0,v.$Ji)(t.contents,l),O=(0,v.$Ji)(r.contents,l);k.$Cn(I,O)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,N,D,R,L,A,k,h,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=void 0;class d extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$6n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Kn.as(h.$Pn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:c})=>this.c(Array.from(b),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,c){this.h(b,E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new k.$6n;const b=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,c){const p=this.f();for(const m of b){const u=p[m],g=c[m];u!==void 0?this.b.addValue(m,u):g?this.b.addValue(m,g.default):this.b.removeValue(m)}}}e.$_n=d;class ${constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new k.$6n}async initialize(){return this.configurationModel}}e.$ao=$;let w=class extends R.$Tc{get configurationModel(){return this.b}constructor(b,c,p){super(),this.c=b,this.f=c,this.g=p,this.a=this.B(new D.$Wd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$6n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const c={},p=[],m=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties();for(const u of b){const g=m[u];if(!g){p.push(u);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}p.push(u),c[g.policy.name]={type:g.type}}}return(0,A.$Wf)(c)||await this.f.updatePolicyDefinitions(c),p}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const c=E.$Kn.as(h.$Pn.Configuration).getPolicyConfigurations(),p=(0,N.$Hb)(b.map(m=>c.get(m)));this.m(p,!0)}m(b,c){this.g.trace("PolicyConfiguration#update",b);const p=E.$Kn.as(h.$Pn.Configuration).getConfigurationProperties(),m=[],u=this.b.isEmpty();for(const g of b){const i=p[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(u?r!==void 0:!(0,L.$Cn)(this.b.getValue(g),r))&&m.push([g,r])}else this.b.getValue(g)!==void 0&&m.push([g,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const g=this.b;this.b=new k.$6n;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of m)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$bo=w,e.$bo=w=$e([se(1,v.$Mn),se(2,a.$pj)],w)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class c extends h.$Tc{constructor(u,g,i,r){super(),this.m=u,this.h=this.B(new L.$Wd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new P.$_n),this.c=i instanceof b.$On?new P.$ao:this.B(new P.$bo(this.b,i,r)),this.f=this.B(new $.$8n(this.m,{},E.$zg,g)),this.a=new $.$9n(this.b.configurationModel,this.c.configurationModel,new $.$6n,new $.$6n),this.j=new p(u,g,this),this.g=this.B(new D.$hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[u,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$9n(u,g,new $.$6n,i)}getConfigurationData(){return this.a.toData()}getValue(u,g){const i=typeof u=="string"?u:void 0,r=(0,d.$Ci)(u)?u:(0,d.$Ci)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(u,g,i,r,t){const n=(0,d.$Di)(i)?i:(0,d.$Ci)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${u} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,N.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(u,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${u} because it is configured in system policy.`);if((0,a.$Cn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const I=n.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(y=>(0,N.$ub)([...y.identifiers].sort(),I));O&&(n.overrideIdentifiers=O.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$2n)(n.overrideIdentifiers),u]:[u];await this.j.write(l,g),await this.reloadConfiguration()}inspect(u,g={}){return this.a.inspect(u,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const u=await this.f.loadConfiguration();this.n(u)}n(u){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(u);this.t(i,g,2)}r(u,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(u,g);this.t(r,i,7)}s(u){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(u);this.t(i,g,7)}t(u,g,i){const r=new $.$$n(u,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$co=c;class p{constructor(u,g,i){this.b=u,this.c=g,this.d=i,this.a=new D.$ch}write(u,g){return this.a.queue(()=>this.e(u,g))}async e(u,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$fn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,u,g);i=(0,k.$xn)(i,t),await this.c.writeFile(this.b,R.$ke.fromString(i))}f(u,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,k.$un)(u,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let u=v.OS===3||v.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(u=g),this.g={eol:u,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function D(a){return a.scheme===N.Schemas.vscodeRemote?a.authority:void 0}e.$cl=D;function R(a){if(!a)return;const v=a.indexOf("+");return v<0?a:a.substr(0,v)}e.$dl=R;function L(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$el=L;function A(a){const{host:v,port:E}=h(a);if(typeof E>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:v,port:E}}e.$fl=A;function k(a,v){let{host:E,port:d}=h(a);return typeof d>"u"&&(d=v),{host:E,port:d}}e.$gl=k;function h(a){const v=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const E=a.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const d=a.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function L(P){if(typeof P=="object"&&P!==null&&P.supported!==!0)return P.description}e.$lm=L,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(A||(e.ExtensionType=A={}));var k;(function(P){P.WIN32_X64="win32-x64",P.WIN32_ARM64="win32-arm64",P.LINUX_X64="linux-x64",P.LINUX_ARM64="linux-arm64",P.LINUX_ARMHF="linux-armhf",P.ALPINE_X64="alpine-x64",P.ALPINE_ARM64="alpine-arm64",P.DARWIN_X64="darwin-x64",P.DARWIN_ARM64="darwin-arm64",P.WEB="web",P.UNIVERSAL="universal",P.UNKNOWN="unknown",P.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class h{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,c){if(typeof b>"u"||b===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof b=="string"||typeof c=="string"){const p=typeof b=="string"?b:b.value,m=typeof c=="string"?c:c.value;return N.$af(p,m)}return b._lower===c._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$nm=h;class a{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const c of b)this.add(c)}add(b){this.c.add(h.toKey(b))}delete(b){return this.c.delete(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}}e.$om=a;class v{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(h.toKey(b))}get(b){return this.c.get(h.toKey(b))}has(b){return this.c.has(h.toKey(b))}set(b,c){this.c.set(h.toKey(b),c)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=v;function E(P){return d(P)}e.$qm=E;function d(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.$rm=d;function $(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.$sm=$;function w(P,b){if(b){const c=`onResolveRemoteAuthority:${(0,R.$dl)(b)}`;return!!P.activationEvents?.includes(c)}return!1}e.$tm=w,e.$um=(0,D.$8h)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends N.$Tc{constructor(k,h,a,v,E){super(),this.a=k,this.b=h,this.c=a,this.f=E,this.B(v.onDidInstallExtensions(d=>this.g(d))),this.B(v.onDidUninstallExtension(d=>this.h(d)))}g(k){for(const h of k)h.local&&this.invalidate(h.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,k)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,D.$hm))}catch(h){(0,R.$Jk)(h)!==1&&this.f.error(h)}}}e.$0p=L}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$jp=(0,k.$8h)("requestService");class v{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends R.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,L.localize)(0,null),when:h.$Gj.isEqualTo((0,h.$Ej)(h.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new v(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$kp=E;function d(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}e.$lp=d;function $(u){return u.res.statusCode===204}e.$mp=$;async function w(u){return $(u)?null:(await(0,N.$we)(u.stream)).toString()}e.$np=w;async function P(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);return w(u)}e.$op=P;async function b(u){if(!d(u))throw new Error("Server returned "+u.res.statusCode);if($(u))return null;const i=(await(0,N.$we)(u.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$pp=b;function c(u){m(u)}e.$qp=c;let p;function m(u){const g=a.$Kn.as(A.$Pn.Configuration),i=p;p={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[p],remove:i?[i]:[]})}m(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=void 0;let A=class{constructor(h,a){this.a=h,this.b=a}async download(h,a,v=N.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,a);return}const E={type:"GET",url:h.toString(!0)},d=await this.a.request(E,v);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const $=await(0,L.$op)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${$}`)}}};e.$1O=A,e.$1O=A=$e([se(0,L.$jp),se(1,R.$sk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;function R(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function L(A,k,h={}){const a=(0,N.parse)(A),v=h.proxyUrl||R(a,k);if(!v)return null;const E=(0,N.parse)(v);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Pf)(h.strictSSL)?h.strictSSL:!0};return a.protocol==="http:"?new(await new Promise(($,w)=>{J(["http-proxy-agent"],$,w)})).HttpProxyAgent(v,d):new(await new Promise(($,w)=>{J(["https-proxy-agent"],$,w)})).HttpsProxyAgent(v,d)}e.$or=L}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=void 0;let w;async function P(c,p,m,u){return m["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$8l)(u)&&!m["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$8l)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new L.$7d;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,$.$9l)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{g(await b(p,r.token))}catch(o){!(0,k.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,A.$Si)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}e.$bm=P;async function b(c,p){const m=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",m);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",u);const g=(0,a.$rg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,v.$Xl)(h.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(p.isCancellationRequested)return s(new k.$5);const o=(0,D.$nc)(t);let l,I;const O="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${O} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,I=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${O} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,I=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,I=["-i","-l","-c"]):(l=`'${process.execPath}' ${O} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),l);const y=(0,N.spawn)(t,[...I,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});p.onCancellationRequested(()=>(y.kill(),s(new k.$5))),y.on("error",te=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Si)(te)),s(te)});const j=[];y.stdout.on("data",te=>j.push(te));const W=[];y.stderr.on("data",te=>W.push(te)),y.on("close",(te,_)=>{const oe=Buffer.concat(j).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(W).toString("utf8");if(re.trim()&&c.trace("getUnixShellEnvironment#stderr",re),te||_)return s(new Error((0,R.localize)(2,null,te,_)));const he=i.exec(oe),ce=he?he[1]:"{}";try{const ae=JSON.parse(ce);m?ae.ELECTRON_RUN_AS_NODE=m:delete ae.ELECTRON_RUN_AS_NODE,u?ae.ELECTRON_NO_ATTACH_CONSOLE=u:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){c.error("getUnixShellEnvironment#errorCaught",(0,A.$Si)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DO=e.$CO=void 0,e.$CO=(0,N.$8h)("stateReadService"),e.$DO=(0,N.$8h)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GO=e.$FO=e.$EO=e.SaveStrategy=void 0;var a;(function($){$[$.IMMEDIATE=0]="IMMEDIATE",$[$.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class v extends R.$Tc{constructor(w,P,b,c){super(),this.h=w,this.j=P,this.m=b,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new N.$6g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,P){const b=this.a[w];return(0,L.$Sf)(b)?P:b}setItem(w,P){this.setItems([{key:w,data:P}])}setItems(w){let P=!1;for(const{key:b,data:c}of w)this.a[b]!==c&&((0,L.$Sf)(c)?(0,L.$Qf)(this.a[b])||(this.a[b]=void 0,P=!0):(this.a[b]=c,P=!0));P&&this.s()}removeItem(w){(0,L.$Qf)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,D.$ke.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(P){this.m.error(P)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$EO=v;let E=class extends R.$Tc{constructor(w,P,b,c){super(),this.a=this.B(new v(P.stateResource,w,b,c))}async init(){await this.a.init()}getItem(w,P){return this.a.getItem(w,P)}};e.$FO=E,e.$FO=E=$e([se(1,A.$ci),se(2,h.$pj),se(3,k.$sk)],E);class d extends E{setItem(w,P){this.a.setItem(w,P)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$GO=d}),define(ie[69],ne([0,1,12,35,28]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function L(h){if(N.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,a,v,E,d,$,w,P,b){const c=Object.create(null);c["common.machineId"]=$,c["common.sqmId"]=w,c.sessionID=(0,R.$rg)()+Date.now(),c.commitHash=E,c.version=d,c["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,N.$h)(N.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=v,c["common.product"]=b||"desktop",P&&(c["common.msftInternal"]=P);let p=0;const m=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),N.$l&&(c["common.snap"]="true");const u=L(a);return u&&(c["common.platformDetail"]=u),c}e.$Lo=A;function k(h){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const v=a.toLowerCase();return h.some(E=>v===E)}e.$Mo=k}),define(ie[25],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,N.$8h)("telemetryService"),e.$xl=(0,N.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var D;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$No=k;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=h,e.$Po=new h;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$Qo=a,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$Uo=v;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Vo=E;function d(i){const r=i.getValue(A.$El),t=i.getValue(A.$Fl);if(i.getValue(A.$Gl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=d;function $(i){const r={},t={},n={};b(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$Xo=$;const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function P(i){if(!i)return"none";const r=(0,R.$dl)(i);return w.has(r)?r:"other"}e.$Yo=P;function b(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,N.$Dn)(o):o instanceof Date?r[l]=o.toISOString():(0,D.$Lf)(o)?t<2?b(o,r,t+1,l+"."):r[l]=(0,N.$Dn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,L.$Mo)(t)||n}e.$Zo=c;function p(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$1o=p;function m(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const I of r)for(;;){const O=I.exec(i);if(!O)break;n.push([O.index,I.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const I=o.exec(i);if(!I)break;const O=n.some(([y,j])=>I.index<j&&y<o.lastIndex);!s.test(I[0])&&!O&&(t+=i.substring(l,I.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function u(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,N.$An)(i,t=>{if(t instanceof k||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=m(n,r);for(const s of r)n=n.replace(s,"");return n=u(n),n}})}e.$2o=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function v(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,N.$8e)(t.id,n.id)===0}e.$3o=v;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?v(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$4o=d;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=$.exec(t);return n&&n[1]?[b(n[1]),n[2]]:[b(t),void 0]}e.$5o=w;function P(t,n){return`${t}.${n}`}e.$6o=P;function b(t){return t.toLowerCase()}e.$7o=b;function c(t,n){return b(P(t??R.$jm,n))}e.$8o=c;function p(t,n){const s=[],o=l=>{for(const I of s)if(I.some(O=>v(n(O),n(l))))return I;return null};for(const l of t){const I=o(l);I?I.push(l):s.push([l])}return s}e.$9o=p;function m(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$0o=m;function u(t){return{id:new a.$No(t.identifier.id),name:new a.$No(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$$o=u,e.$_o=new R.$nm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(I=>!v(I.identifier,{id:l}))){const I=t.filter(O=>v(O.identifier,{id:l}));I.length===1&&(s.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$ap=g;async function i(t,n){if(!L.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,k.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$xo)(s?"alpine":L.$u,h.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$bp=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,N,D,R,L,A,k,h,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;const d=P=>(0,h.localize)(0,null,P),$=(0,h.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(b,c,p){this.a=b,this.b=c,this.d=p}get f(){}async listExtensions(b,c,p){let m=await this.b.getInstalled(1,p);const u=E.$mm.map(i=>i.toLowerCase());if(c&&c!==""){if(u.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),u.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),m=m.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of m)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(b?`${g}@${i.manifest.version}`:g))}async installExtensions(b,c,p,m){const u=[];try{const g=[];b.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const i=[];let r=[];const t=(s,o,l)=>{r.push({id:s,version:o!=="prerelease"?o:void 0,installOptions:{...p,isBuiltin:l,installPreReleaseVersion:o==="prerelease"||p.installPreReleaseVersion}})};for(const s of b)if(s instanceof k.URI)i.push({vsix:s,installOptions:p});else{const[o,l]=(0,v.$5o)(s);t(o,l,!1)}for(const s of c)if(s instanceof k.URI)i.push({vsix:s,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[o,l]=(0,v.$5o)(s);t(o,l,!0)}const n=await this.b.getInstalled(1,p.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:s,installOptions:o})=>{try{const l=await this.g(s,o,m,n);l&&g.push(l)}catch(l){this.a.error(l),u.push(s.toString())}})),r.length&&(r=r.filter(({id:s,version:o})=>{const l=n.find(I=>(0,v.$3o)(I.identifier,{id:s}));if(l){if(!m&&(!o||o==="prerelease"&&l.preRelease))return this.a.info((0,h.localize)(5,null,s,l.manifest.version,s)),!1;if(o&&l.manifest.version===o)return this.a.info((0,h.localize)(6,null,`${s}@${o}`)),!1}return!0}),r.length)){const s=await this.h(r);await Promise.all(r.map(async o=>{const l=s.get(o.id.toLowerCase());if(l)try{const I=await this.j(o,l,n);I&&g.push(I)}catch(I){this.a.error(I.message||I.stack||I),u.push(o.id)}else this.a.error(`${d(o.version?`${o.id}@${o.version}`:o.id)}
${$}`),u.push(o.id)}))}}catch(g){throw this.a.error((0,h.localize)(7,null,(0,D.$0)(g))),g}if(u.length)throw new Error((0,h.localize)(8,null,u.join(", ")))}async updateExtensions(b){const c=await this.b.getInstalled(1,b),p=[];for(const i of c)i.identifier.uuid&&p.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,h.localize)(9,null,p.length));const m=await this.d.getExtensions(p,{compatible:!0},N.CancellationToken.None),u=[];for(const i of m)for(const r of c)(0,v.$3o)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&u.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!u.length){this.a.info((0,h.localize)(10,null));return}this.a.info((0,h.localize)(11,null,u.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(u);for(const i of g)i.error?this.a.error((0,h.localize)(12,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,h.localize)(13,null,i.identifier.id,i.local?.manifest.version))}async g(b,c,p,m){const u=await this.b.getManifest(b);if(!u)throw new Error("Invalid vsix");if(await this.l(u,p,c.profileLocation,m))try{return await this.b.install(b,c),this.a.info((0,h.localize)(14,null,(0,L.$Fg)(b))),u}catch(i){if((0,D.$4)(i))return this.a.info((0,h.localize)(15,null,(0,L.$Fg)(b))),null;throw i}return null}async h(b){const c=new Map,p=b.some(g=>g.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),u=[];for(const g of b)a.$qo.test(g.id)&&u.push({...g,preRelease:p});if(u.length){const g=await this.d.getExtensions(u,{targetPlatform:m},N.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}async j({id:b,version:c,installOptions:p},m,u){const g=await this.d.getManifest(m,N.CancellationToken.None);if(g&&!this.k(g))return null;const i=u.find(r=>(0,v.$3o)(r.identifier,m.identifier));if(i){if(m.version===i.manifest.version)return this.a.info((0,h.localize)(16,null,c?`${b}@${c}`:b)),null;this.a.info((0,h.localize)(17,null,b,m.version))}try{p.isBuiltin?this.a.info(c?(0,h.localize)(18,null,b,c):(0,h.localize)(19,null,b)):this.a.info(c?(0,h.localize)(20,null,b,c):(0,h.localize)(21,null,b));const r=await this.b.installFromGallery(m,{...p,installGivenVersion:!!c});return this.a.info((0,h.localize)(22,null,b,r.manifest.version)),g}catch(r){if((0,D.$4)(r))return this.a.info((0,h.localize)(23,null,b)),null;throw r}}k(b){return!0}async l(b,c,p,m){if(!c){const u={id:(0,v.$8o)(b.publisher,b.name)},g=m.find(i=>(0,v.$3o)(u,i.identifier)&&(0,A.gt)(i.manifest.version,b.version));if(g)return this.a.info((0,h.localize)(24,null,g.identifier.id,g.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,c,p){const m=async g=>{if(g instanceof k.URI){const i=await this.b.getManifest(g);return(0,v.$6o)(i.publisher,i.name)}return g},u=[];for(const g of b){const i=await m(g),t=(await this.b.getInstalled(void 0,p)).filter(n=>(0,v.$3o)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${$}`);if(t.some(n=>n.type===0)){this.a.info((0,h.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,h.localize)(26,null,i));return}this.a.info((0,h.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:p}),u.push(n);this.f?this.a.info((0,h.localize)(28,null,i,this.f)):this.a.info((0,h.localize)(29,null,i))}}async locateExtension(b){const c=await this.b.getInstalled();b.forEach(p=>{c.forEach(m=>{if(m.identifier.id===p&&m.location.scheme===R.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(b){return this.f?(0,h.localize)(30,null,b,this.f):(0,h.localize)(31,null,b)}};e.$Jp=w,e.$Jp=w=$e([se(1,a.$Eo),se(2,a.$Bo)],w)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;let u=class extends R.$Tc{static{m=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Ig)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$Co(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const I=l;if(s=I.code,I.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${I.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(O){this.r.error(O)}throw new w.$Co(E.$Np,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,h.$Pf)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Ig)(this.extensionsDownloadDir,`${this.z(i)}${m.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$Co(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==L.Schemas.file){await t(r);return}const n=(0,A.$Ig)(this.extensionsDownloadDir,`.${(0,a.$rg)()}`);await this.h.exists(n)||await t(n);try{await v.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith(m.c))n.push(l.resource);else{const I=P.$4o.parse(l.name);I&&t.push([I,l])}const s=(0,P.$9o)(t,([l])=>l),o=[];for(const l of s)l.sort((I,O)=>k.rcompare(I[0].version,O[0].version)),r.push(...l.slice(1).map(I=>I[1].resource)),o.push(l[0][1]);o.sort((l,I)=>l.mtime-I.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await N.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?P.$4o.create(i).toString().toLowerCase():(0,a.$rg)()}};e.$7p=u,e.$7p=u=m=$e([se(0,$.$di),se(1,c.$sk),se(2,w.$Bo),se(3,d.$Bi),se(4,b.$Hp),se(5,p.$pj)],u)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=void 0;class k extends D.$Tc{constructor(a,v,E,d,$,w,P){super(),this.f=a,this.g=v,this.h=E,this.j=d,this.m=$,this.n=w,this.r=P,this.a=this.B(new N.$Wd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,b=>P.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(v=>(this.c.set(v.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(v.extensionsResource)),this.n.watch(v.extensionsResource))),this.G(v.extensionsResource))))}catch(v){throw this.r.error(v),v}}async w(a){for(const v of a.extensions)this.I(this.L(v.identifier,v.version),a.profileLocation)}async y(a){for(const v of a.extensions){const E=this.L(v.identifier,v.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const v of a.extensions)this.J(this.L(v.identifier,v.version),a.profileLocation)}async C(a){const v=[],E=[];for(const d of a.extensions){const $=this.L(d.identifier,d.version);a.error?this.I($,a.profileLocation):(this.J($,a.profileLocation),this.b.has($)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?v.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(E),v.length&&await this.H(v)}catch(d){this.r.error(d)}}D(a){for(const v of this.h.profiles)a.contains(v.extensionsResource,0,1)&&this.F(v.extensionsResource)}async F(a){const v=[],E=[],d=await this.j.scanProfileExtensions(a),$=new Set,w=new Set;for(const[P,b]of this.b)b.has(a)&&w.add(P);for(const P of d){const b=this.L(P.identifier,P.version);$.add(b),w.has(b)||(v.push(P.identifier),this.I(b,a))}for(const P of w)if(!$.has(P)){const b=this.M(P);b&&(E.push(b.identifier),this.J(P,a))}(v.length||E.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const v=await this.j.scanProfileExtensions(a);for(const E of v)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,v){let E=this.b.get(a);E||this.b.set(a,E=new R.$Bc(d=>this.m.extUri.getComparisonKey(d))),E.add(v)}J(a,v){const E=this.b.get(a);E&&E.delete(v),E?.size||this.b.delete(a)}L(a,v){return`${A.$nm.toKey(a.id)}@${v}`}M(a){const[v,E]=(0,L.$5o)(a);return E?{identifier:{id:v},version:E}:void 0}}e.$$p=k}),define(ie[146],ne([0,1,117,41]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function R(L,A,k,h,a,v,E){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`};if((0,D.$Uo)(A,k)&&(0,D.$Wo)(h)===3){const $=await(0,N.$Cp)(k,a,v);d["X-Market-User-Id"]=$,d["VSCode-SessionId"]=E.machineId||$}return d}e.$Dp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let P=class extends $.$kr{constructor(m,u,g,i){super(g),this.h=m,this.j=i,this.g=this.B(new b(u,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(m,u){const i=(await this.g.getLanguagePacks())[u];if(!i){this.j.warn(`No language pack found for ${u}`);return}const r=i.translations[m];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),u=Object.keys(m).map(g=>{const i=m[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return u.push(this.f("en","English")),u.sort((g,i)=>g.label.localeCompare(i.label)),u}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const u=await this.g.getLanguagePacks();Object.keys(u).some(g=>u[g]&&u[g].extensions.some(i=>(0,E.$3o)(i.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,u]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(u);return!(0,D.$ub)(Object.keys(m),Object.keys(g))}};e.$lr=P,e.$lr=P=$e([se(0,v.$Eo),se(1,a.$di),se(2,v.$Bo),se(3,d.$pj)],P);let b=class extends L.$Tc{constructor(m,u){super(),this.j=u,this.c={},this.f=(0,k.$jc)(m.userDataPath,"languagepacks.json"),this.g=new R.$ch}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(u=>{Object.keys(u).forEach(g=>delete u[g]),this.m(u,...m)}).then(()=>this.c)}m(m,...u){for(const g of u)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(m,g);Object.keys(m).forEach(g=>this.r(m[g]))}n(m,u){const g=u.identifier,i=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const r of i)if(u.location.scheme===A.Schemas.file&&c(r)){let t=m[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$3o)(s.extensionIdentifier,g))[0];n?n.version=u.manifest.version:t.extensions.push({extensionIdentifier:g,version:u.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,k.$jc)(u.location.fsPath,s.path)}}r(m){if(m){const u=(0,N.createHash)("md5");for(const g of m.extensions)u.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=u.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let u=null;return h.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(u=m(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),h.Promises.writeFile(this.f,i)}).then(()=>u,g=>this.j.error(g))})}};b=$e([se(0,a.$di),se(1,d.$pj)],b);function c(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const m of p.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function h(v,E,d){const $=await(0,N.$jD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,N.$jD)("@microsoft/1ds-post-js","dist/ms.post.js"),P=new $.AppInsightsCore,b=new w.PostChannel,c={instrumentationKey:v,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(d){c.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[b.identifier]=p}return P.initialize(c,[]),P.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),P}class a{constructor(E,d,$,w,P){this.e=E,this.f=d,this.g=$,this.h=P,this.c=A,this.d=k,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,D.$1)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,R.$Bn)(d,this.g),d=(0,L.$Xo)(d);const $=this.f+"/"+E;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:$,baseData:{name:$,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$yO=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,p,m){this.k=p,this.l=m,this.d={},this.i=new N.$Sc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const u of this.f)this.j.push(new RegExp((0,L.$Pe)(u),"gi")),u.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Pe)(u.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(u=>{(u.affectsConfiguration(d.$El)||u.affectsConfiguration(d.$Gl)||u.affectsConfiguration(d.$Fl))&&this.m()}))}setExperimentProperty(c,p){this.d[c]=p}m(){let c=(0,$.$Wo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const m=p.usage?3:p.error?2:0;c=Math.min(c,m)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,p,m){this.g<p||(m=(0,D.$Bn)(m,this.d),m=(0,$.$2o)(m,this.j),m=(0,D.$Bn)(m,this.c),this.b.forEach(u=>u.log(c,m)))}publicLog(c,p){this.n(c,3,p)}publicLog2(c,p){this.publicLog(c,p)}publicLogError(c,p){this.h&&this.n(c,2,p)}publicLogError2(c,p){this.publicLogError(c,p)}};e.$rr=w,e.$rr=w=$e([se(1,k.$Bi),se(2,v.$Hj)],w);function P(){const b=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=R.$o?"":(0,A.localize)(3,null),m=(0,A.localize)(4,null),u=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${m} | ${u} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${b} ${c} ${p}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Kn.as(h.$Pn.Configuration).registerConfiguration({id:d.$Dl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[d.$El]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:P(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Kn.as(h.$Pn.Configuration).registerConfiguration({id:d.$Dl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[d.$Gl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${d.$El}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,N,D,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;async function A(v,E){const d=await E.request(v,D.CancellationToken.None),$=(await(0,N.$we)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:$}}async function k(v){const E={method:v.type,headers:v.headers};return new Promise(($,w)=>{const P=R.request(v.url??"",E,b=>{b.on("data",function(c){$({headers:b.headers,statusCode:b.statusCode??200,responseData:c.toString()})}),b.on("error",function(c){w(c)})});P.write(v.data,b=>{b&&w(b)}),P.end()})}async function h(v,E,d){const $=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),w={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:$};try{const P=v?await A(w,v):await k(w);d(P.statusCode,P.headers,P.responseData)}catch{d(0,{})}}class a extends L.$yO{constructor(E,d,$,w,P){const b={sendPOST:(c,p)=>{h(E,c,p)}};super(d,$,w,P,b)}}e.$zO=a}),define(ie[152],ne([0,1,16,24]),function(J,e,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0;async function R(L,A){const k=Object.create(null),h=(v,E)=>{const d=JSON.parse(v);k[E]=d};if(A){const v=[],E=await D.Promises.readdir(A);for(const $ of E)try{(await D.Promises.stat((0,N.$jc)(A,$))).isDirectory()&&v.push($)}catch{}const d=[];for(const $ of v)(await D.Promises.readdir((0,N.$jc)(A,$))).filter(P=>P==="telemetry.json").length===1&&d.push($);for(const $ of d){const w=(await D.Promises.readFile((0,N.$jc)(A,$,"telemetry.json"))).toString();h(w,$)}}let a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-core.json"))).toString();return h(a,"vscode-core"),a=(await D.Promises.readFile((0,N.$jc)(L,"telemetry-extensions.json"))).toString(),h(a,"vscode-extensions"),JSON.stringify(k,null,4)}e.$m_b=R}),define(ie[153],ne([0,1,12,84,25]),function(J,e,N,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=void 0;async function L(k,h){let a=k.getItem(R.$Bl);return(typeof a!="string"||N.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$bn)(h.error.bind(h))),a}e.$C$b=L;async function A(k,h){let a=k.getItem(R.$Cl);return typeof a!="string"&&(a=await(0,D.$cn)(h.error.bind(h))),a}e.$D$b=A}),define(ie[22],ne([0,1,10]),function(J,e,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=void 0,e.$3k=(0,N.$8h)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let v=class{constructor(d){this.g=d,this.c=new h.$Sc,this.f=2**16;const $=new Map,w=P=>{let b=$.get(P.scheme);return b===void 0&&(b=d.hasProvider(P)&&!this.g.hasCapability(P,1024),$.set(P.scheme,b)),b};this.c.add(k.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(P=>{$.delete(P.scheme)})),this.extUri=new L.$xg(w),this.d=new A.$3r((P,b)=>this.extUri.compare(P,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,L.$Jg)(d));const $=this.d.get(d);return $?$.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,P)=>w[1].time<P[1].time?1:w[1].time>P[1].time?-1:0);a._clock=0,this.d.clear();const $=this.f*.5;for(let w=0;w<$;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$4r=v,e.$4r=v=$e([se(0,R.$sk)],v),(0,D.$1r)(N.$3k,v,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,N,D,R,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=void 0;class k extends D.$Tc{constructor(a,v,E,d,$,w){super(),this.f=a,this.g=v,this.h=E,this.j=d,this.m=$,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new N.$Wd),this.onDidChangeFile=this.a.event,this.b=L.$bi.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(P=>this.m.extUri.getComparisonKey(this.t(P))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(P=>this.s(P)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,v){return this.g.open(this.t(a),v)}close(a){return this.g.close(a)}read(a,v,E,d,$){return this.g.read(a,v,E,d,$)}write(a,v,E,d,$){return this.g.write(a,v,E,d,$)}watch(a,v){this.b.set(a,a);const E=this.g.watch(this.t(a),v);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,v,E){return this.g.rename(this.t(a),this.t(v),E)}readFile(a,v){return this.g.readFile(this.t(a),v)}readFileStream(a,v,E){return this.g.readFileStream(this.t(a),v,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,v,E){return this.g.writeFile(this.t(a),v,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,v){return this.g.delete(this.t(a),v)}copy(a,v,E){if((0,R.$wk)(this.g))return this.g.copy(this.t(a),this.t(v),E);throw new Error("copy not supported")}cloneFile(a,v){if((0,R.$xk)(this.g))return this.g.cloneFile(this.t(a),this.t(v));throw new Error("clone not supported")}s(a){const v=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const d=this.u(E.resource);this.b.findSubstr(d)&&v.push({resource:d,type:E.type,cId:E.cId})}v.length&&(this.n.debug("User data changed"),this.a.fire(v))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$1$b=k}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,N,D,R,L,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,k.$8h)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$fi=a;function v(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$gi=v,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$hi:e.$ii;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$ji=E;function d(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$ki=d;function $(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$li=$;var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function P(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$mi=P;function b(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$ni=b;class c{constructor(s,o,l,I,O){this.h=s,this.j=l,this.k=I,this.l=O,this.c=R.$bi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=R.$bi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=c;class p{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$Ig)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=p;function m(n){return new p({uri:n,index:0,name:(0,L.$Eg)(n)},{uri:n.toString()})}e.$qi=m,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,N.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function u(n,s){return L.$zg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$vi=u;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===h.Schemas.tmp}e.$wi=g,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$xi}e.$yi=i;function r(n,s){return!u(n,s)&&!g(n)}e.$zi=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,L.$Gg)(n))===e.$si}e.$Ai=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.ProfileResourceType=void 0;var m;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function u(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$4k=u,e.$5k=(0,v.$8h)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$6k=g;function i(n,s,o,l,I,O){return{id:n,name:s,location:o,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:O&&I?.useDefaultFlags?.globalState?O.globalStorageHome:(0,L.$Ig)(o,"globalStorage"),settingsResource:O&&I?.useDefaultFlags?.settings?O.settingsResource:(0,L.$Ig)(o,"settings.json"),keybindingsResource:O&&I?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,L.$Ig)(o,"keybindings.json"),tasksResource:O&&I?.useDefaultFlags?.tasks?O.tasksResource:(0,L.$Ig)(o,"tasks.json"),snippetsHome:O&&I?.useDefaultFlags?.snippets?O.snippetsHome:(0,L.$Ig)(o,"snippets"),extensionsResource:O&&I?.useDefaultFlags?.extensions?O.extensionsResource:(0,L.$Ig)(o,"extensions.json"),cacheHome:(0,L.$Ig)(l,n),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$7k=i;let r=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,I){super(),this.t=s,this.u=o,this.w=l,this.y=I,this.f=!0,this.h=this.B(new D.$Wd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Wd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Wd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Wd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new $.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,p.$Jf)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}o.push(i((0,L.$Fg)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},s))}}catch(O){this.y.error(O)}const l=new $.$Ac,I=new Map;if(o.length)try{const O=this.Q();if(O.workspaces)for(const[y,j]of Object.entries(O.workspaces)){const W=A.URI.parse(y),te=o.find(_=>_.id===j);te&&l.set(W,te)}if(O.emptyWindows)for(const[y,j]of Object.entries(O.emptyWindows)){const W=o.find(te=>te.id===j);W&&I.set(y,W)}}catch(O){this.y.error(O)}this.z={profiles:o,workspaces:l,emptyWindows:I}}return this.z}D(){const s=i("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Pe)(o)}\\s(\\d+)`);let I=0;for(const y of this.profiles){const j=l.exec(y.name),W=j?parseInt(j[1]):0;I=W>I?W:I}const O=`${o} ${I+1}`;return this.createProfile((0,N.$Vi)((0,b.$rg)()).toString(16),O,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,N.$Vi)((0,b.$rg)()).toString(16),s,o,l)}async createProfile(s,o,l,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(s,o,l);return I&&await this.setProfileForWorkspace(I,O),O}async F(s,o,l){if(!(0,p.$Jf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(o);return I||(I=(async()=>{try{const O=this.profiles.find(W=>W.name===o||W.id===s);if(O)return O;const y=i(s,o,(0,L.$Ig)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(y.location);const j=[];return this.j.fire({profile:y,join(W){j.push(W)}}),await P.Promises.settled(j),this.I([y],[],[]),y}finally{this.r.delete(o)}})(),this.r.set(o,I)),I}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(I=>I.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(I){l.push(I)}});try{await Promise.allSettled(l)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(I){(0,a.$Jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(I=>I.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$fi)(s)?s.uri:(0,d.$ki)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const I=[...this.profiles,...s],O=[];this.s.profiles=[];for(let y of I)y.isDefault||o.some(j=>y.id===j.id)||(y=l.find(j=>y.id===j.id)??y,y.isTransient?this.s.profiles.push(y):O.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(O),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const I=this.G(s),O=l?this.s:this.C;A.URI.isUri(I)?(O.workspaces.delete(I),o&&O.workspaces.set(I,o)):(O.emptyWindows.delete(I),o&&O.emptyWindows.set(I,o)),l||this.M()}M(){const s={};for(const[l,I]of this.C.workspaces.entries())s[l.toString()]=I.id;const o={};for(const[l,I]of this.C.emptyWindows.entries())o[l.toString()]=I.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[O,y]of Object.entries(s.workspaces)){const j=A.URI.parse(y);o[O]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}const I={};if(s.emptyWindows)for(const[O,y]of Object.entries(s.emptyWindows)){const j=A.URI.parse(y);I[O]=this.w.extUri.isEqual(j,l.location)?l.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:I}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$8k=r,e.$8k=r=$e([se(0,h.$ci),se(1,a.$sk),se(2,w.$3k),se(3,E.$pj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$9k=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=e.$Tp=e.$Sp=void 0;let u=class extends k.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,I,O,y){super(),this.z=s,this.C=o,this.D=l,this.F=I,this.G=O,this.H=y,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Wd),this.s=this.B(new A.$Wd),this.t=this.B(new A.$Wd),this.u=this.B(new A.$Wd),this.w=this.B(new A.$Wd),this.y=[],this.B((0,k.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$zo)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const I=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:O})=>(0,$.$3o)(O,s.identifier));if(I?.local)return I?.local;throw I?.error?I.error:new d.$Co(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$Co(E.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:I,options:O})=>{try{const y=await this.O(I,!!O?.installGivenVersion,!!O?.installPreReleaseVersion);l.push({...y,options:O})}catch(y){o.push({identifier:I.identifier,operation:2,source:I,error:y})}})),l.length&&o.push(...await this.I(l));for(const I of o)I.error&&(this.F.error("Failed to install extension.",I.identifier.id),this.F.error(I.error),I.source&&!v.URI.isUri(I.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,$.$$o)(I.source),error:I.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.Q(s,o)}async toggleAppliationScope(s,o){if((0,w.$qm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.ab(s,this.H.defaultProfile.extensionsResource,o));for(const I of this.H.profiles){const O=(await this.getInstalled(1,I.extensionsResource)).find(y=>(0,$.$3o)(y.identifier,s.identifier));O?this.w.fire(O):this.u.fire({identifier:s.identifier,profileLocation:I.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.X(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[];return await Promise.allSettled(s.map(async l=>{try{const I=await this.J(l,(O,y)=>s.some(j=>(0,$.$7o)(y.identifier.id)===(0,$.$8o)(j.manifest.publisher,j.manifest.name))?!1:this.L(O,y));o.push(...I)}catch(I){o.push({identifier:{id:(0,$.$8o)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:I})}})),this.s.fire(o),o}async J({manifest:s,extension:o,options:l},I){const O=l.isApplicationScoped||l.isBuiltin||(0,w.$qm)(s),y={...l,installOnlyNewlyAddedFromExtensionPack:v.URI.isUri(o)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:O,profileLocation:O?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},j=he=>`${$.$4o.create(he).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!v.URI.isUri(o)){const he=this.j.get(j(o));if(he)return this.F.info("Extensions is already requested to install",o.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const W=[],te=[],_=[],oe=this.Z(s,o,y);v.URI.isUri(o)||this.j.set(j(o),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:o,profileLocation:y.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),W.push({task:oe,manifest:s});let re=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,s,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),ae=await this.getInstalled(void 0,y.profileLocation),q={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[d.$uo]:!0}};for(const{gallery:Z,manifest:M}of(0,N.$Mb)(ce,({gallery:U})=>U.identifier.id)){re=re||!!M.extensionDependencies?.some(X=>(0,$.$3o)({id:X},oe.identifier));const U=j(Z),V=this.j.get(U);if(V){if(I(oe,V.task)){const X=V.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,oe.identifier.id),V.waitingTasks.push(oe),te.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Y=>Y.some(Q=>(0,$.$3o)(Q.identifier,X)))).then(Y=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,oe.identifier.id),!Y.find(F=>(0,$.$3o)(F.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else if(!ae.some(({identifier:X})=>(0,$.$3o)(X,Z.identifier))){const X=this.Z(M,Z,q);this.j.set(U,{task:X,waitingTasks:[oe]}),this.n.fire({identifier:X.identifier,source:Z,profileLocation:y.profileLocation}),this.F.info("Installing extension:",X.identifier.id,oe.identifier.id),W.push({task:X,manifest:M})}}}catch(ce){if(v.URI.isUri(oe.source))(0,N.$Lb)(s.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,N.$Lb)(s.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const he=W.reduce((ce,{task:ae,manifest:q})=>(ce.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:q}),ce),new Map);for(;he.size;){let ce;const ae=[...he.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(Z=>he.has(Z.toLowerCase())));ae.length?ce=he.size===1?ae:ae.filter(({task:q})=>!(q===oe&&!re)):(this.F.info("Found extensions with circular dependencies",ae.map(({task:q})=>q.identifier.id)),ce=[...he.values()]),await this.M(ce.map(async({task:q})=>{const Z=new Date().getTime();try{const M=await q.run();if(await this.M(this.y.map(U=>U.postInstall(M,q.source,y,R.CancellationToken.None))),!v.URI.isUri(q.source)){const U=q.operation===3,V=U?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$$o)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:V}),h.$o&&q.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}_.push({local:M,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw this.F.error("Error while installing the extension",q.identifier.id,(0,L.$0)(M)),M}finally{he.delete(q.identifier.id.toLowerCase())}}))}return te.length&&await this.M(te),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(he){if(W.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:ae})=>this.$(ae,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let ae=0;ae<ce.length;ae++){const q=ce[ae],{identifier:Z}=_[ae];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Z.id):this.F.warn("Rollback: Error while uninstalling extension",Z.id,(0,L.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,L.$0)(ce),_.map(({identifier:ae})=>ae.id))}return W.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:y.context,profileLocation:y.profileLocation,error:he}))}finally{for(const{task:he}of W)he.source&&!v.URI.isUri(he.source)&&this.j.delete(j(he.source))}}L(s,o){for(const[,{task:l,waitingTasks:I}]of this.j.entries())if(l===s&&(I.includes(o)||I.some(O=>this.L(O,o)))||l===o&&I[0]&&!this.L(s,I[0]))return!1;return!0}async M(s){const o=[],l=[],I=await Promise.allSettled(s);for(const O of I)O.status==="fulfilled"?o.push(O.value):l.push(O.reason);if(l.length)throw g(l);return o}async N(s,o,l,I,O){if(!this.z.isEnabled())return[];const y=await this.getInstalled(void 0,O),j=[],W=[],te=async(_,oe)=>{j.push(_);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const ce=l?y.find(ae=>(0,$.$3o)(ae.identifier,_)):void 0;for(const ae of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,$.$3o)({id:q},{id:ae}))||he.every(q=>!(0,$.$3o)({id:q},{id:ae}))&&he.push(ae)}if(he.length){const ce=he.filter(ae=>j.every(q=>!(0,$.$3o)(q,{id:ae})));if(ce.length){const ae=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:I})),R.CancellationToken.None);for(const q of ae){if(j.find(U=>(0,$.$3o)(U,q.identifier)))continue;const Z=re.some(U=>(0,$.$3o)({id:U},q.identifier));let M;try{M=await this.O(q,!1,I)}catch(U){if(Z)throw U;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,L.$0)(U));continue}W.push({gallery:M.extension,manifest:M.manifest}),await te(M.extension.identifier,M.manifest)}}}};return await te(s,o),W}async O(s,o,l){let I;const O=await this.getExtensionsControlManifest();if(O.malicious.some(W=>(0,$.$3o)(s.identifier,W)))throw new d.$Co(E.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const y=O.deprecated[s.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!I)throw new d.$Co(E.localize(2,null,s.identifier.id,y.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const W=await this.getTargetPlatform();throw new d.$Co(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$vo)(W)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.P(s,o,l),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new d.$Co(E.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Co(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const j=await this.z.getManifest(I,R.CancellationToken.None);if(j===null)throw new d.$Co(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(j.version!==I.version)throw new d.$Co(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:j}}async P(s,o,l){const I=await this.getTargetPlatform();let O=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(O=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null),!O&&await this.z.isExtensionCompatible(s,l,I)&&(O=s),O||(o?O=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null:O=await this.z.getCompatibleExtension(s,l,I)),O}async Q(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},I=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,O=this.m.get(I(s.identifier));if(O)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),O.waitUntilTaskIsFinished();const y=_=>{const oe=this.$(_,l);return this.m.set(I(oe.extension.identifier),oe),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),oe},j=(_,oe)=>{oe?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,oe.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$0o)(_),error:oe}),this.u.fire({identifier:_.identifier,error:oe?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},W=[],te=[];try{W.push(y(s));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.U(s,_);for(const re of oe)this.m.has(I(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):W.push(y(re))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.R(W.map(oe=>oe.extension),_,s),await this.M(W.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(re=>re.postUninstall(oe.extension,l,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof d.$Co?re:new d.$Co((0,L.$0)(re),d.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{te.push(oe)}}))}catch(_){const oe=_ instanceof d.$Co?_:new d.$Co((0,L.$0)(_),d.ExtensionManagementErrorCode.Internal);for(const re of W){try{re.cancel()}catch{}te.includes(re)||j(re.extension,oe)}throw oe}finally{for(const _ of W)this.m.delete(I(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(s,o,l){for(const I of s){const O=this.W(I,o);if(O.length){const y=O.filter(j=>!s.some(W=>(0,$.$3o)(W.identifier,j.identifier)));if(y.length)throw new Error(this.S(I,y,l))}}}S(s,o,l){return l===s?o.length===1?E.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}U(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const I=s.manifest.extensionPack?s.manifest.extensionPack:[];if(I.length){const O=o.filter(j=>!j.isBuiltin&&I.some(W=>(0,$.$3o)({id:W},j.identifier))),y=[];for(const j of O)y.push(...this.U(j,o,l));return[...O,...y]}return[]}W(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(I=>(0,$.$3o)({id:I},s.identifier)))}async X(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$Sp=u,e.$Sp=u=$e([se(0,d.$Bo),se(1,c.$wl),se(2,p.$3k),se(3,P.$pj),se(4,b.$Hj),se(5,m.$5k)],u);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$Tp=g;function i(n){if(n instanceof d.$Co)return n;if(n instanceof d.$Do){const o=new d.$Co(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$Co(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$Up=i;function r(n,s,{extensionData:o,verificationStatus:l,duration:I,error:O,durationSinceUpdate:y}){let j,W;(0,a.$Rf)(l)&&(l===!0?l="Verified":(l===!1||(j=d.ExtensionManagementErrorCode.Signature,W=l),l="Unverified")),O&&(O instanceof d.$Co||O instanceof d.$Do?(j=O.code,O.code===d.ExtensionManagementErrorCode.Signature&&(W=O.message)):j=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!O,duration:I,errorcode:j,errorcodeDetail:W,durationSinceUpdate:y})}class t{constructor(){this.d=new D.$7g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Ug)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Ug)(s=>new Promise((o,l)=>{const I=s.onCancellationRequested(()=>{I.dispose(),l(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$Vp=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class m extends Error{constructor(t,n){super(t),this.code=n}}e.$Wp=m,e.$Xp=(0,E.$8h)("IExtensionsProfileScannerService");let u=class extends R.$Tc{constructor(t,n,s,o,l,I){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=I,this.b=this.B(new L.$Wd),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Wd),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Wd),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Wd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,l=>{const I=[];for(const O of l)t.some(([y])=>(0,a.$3o)(y.identifier,O.identifier)&&y.manifest.version!==O.version)?s.push(O):I.push(O);for(const[O,y]of t){const j=I.findIndex(te=>(0,a.$3o)(te.identifier,O.identifier)&&te.version===O.manifest.version),W={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:y};j===-1?(o.push(W),I.push(W)):I.splice(j,1,W)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),I}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:l,profileLocation:n}),l}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const I of o){const O=t.find(([y])=>(0,a.$3o)(y.identifier,I.identifier)&&y.manifest.version===I.version);O&&(I.metadata={...I.metadata,...O[1]},s.push(I)),l.push(I)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const I of o)(0,a.$3o)(I.identifier,t.identifier)?s.push(I):l.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const I=await this.m.readFile(t);l=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,v.$Jk)(I)!==1)throw I;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new m((0,b.$0)(I),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let I=!1;for(const O of l){g(O)||this.w(t);let y;if((0,P.$Jf)(O.relativeLocation)&&O.relativeLocation)y=this.z(O.relativeLocation);else if((0,P.$Jf)(O.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${O.location}`);continue}else{y=k.URI.revive(O.location);const j=this.y(y);j&&(I=!0,O.relativeLocation=j)}(0,P.$Qf)(O.metadata?.hasPreReleaseVersion)&&O.metadata?.preRelease&&(I=!0,O.metadata.hasPreReleaseVersion=!0),o.push({identifier:O.identifier,location:y,version:O.version,metadata:O.metadata})}I&&await this.m.writeFile(t,D.$ke.fromString(JSON.stringify(l)))}if(n){o=n(o);const I=o.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(t,D.$ke.fromString(JSON.stringify(I)))}return o})}w(t){const n=new m(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,v.$Jk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(I=>g(I))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$ke.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,v.$Jk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,v.$Jk)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,v.$Jk)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new N.$ch,this.h.set(t,n)),n}};e.$Yp=u,e.$Yp=u=$e([se(1,v.$sk),se(2,$.$5k),se(3,w.$3k),se(4,c.$wl),se(5,d.$pj)],u);function g(r){return(0,P.$Lf)(r)&&(0,h.$Ao)(r.identifier)&&(i(r.location)||(0,P.$Jf)(r.location)&&r.location)&&((0,P.$Qf)(r.relativeLocation)||(0,P.$Jf)(r.relativeLocation))&&r.version&&(0,P.$Jf)(r.version)}function i(r){return r?(0,P.$Jf)(r.path)&&(0,P.$Jf)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,I,O,y,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.Translations=void 0;var W;(function(ae){function q(Z,M){if(Z===M)return!0;const U=Object.keys(Z),V=new Set;for(const X of Object.keys(M))V.add(X);if(U.length!==V.size)return!1;for(const X of U){if(Z[X]!==M[X])return!1;V.delete(X)}return V.size===0}ae.equals=q})(W||(e.Translations=W={})),e.$2p=(0,t.$8h)("IExtensionsScannerService");let te=class extends a.$Tc{constructor(q,Z,M,U,V,X,Y,Q,F,C,f,S){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=Z,this.r=M,this.s=U,this.t=V,this.u=X,this.w=Y,this.y=Q,this.z=F,this.C=C,this.D=f,this.F=S,this.g=this.B(new o.$Wd),this.onDidChangeCache=this.g.event,this.h=(0,$.$Ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,u.$bp)(this.w,this.y)),this.G}async scanAllExtensions(q,Z,M){const[U,V]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(Z)]),X=M?await this.scanExtensionsUnderDevelopment(q,[...U,...V]):[];return this.L(U,V,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const Z=[];Z.push(this.M(!!q.useCache,q.language)),Z.push(this.N(q.language,!!q.checkControlFile));const[M,U]=await Promise.all(Z);return this.J([...M,...U],0,q,!1)}async scanUserExtensions(q){const Z=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const M=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(Z,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,M),V=q.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let X;try{X=await V.scanExtensions(U)}catch(Y){if(Y instanceof I.$Wp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await V.scanExtensions(U);else throw Y}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===v.Schemas.file).map(async U=>{const V=await this.P(U,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(Y=>(Y.type=Z.find(Q=>(0,u.$3o)(Q.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,V)))}))).flat();return this.J(M,"development",q,!0)}return[]}async scanExistingExtension(q,Z,M){const U=await this.P(q,!1,Z,!0,M.language,!0,void 0),V=await this.n.scanExtension(U);return!V||!M.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(q,Z,M){const U=await this.P(q,!1,Z,!0,M.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(U);return this.J(V,Z,M,!0)}async scanMetadata(q){const Z=(0,$.$Ig)(q,"package.json"),M=(await this.w.readFile(Z)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(q,Z){const M=(0,$.$Ig)(q,"package.json"),U=(await this.w.readFile(M)).value.toString(),V=JSON.parse(U);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,V.__metadata={...V.__metadata,...Z},await this.w.writeFile((0,$.$Ig)(q,"package.json"),L.$ke.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof I.$Wp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ke.fromString(JSON.stringify([])))}catch(Z){(0,r.$Jk)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,Z,M,U){return M.includeAllVersions||(q=this.L(Z===0?q:void 0,Z===1?q:void 0,Z==="development"?q:void 0,await this.getTargetPlatform(),U)),M.includeInvalid||(q=q.filter(V=>V.isValid)),q.sort((V,X)=>{const Y=E.$nc(V.location.fsPath),Q=E.$nc(X.location.fsPath);return Y<Q?-1:Y>Q?1:0})}L(q,Z,M,U,V){const X=(Q,F,C)=>{if(Q.isValid&&!F.isValid)return!1;if(Q.isValid===F.isValid){if(V&&w.gt(Q.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${Q.location.path} with version ${Q.manifest.version}`),!1;if(w.eq(Q.manifest.version,F.manifest.version)){if(Q.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${Q.location.path} with same version`),!1;if(Q.targetPlatform===U)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${Q.location.path} with ${F.location.path}.`),!0},Y=new g.$pm;return q?.forEach(Q=>{const F=Y.get(Q.identifier.id);(!F||X(F,Q,!1))&&Y.set(Q.identifier.id,Q)}),Z?.forEach(Q=>{const F=Y.get(Q.identifier.id);if(!F&&q&&Q.type===0){this.y.debug(`Skipping obsolete system extension ${Q.location.path}.`);return}(!F||X(F,Q,!1))&&Y.set(Q.identifier.id,Q)}),M?.forEach(Q=>{const F=Y.get(Q.identifier.id);(!F||X(F,Q,!0))&&Y.set(Q.identifier.id,Q),Y.set(Q.identifier.id,Q)}),[...Y.values()]}async M(q,Z){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),V=await(q&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",V.length),V}async N(q,Z){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const U=Z?await this.O():{},V=[],X=c.URI.file(E.$hc(E.$jc(v.$pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const Q of M){const F=U[Q.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":V.push((0,$.$Ig)(X,Q.name));break;default:V.push(c.URI.file(F));break}}const Y=await Promise.all(V.map(async Q=>this.n.scanExtension(await this.P(Q,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,N.$Hb)(Y)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,Z,M,U,V,X,Y){const Q=await this.f(V??d.$w),F=await this.Q(q),C=Z&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,f=C?await this.Q(C):void 0;return new _(q,F,C,f,Z,Y,M,U,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,Q)}async Q(q){try{const Z=await this.w.stat(q);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$3p=te,e.$3p=te=$e([se(4,O.$5k),se(5,I.$Xp),se(6,r.$sk),se(7,n.$pj),se(8,m.$ci),se(9,s.$Hj),se(10,y.$3k),se(11,t.$7h)],te);class _{constructor(q,Z,M,U,V,X,Y,Q,F,C,f,S,z,T,H){this.location=q,this.mtime=Z,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=U,this.profile=V,this.profileScanOptions=X,this.type=Y,this.excludeObsolete=Q,this.validate=F,this.productVersion=C,this.productDate=f,this.productCommit=S,this.devMode=z,this.language=T,this.translations=H}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,Z){return(0,$.$Bg)(q.location,Z.location)&&q.mtime===Z.mtime&&(0,$.$Bg)(q.applicationExtensionslocation,Z.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&q.profile===Z.profile&&R.$Cn(q.profileScanOptions,Z.profileScanOptions)&&q.type===Z.type&&q.excludeObsolete===Z.excludeObsolete&&q.validate===Z.validate&&q.productVersion===Z.productVersion&&q.productDate===Z.productDate&&q.productCommit===Z.productCommit&&q.devMode===Z.devMode&&q.language===Z.language&&W.equals(q.translations,Z.translations)}}e.$4p=_;let oe=class extends a.$Tc{constructor(q,Z,M,U,V){super(),this.f=q,this.g=Z,this.h=M,this.j=U,this.m=V}async scanExtensions(q){const Z=q.profile?await this.r(q):await this.n(q);let M={};if(q.excludeObsolete&&q.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(U)}catch{}return(0,b.$Wf)(M)?Z:Z.filter(U=>!M[u.$4o.create(U).toString()])}async n(q){const Z=await this.j.resolve(q.location);if(!Z.children?.length)return[];const M=await Promise.all(Z.children.map(async U=>{if(!U.isDirectory||q.type===1&&(0,$.$Fg)(U.resource).indexOf(".")===0)return null;const V=new _(U.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(V)}));return(0,N.$Hb)(M).sort((U,V)=>U.location.path<V.location.path?-1:1)}async r(q){let Z=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){Z=Z.filter(U=>!U.metadata?.isApplicationScoped);const M=await this.s(q.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,q);Z.push(...M)}return Z}async s(q,Z,M){const U=await this.g.scanProfileExtensions(q,M.profileScanOptions);if(!U.length)return[];const V=await Promise.all(U.map(async X=>{if(Z(X)){const Y=new _(X.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Y,X.metadata)}return null}));return(0,N.$Hb)(V)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,$.$Ig)(q.location,"package.json"))){const Z=await this.scanExtension(q);return Z?[Z]:[]}else return await this.scanExtensions(q)}catch(Z){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,A.$0)(Z)),[]}}async scanExtension(q,Z){try{let M=await this.scanExtensionManifest(q.location);if(M){M.publisher||(M.publisher=g.$jm),Z=Z??M.__metadata,delete M.__metadata;const U=(0,u.$8o)(M.publisher,M.name),V=Z?.id?{id:U,uuid:Z.id}:{id:U},X=Z?.isSystem?0:q.type,Y=X===0||!!Z?.isBuiltin;M=await this.t(q.location,M,_.createNlsConfiguration(q));const Q={type:X,identifier:V,manifest:M,location:q.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return q.validate?this.validate(Q,q):Q}}catch(M){q.type!==0&&this.m.error(M)}return null}validate(q,Z){let M=!0;const U=(0,i.$gp)(Z.productVersion,Z.productDate,Z.location,q.manifest,q.isBuiltin);for(const[V,X]of U)V===P.default.Error&&(M=!1,this.m.error(this.z(Z.location,X)));return q.isValid=M,q.validations=U,q}async scanExtensionManifest(q){const Z=(0,$.$Ig)(q,"package.json");let M;try{M=(await this.j.readFile(Z)).value.toString()}catch(V){return(0,r.$Jk)(V)!==1&&this.m.error(this.z(q,(0,p.localize)(0,null,Z.path,V.message))),null}let U;try{U=JSON.parse(M)}catch{const X=[];(0,k.$fn)(M,X);for(const Y of X)this.m.error(this.z(q,(0,p.localize)(1,null,Z.path,Y.offset,Y.length,(0,h.$Zp)(Y.error))));return null}return(0,k.$on)(U)!=="object"?(this.m.error(this.z(q,(0,p.localize)(2,null,Z.path))),null):U}async t(q,Z,M){const U=await this.u(q,Z,M);if(U)try{const V=[],X=await this.w(U.default,V);if(V.length>0)return V.forEach(Q=>{this.m.error(this.z(q,(0,p.localize)(3,null,U.default?.path,(0,h.$Zp)(Q.error))))}),Z;if((0,k.$on)(U)!=="object")return this.m.error(this.z(q,(0,p.localize)(4,null,U.default?.path))),Z;const Y=U.values||Object.create(null);return(0,j.$1p)(this.m,Z,Y,X)}catch{}return Z}async u(q,Z,M){const U=(0,$.$Ig)(q,"package.nls.json"),V=(F,C)=>{C.forEach(f=>{this.m.error(this.z(q,(0,p.localize)(5,null,F?.path,(0,h.$Zp)(f.error))))})},X=F=>{this.m.error(this.z(q,(0,p.localize)(6,null,F?.path)))},Y=`${Z.publisher}.${Z.name}`,Q=M.translations[Y];if(Q)try{const F=c.URI.file(Q),C=(await this.j.readFile(F)).value.toString(),f=[],S=(0,k.$fn)(C,f);return f.length>0?(V(F,f),{values:void 0,default:U}):(0,k.$on)(S)!=="object"?(X(F),{values:void 0,default:U}):{values:S.contents?S.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let C;try{C=await this.y(q,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const f=(await this.j.readFile(C.localized)).value.toString(),S=[],z=(0,k.$fn)(f,S);return S.length>0?(V(C.localized,S),{values:void 0,default:C.original}):(0,k.$on)(z)!=="object"?(X(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(q,Z){if(q)try{const M=(await this.j.readFile(q)).value.toString();return(0,k.$fn)(M,Z)}catch{}}y(q,Z){return new Promise((M,U)=>{const V=X=>{const Y=(0,$.$Ig)(q,`package.nls.${X}.json`);this.j.exists(Y).then(Q=>{Q&&M({localized:Y,original:(0,$.$Ig)(q,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?M({localized:(0,$.$Ig)(q,"package.nls.json"),original:null}):(X=X.substring(0,F),V(X))})};if(Z.devMode||Z.pseudo||!Z.language)return M({localized:(0,$.$Ig)(q,"package.nls.json"),original:null});V(Z.language)})}z(q,Z){return`[${q.path}]: ${Z}`}};oe=$e([se(1,I.$Xp),se(2,y.$3k),se(3,r.$sk),se(4,n.$pj)],oe);let re=class extends oe{constructor(q,Z,M,U,V,X,Y){super(Z,U,V,X,Y),this.G=q,this.H=M,this.D=this.B(new D.$6g(3e3)),this.F=this.B(new o.$Wd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const Z=this.M(q),M=await this.I(Z);if(this.C=q,M&&M.input&&_.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),M.result.map(V=>(V.location=c.URI.revive(V.location),V));const U=await super.scanExtensions(q);return await this.J(Z,{input:q,result:U}),U}async I(q){try{const Z=await this.j.readFile(q),M=JSON.parse(Z.value.toString());return{result:M.result,input:(0,l.$Eh)(M.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",q.path,(0,A.$0)(Z))}return null}async J(q,Z){try{await this.j.writeFile(q,L.$ke.fromString(JSON.stringify(Z)))}catch(M){this.m.debug("Error while writing the extension cache file:",q.path,(0,A.$0)(M))}}async L(){if(!this.C)return;const q=this.M(this.C),Z=await this.I(q);if(!Z)return;const M=Z.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$Cn(U,M))try{this.m.info("Invalidating Cache",M,U),await this.j.del(q),this.F.fire()}catch(V){this.m.error(V)}}M(q){const Z=this.N(q);return this.h.extUri.joinPath(Z.cacheHome,q.type===0?g.$im:g.$hm)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(q.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};re=$e([se(2,O.$5k),se(3,I.$Xp),se(4,y.$3k),se(5,r.$sk),se(6,n.$pj)],re);function he(ae,q){const Z=(0,u.$6o)(ae.manifest.publisher,ae.manifest.name);return{id:Z,identifier:new g.$nm(Z),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:q,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$5p=he;class ce extends te{constructor(q,Z,M,U,V,X,Y,Q,F,C,f,S){super(q,Z,(0,$.$Ig)(M,".vscode-oss-dev","extensions","control.json"),U,V,X,Y,Q,F,C,f,S),this.R=(async()=>{if(d.$z)try{const z=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$6p=ce}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,N,D,R,L,A,k,h,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;let d=class extends A.$Tc{constructor(w,P){super(),this.b=w,this.f=P,this.a=new D.$bh(5)}async postUninstall(w){const P=this.g(w,"uninstall");P&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(P.script,"uninstall",P.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(w))}catch(b){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(b)}}g(w,P){const b=`vscode:${P}`;if(w.location.scheme===k.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[b]=="string"){const c=w.manifest.scripts[b].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${b} should be a node script`),null):{script:(0,h.$jc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,P,b,c,p){return new Promise((m,u)=>{const g=this.j(w,P,b,p);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?u(t):m(void 0)};g.on("error",t=>{r((0,R.$Si)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${P} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),u("timed out")},5e3))})}j(w,P,b,c){const p={silent:!0,execArgv:void 0},m=(0,N.fork)(w,[`--type=extension-post-${P}`,...b],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const u=L.Event.fromNodeEventEmitter(m.stdout,"data"),g=L.Event.fromNodeEventEmitter(m.stderr,"data");u(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${P}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${P}`,t));const i=L.Event.any(L.Event.map(u,t=>({data:`%c${t}`,format:[""]})),L.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),m}m(w){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$8p=d,e.$8p=d=$e([se(0,E.$5k),se(1,v.$pj)],d)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,I,O,y,j,W,te,_,oe,re,he,ce,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=void 0,e.$_p=(0,_.$9h)(t.$Eo);const q=".vsctmp";let Z=class extends r.$Sp{constructor(F,C,f,S,z,T,H,G,ee,ue,fe,me){super(F,C,fe,f,ue,me),this.fb=z,this.gb=T,this.hb=H,this.ib=ee,this.eb=new Map,this.rb=new v.$Bc;const we=this.B(G.createInstance(I.$8p));this.bb=this.B(G.createInstance(M,le=>we.postUninstall(le))),this.cb=this.B(new y.$0p(me,ee,fe,this,this.F)),this.db=this.B(G.createInstance(l.$7p));const de=this.B(new j.$$p(this,this.fb,me,T,fe,ee,f));this.B(de.onDidChangeExtensionsByAnotherSource(le=>this.qb(le))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$bp)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.pb(F),f=await(0,m.zip)((0,$.$Ig)(this.db.extensionsDownloadDir,(0,c.$rg)()).fsPath,C);return b.URI.file(f)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:f}=await this.lb(F),S=d.$kc(C.fsPath);try{return await(0,O.$9p)(S)}finally{await f()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:f,cleanup:S}=await this.lb(F);try{const z=await(0,O.$9p)(d.$kc(f.fsPath)),T=(0,n.$8o)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,W.$ip)(z.engines.vscode,this.G.version,this.G.date))throw new Error(u.localize(0,null,T,this.G.version));const G=(await this.I([{manifest:z,extension:f,options:C}])).find(({identifier:ee})=>(0,n.$3o)(ee,{id:T}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Up)(new Error(`Unknown error while installing extension ${T}`))}finally{await S()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const f=await this.bb.scanUserExtensionAtLocation(F);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[f,void 0]],C),this.F.info("Successfully installed extension",f.identifier.id,C.toString()),f}async installExtensionsFromProfile(F,C,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),f.toString());const S=(await this.bb.scanExtensions(1,C)).filter(z=>F.some(T=>(0,n.$3o)(T,z.identifier)));if(S.length){const z=await Promise.all(S.map(T=>this.bb.scanMetadata(T,C)));await this.ub(S.map((T,H)=>[T,z[H]]),f),this.F.info("Successfully installed extensions",S.map(T=>T.identifier.id),f.toString())}return S}async updateMetadata(F,C,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0,C.hasPreReleaseVersion=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.bb.updateMetadata(F,C,f),this.cb.invalidate(f),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(u.localize(1,null));const C=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},R.CancellationToken.None);if(!f)throw new Error(u.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(S){throw new Error(u.localize(3,null,(0,L.$Si)(S)))}return this.installFromGallery(f)}ab(F,C,f,S){return this.bb.copyExtension(F,C,f,S)}copyExtensions(F,C){return this.bb.copyExtensions(F,C)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,f){const{location:S}=await this.db.download(F,C,!f);return S}async lb(F){if(F.scheme===E.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,$.$Ig)(this.db.extensionsDownloadDir,(0,c.$rg)());return await this.hb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.ib.del(C)}catch(S){this.F.error(S)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,C,f){if(b.URI.isUri(C))return new X(F,C,f,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const S=n.$4o.create(C).toString();let z=this.eb.get(S);return z||(this.eb.set(S,z=new V(F,C,f,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(S))),z}$(F,C){return new Y(F,C.profileLocation,this.gb)}async pb(F){const C=async S=>{let z=await p.Promises.readdir(S);z=z.map(G=>d.$jc(S,G));const T=await Promise.all(z.map(G=>p.Promises.stat(G)));let H=Promise.resolve([]);return T.forEach((G,ee)=>{const ue=z[ee];G.isFile()&&(H=H.then(fe=>[...fe,ue])),G.isDirectory()&&(H=H.then(fe=>C(ue).then(me=>[...fe,...me])))}),H};return(await C(F.location.fsPath)).map(S=>({path:`extension/${d.$lc(F.location.fsPath,S)}`,localPath:S}))}async qb({added:F,removed:C}){if(C){const f=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(S=>F.extensions.every(z=>!(0,n.$3o)(z,S))):C.extensions;for(const S of f)this.F.info("Extensions removed from another source",S.id,C.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:C.profileLocation})}if(F){const S=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(T=>(0,n.$3o)(T,z.identifier)));this.s.fire(S.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(C=>this.rb.add(C)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.rb.add(C.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(C=>this.tb(C)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const C=[];for(const f of F.rawAdded){if(this.rb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.ib.stat(f)).isDirectory)continue;const S=await this.bb.scanUserExtensionAtLocation(f);S&&S.installedTimestamp===void 0&&(this.rb.add(f),C.push(S))}C.length&&(await this.ub(C.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(f=>f.identifier.id)))}async ub(F,C){const f=F.map(S=>S[0]);await this.vb(f),await this.gb.addExtensionsToProfile(F,C),this.s.fire(f.map(S=>({local:S,identifier:S.identifier,operation:1,profileLocation:C})))}async vb(F){const C=await this.bb.getUninstalledExtensions();for(const f of F){const S=n.$4o.create(f);C[S.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",S.id),await this.bb.setInstalled(S),this.F.info("Removed the extension from uninstalled list:",S.id))}}};e.$aq=Z,e.$aq=Z=$e([se(0,t.$Bo),se(1,he.$wl),se(2,oe.$pj),se(3,i.$di),se(4,o.$2p),se(5,s.$Xp),se(6,g.$go),se(7,_.$7h),se(8,te.$sk),se(9,re.$Hj),se(10,ce.$3k),se(11,ae.$5k)],Z);let M=class extends a.$Tc{constructor(F,C,f,S,z,T){super(),this.j=F,this.m=C,this.n=f,this.s=S,this.t=z,this.u=T,this.h=this.B(new k.$Wd),this.onExtract=this.h.event,this.c=(0,$.$Ig)(this.n.userExtensionsLocation,".obsolete"),this.g=new N.$ch}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const f={includeInvalid:!0,profileLocation:C};let S=[];return F===null||F===0?S.push(...await this.n.scanAllExtensions({includeInvalid:!0},f,!1)):F===1&&S.push(...await this.n.scanUserExtensions(f)),S=F!==null?S.filter(z=>z.type===F):S,Promise.all(S.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(f=>this.F(f)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,f,S,z){const T=F.toString(),H=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$rg)()}`)),G=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,T));let ee=await this.m.exists(G);if(ee&&S){try{await this.y(F.id,G,"removeExisting")}catch{throw new t.$Co(u.localize(4,null,G.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(ee)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${C} to ${G.fsPath}`),await(0,m.$Qp)(C,H.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,F.id)}catch(ue){let fe=t.ExtensionManagementErrorCode.Extract;throw ue instanceof m.$Op&&(ue.type==="CorruptZip"?fe=t.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(fe=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$Co(ue.message,fe)}await this.n.updateMetadata(H,f);try{this.u.trace(`Started renaming the extension from ${H.fsPath} to ${G.fsPath}`),await this.C(H.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ue)}. Deleted from extracted location`,H),ue}this.h.fire(G)}catch(ue){try{await this.m.del(H,{recursive:!0})}catch{}throw ue}return this.D(G,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(S=>(0,n.$3o)(S.identifier,F.identifier))}async updateMetadata(F,C,f){return f?await this.s.updateMetadata([[F,C]],f):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(f=>n.$4o.create(f));await this.z(f=>C.forEach(S=>{f[S.toString()]=!0,this.u.info("Marked extension as uninstalled",S.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[n.$4o.create(F).toString()])}async copyExtension(F,C,f,S){const z=await this.w(F,C),T=await this.w(F,f);if(S={...z?.metadata,...S},T)if(this.t.extUri.isEqual(T.location,F.location))await this.s.updateMetadata([[F,{...T.metadata,...S}]],f);else{const H=await this.D(T.location,F.type,f);await this.s.removeExtensionFromProfile(H,f),await this.s.addExtensionsToProfile([[F,{...T.metadata,...S}]],f)}else await this.s.addExtensionsToProfile([[F,S]],f);return this.D(F.location,F.type,f)}async copyExtensions(F,C){const f=await this.scanExtensions(1,F),S=await Promise.all(f.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(S,C)}async y(F,C,f){this.u.trace(`Deleting ${f} extension from disk`,F,C.fsPath);const S=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,h.$Vi)((0,c.$rg)()).toString(16)}${q}`);await this.C(C.fsPath,S.fsPath),await this.m.del(S,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(S){if((0,te.$Jk)(S)!==1)throw S}let f={};if(C)try{f=JSON.parse(C)}catch{}return F&&(F(f),Object.keys(f).length?await this.m.writeFile(this.c,D.$ke.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(F,C){try{await p.Promises.rename(F,C,2*60*1e3)}catch(f){throw new t.$Co(f.message||u.localize(5,null,F,C),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,f){if(f){const z=(await this.n.scanUserExtensions({profileLocation:f})).find(T=>this.t.extUri.isEqual(T.location,F));if(z)return this.F(z)}else{const S=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(S)return this.F(S)}throw new Error(u.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let f,S;return C.children&&(f=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,S=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:f,changelogUrl:S,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const z of C)F[n.$4o.create(z).toString()]||f.add(z.identifier.id.toLowerCase());try{const z=(0,n.$9o)(C,T=>T.identifier);await N.Promises.settled(z.map(async T=>{const H=T.sort((G,ee)=>w.rcompare(G.manifest.version,ee.manifest.version))[0];f.has(H.identifier.id.toLowerCase())||await this.j(await this.F(H))}))}catch(z){this.u.error(z)}const S=C.filter(z=>z.metadata&&F[n.$4o.create(z).toString()]);await Promise.allSettled(S.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,te.$Jk)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(f){(0,te.$Jk)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$bq=M,e.$bq=M=$e([se(1,te.$sk),se(2,o.$2p),se(3,s.$Xp),se(4,ce.$3k),se(5,oe.$pj)],M);class U extends r.$Vp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,P.$Qf)(this.options.operation)?this.l:this.options.operation}constructor(F,C,f,S,z,T,H,G,ee){super(),this.identifier=F,this.source=C,this.options=f,this.m=S,this.n=z,this.o=T,this.p=H,this.q=G,this.s=ee,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,f]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,f]],this.j),C}async u({zipPath:F,key:C,metadata:f},S,z){let T=await this.v(C);return T?T=await this.m.updateMetadata(T,f):(this.s.trace("Extracting extension...",C.id),T=await this.m.extractUserExtension(C,F,f,S,z),this.s.info("Extracting extension completed.",C.id)),T}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(S=>n.$4o.create(S).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class V extends U{constructor(F,C,f,S,z,T,H,G,ee,ue){super(C.identifier,C,f,z,T,H,G,ee,ue),this.y=C,this.z=S}async x(F){let C;try{C=await this.m.scanExtensions(null,this.options.profileLocation)}catch(H){throw new t.$Co(H,t.ExtensionManagementErrorCode.Scanning)}const f=C.find(H=>(0,n.$3o)(H.identifier,this.y.identifier));f&&(this.l=3);const S={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,P.$Pf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,S),S]}catch(H){throw new t.$Co((0,A.$0)(H),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$4o.create(this.y),metadata:S},!1,F),S]}catch(H){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw H}}async B(F){try{await(0,O.$9p)(F)}catch(C){throw new t.$Co((0,r.$Tp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$cq=V;class X extends U{constructor(F,C,f,S,z,T,H,G,ee,ue){super({id:(0,n.$8o)(F.publisher,F.name)},C,f,z,T,H,G,ee,ue),this.y=F,this.z=C,this.A=S}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new n.$4o(this.identifier,this.y.version),S=(await this.m.scanExtensions(1,this.options.profileLocation)).find(H=>(0,n.$3o)(this.identifier,H.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??S?.pinned};if(S)if(this.l=3,C.equals(new n.$4o(S.identifier,S.manifest.version)))try{await this.m.removeExtension(S,"existing")}catch{throw new Error(u.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(S.manifest.version,this.y.version)&&await this.m.setUninstalled(S);else{const H=await this.v(C);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(u.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[f]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(f||([f]=await this.A.getExtensions([{id:F.identifier.id}],C)),f){const S={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,S,this.options.profileLocation)}}catch{}}}class Y extends r.$Vp{constructor(F,C,f){super(),this.extension=F,this.j=C,this.k=f}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;let v=class extends A.$Yp{constructor(d,$,w,P,b,c){super(a.URI.file(d.extensionsPath),$,w,P,b,c)}};e.$KO=v,e.$KO=v=$e([se(0,h.$di),se(1,k.$sk),se(2,D.$5k),se(3,R.$3k),se(4,L.$wl),se(5,N.$pj)],v)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,N,D,R,L,A,k,h,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0;let d=class extends L.$6p{constructor(w,P,b,c,p,m,u,g){super(N.URI.file(p.builtinExtensionsPath),N.URI.file(p.extensionsPath),p.userHome,w.defaultProfile,w,P,b,c,p,m,u,g)}};e.$z$b=d,e.$z$b=d=$e([se(0,E.$5k),se(1,R.$Xp),se(2,A.$sk),se(3,h.$pj),se(4,D.$di),se(5,a.$Hj),se(6,v.$3k),se(7,k.$7h)],d)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,N,D,R,L,A,k,h,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$wp=e.$vp=e.$up=void 0,e.$up="__$__isNewStorageMarker",e.$vp="__$__targetStorageMarker",e.$wp=(0,h.$8h)("storageService");var v;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function $(p){const m=p.get(e.$vp);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.$xp=$;class w extends R.$Tc{static{this.a=60*1e3}constructor(m={flushInterval:w.a}){super(),this.m=m,this.b=this.B(new D.$Zd),this.c=this.B(new D.$Zd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Wd),this.onWillSaveState=this.f.event,this.h=this.B(new N.$hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,u,g){return D.Event.filter(this.b.event,i=>i.scope===m&&(u===void 0||i.key===u),g)}n(){this.j.value=(0,N.$lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,u){const{key:g,external:i}=u;if(g===e.$vp){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:g,target:this.J(m)[g],external:i})}w(m){this.f.fire({reason:m})}get(m,u,g){return this.P(u)?.get(m,g)}getBoolean(m,u,g){return this.P(u)?.getBoolean(m,g)}getNumber(m,u,g){return this.P(u)?.getNumber(m,g)}getObject(m,u,g){return this.P(u)?.getObject(m,g)}storeAll(m,u){this.y(()=>{for(const g of m)this.store(g.key,g.value,g.scope,g.target,u)})}store(m,u,g,i,r=!1){if((0,A.$Sf)(u)){this.remove(m,g,r);return}this.y(()=>{this.z(m,g,i),this.P(g)?.set(m,u,r)})}remove(m,u,g=!1){this.y(()=>{this.z(m,u,void 0),this.P(u)?.delete(m,g)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,u){const g=[],i=this.J(m);for(const r of Object.keys(i))i[r]===u&&g.push(r);return g}z(m,u,g,i=!1){const r=this.J(u);typeof g=="number"?r[m]!==g&&(r[m]=g,this.P(u)?.set(e.$vp,JSON.stringify(r),i)):typeof r[m]=="number"&&(delete r[m],this.P(u)?.set(e.$vp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const u=this.P(m);return u?$(u):Object.create(null)}isNew(m){return this.getBoolean(e.$up,m)===!0}async flush(m=v.NONE){this.f.fire({reason:m});const u=this.P(-1),g=this.P(0),i=this.P(1);switch(m){case v.NONE:await N.Promises.settled([u?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await N.Promises.settled([u?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,u=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c(m,u,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,u){return this.w(v.NONE),(0,a.$4k)(m)?this.R(m,u):this.S(m,u)}M(m,u){return!(m.id===u.id||P(u)&&P(m))}N(m,u,g){this.y(()=>{const i=new Set;for(const[r,t]of m)i.add(r),u.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of u.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$yp=w;function P(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$zp=P;class b extends w{constructor(){super(),this.U=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$sp(new k.$tp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$Ap=b;async function c(p,m,u,g,i,r){const t=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,s=new Map;p.forEach((W,te)=>{n.set(te,W),s.set(te,t(W))});const o=new Map,l=new Map;m.forEach((W,te)=>{o.set(te,W),l.set(te,t(W))});const I=new Map,O=new Map;u.forEach((W,te)=>{I.set(te,W),O.set(te,t(W))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const y=[];if(n.forEach((W,te)=>{y.push({key:te,value:W})}),console.table(y),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const W=[];o.forEach((te,_)=>{W.push({key:_,value:te})}),console.table(W),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const j=[];I.forEach((W,te)=>{j.push({key:te,value:W})}),console.table(j),console.groupEnd(),console.log(O)}e.$Bp=c}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m,u,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.$Ep=void 0;const i=L.$o?"web":(0,E.$xo)(L.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...S){return String(S.reduce((z,T)=>z|T,0))}var s;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class y{constructor(z=O){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,T=this.d.pageSize){return new y({...this.d,pageNumber:z,pageSize:T})}withFilter(z,...T){const H=[...this.d.criteria,...T.length?T.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new y({...this.d,criteria:H})}withSortBy(z){return new y({...this.d,sortBy:z})}withSortOrder(z){return new y({...this.d,sortOrder:z})}withFlags(...z){return new y({...this.d,flags:z.reduce((T,H)=>T|H,0)})}withAssetTypes(...z){return new y({...this.d,assetTypes:z})}withSource(z){return new y({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:T,pageSize:H,sortBy:G,sortOrder:ee,flags:ue,assetTypes:fe}=this.d;return{filters:[{criteria:z,pageNumber:T,pageSize:H,sortBy:G,sortOrder:ee}],assetTypes:fe,flags:ue}}get searchText(){const z=this.d.criteria.filter(T=>T.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(S,z){const T=(S||[]).filter(H=>H.statisticName===z)[0];return T?T.value:0}function W(S){const z="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(H=>H.assetType.indexOf(z)===0).reduce((H,G)=>{const ee=oe(S,G.assetType);return ee&&H.push([G.assetType.substring(z.length),ee]),H},[])}function te(S){if(S.properties){const z=S.properties.filter(G=>G.key===o.Repository),T=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=z.filter(G=>T.test(G.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return oe(S,o.Repository)}function _(S){return{uri:`${S.fallbackAssetUri}/${o.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${o.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function oe(S,z){return S.files.filter(H=>H.assetType===z)[0]?{uri:`${S.assetUri}/${z}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${z}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function re(S,z){const T=S.properties?S.properties.filter(G=>G.key===z):[],H=T.length>0&&T[0].value;return H?H.split(",").map(G=>(0,d.$7o)(G)):[]}function he(S){const z=S.properties?S.properties.filter(T=>T.key===l.Engine):[];return z.length>0&&z[0].value||""}function ce(S){const z=S.properties?S.properties.filter(T=>T.key===l.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(S){const z=S.properties?S.properties.filter(H=>H.key===l.LocalizedLanguages):[],T=z.length>0&&z[0].value||"";return T?T.split(","):[]}function q(S){return S.properties?.find(z=>z.key===l.SponsorLink)?.value}function Z(S){return S.properties?.find(z=>z.key===l.SupportLink)?.value}function M(S){return S.indexOf("preview")!==-1}function U(S){return S.targetPlatform?(0,E.$wo)(S.targetPlatform):"undefined"}function V(S){const z=(0,N.$Mb)(S.versions.map(U)),T=!!S.tags?.includes(E.$ro),H=z.indexOf("web");return T?H===-1&&z.push("web"):H!==-1&&z.splice(H,1),z}function X(S,z){for(let T=0;T<S.length;T++){const H=S[T];if(H.version===S[T-1]?.version){let G=T;if(U(H)===z)for(;G>0&&S[G-1].version===H.version;)G--;G!==T&&(S.splice(T,1),S.splice(G,0,H))}}return S}e.$Ep=X;function Y(S,z,T){S.telemetryData={index:z,querySource:T,queryActivityId:S.queryContext?.[r]}}function Q(S,z,T,H){const G=S.versions[0],ee={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:te(z),download:_(z),icon:oe(z,o.Icon),signature:oe(z,o.Signature),coreTranslations:W(z)};return{identifier:{id:(0,d.$8o)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:z.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(G),description:S.shortDescription||"",installCount:j(S.statistics,"install"),rating:j(S.statistics,"averagerating"),ratingCount:j(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:T,assets:ee,properties:{dependencies:re(z,l.Dependency),extensionPack:re(z,l.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:U(z),isPreReleaseVersion:ce(z)},hasPreReleaseVersion:ce(G),hasReleaseVersion:!0,preview:M(S.flags),isSigned:!!ee.signature,queryContext:H,supportLink:Z(G)}}let F=class{constructor(z,T,H,G,ee,ue,fe,me){this.k=T,this.l=H,this.n=G,this.o=ee,this.q=ue,this.u=fe,this.w=me;const we=fe.extensionsGallery,de=we?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=de?we.servicePPEUrl:we?.serviceUrl,this.g=de?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,p.$Dp)(fe.version,fe,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,T,H){const G=D.CancellationToken.isCancellationToken(T)?{}:T,ee=D.CancellationToken.isCancellationToken(T)?T:H,ue=[],fe=[],me=[],we=[];let de=!0;for(const be of z){be.uuid?fe.push(be.uuid):ue.push(be.id);const ke=!!(be.version||be.preRelease);me.push({id:be.id,uuid:be.uuid,includePreRelease:ke}),be.version&&we.push({id:be.id,uuid:be.uuid,version:be.version}),de=de&&!!be.hasPreRelease&&!ke}if(!fe.length&&!ue.length)return[];let le=new y().withPage(1,z.length);fe.length&&(le=le.withFilter(s.ExtensionId,...fe)),ue.length&&(le=le.withFilter(s.ExtensionName,...ue)),(G.queryAllVersions||de)&&(le=le.withFlags(le.flags,t.IncludeVersions)),G.source&&(le=le.withSource(G.source));const{extensions:pe}=await this.z(le,{targetPlatform:G.targetPlatform??i,includePreRelease:me,versions:we,compatible:!!G.compatible},ee);return G.source&&pe.forEach((be,ke)=>Y(be,ke,G.source)),pe}async getCompatibleExtension(z,T,H){if((0,E.$yo)(z.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(z,T,H))return z;const G=new y().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ee}=await this.z(G,{targetPlatform:H,compatible:!0,includePreRelease:T},D.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(z,T,H){if(!(0,E.$zo)(z.properties.targetPlatform,z.allTargetPlatforms,H)||!T&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const ee=await this.getManifest(z,D.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return(0,$.$ip)(G,this.u.version,this.u.date)}async y(z,T,H,G,ee){if(!(0,E.$zo)(U(z),G,ee)||T!=="any"&&ce(z)!==(T==="prerelease"))return!1;if(H)try{const ue=await this.E(z);if(!(0,$.$ip)(ue,this.u.version,this.u.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,R.$0)(ue)),!1}return!0}async query(z,T){let H=z.text||"";const G=z.pageSize??50;let ee=new y().withPage(1,G);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(s.Category,pe||le),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(s.Tag,pe||le),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(s.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),ee=ee.withFilter(s.SearchText,H)),ee=ee.withSortBy(0)):z.ids?ee=ee.withFilter(s.ExtensionId,...z.ids):z.names?ee=ee.withFilter(s.ExtensionName,...z.names):ee=ee.withSortBy(4),typeof z.sortBy=="number"&&(ee=ee.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ee=ee.withSortOrder(z.sortOrder)),z.source&&(ee=ee.withSource(z.source));const ue=async(de,le)=>{const{extensions:pe,total:be}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},le);return pe.forEach((ke,je)=>Y(ke,(de.pageNumber-1)*de.pageSize+je,z.source)),{extensions:pe,total:be}},{extensions:fe,total:me}=await ue(ee,T),we=async(de,le)=>{if(le.isCancellationRequested)throw new R.$5;const{extensions:pe}=await ue(ee.withPage(de+1),le);return pe};return{firstPage:fe,total:me,pageSize:ee.pageSize,getPage:we}}async z(z,T,H){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),T.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ee,total:ue,context:fe}=await this.B(z,H);if(!(z.flags&t.IncludeLatestVersionOnly)){const le=[];for(const pe of ee){const be=await this.A(pe,T,fe);be&&le.push(be)}return{extensions:le,total:ue}}const we=[],de=new Map;for(let le=0;le<ee.length;le++){const pe=ee[le],be={id:(0,d.$8o)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,k.$Pf)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(B=>(0,d.$3o)(B,be))?.includePreRelease;if(T.compatible&&(0,E.$yo)(V(pe),T.targetPlatform))continue;const je=await this.A(pe,T,fe);!je||je.properties.isPreReleaseVersion&&(!ke||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==T.targetPlatform&&je.hasPreReleaseVersion?de.set(pe.extensionId,le):we.push([le,je])}if(de.size){const le=new g.$Sd,pe=new y().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,de.size).withFilter(s.ExtensionId,...de.keys()),{extensions:be}=await this.z(pe,T,H);this.o.publicLog2("galleryService:additionalQuery",{duration:le.elapsed(),count:de.size});for(const ke of be){const je=de.get(ke.identifier.uuid);we.push([je,ke])}}return{extensions:we.sort((le,pe)=>le[0]-pe[0]).map(([,le])=>le),total:ue}}async A(z,T,H){const G={id:(0,d.$8o)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ee=T.versions?.find(we=>(0,d.$3o)(we,G))?.version,ue=(0,k.$Pf)(T.includePreRelease)?T.includePreRelease:!!T.includePreRelease.find(we=>(0,d.$3o)(we,G))?.includePreRelease,fe=V(z),me=X(z.versions,T.targetPlatform);if(T.compatible&&(0,E.$yo)(fe,T.targetPlatform))return null;for(let we=0;we<me.length;we++){const de=me[we];if(!(ee&&de.version!==ee)){if(await this.y(de,ue?"any":"release",T.compatible,fe,T.targetPlatform))return Q(z,de,fe,H);if(ee&&de.version===ee)return null}}return ee||T.compatible?null:Q(z,z.versions[0],fe)}async B(z,T){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const H=await this.j,G=JSON.stringify(z.raw),ee={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ue=new g.$Sd;let fe,me,we=0;try{if(fe=await this.k.request({type:"POST",url:this.g&&z.criteria.some(le=>le.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ee},T),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:we};const de=await(0,c.$pp)(fe);if(de){const le=de.results[0],pe=le.extensions,be=le.resultMetadata&&le.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return we=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[r]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(de){const le=(0,R.$4)(de)?E.ExtensionGalleryErrorCode.Cancelled:(0,R.$0)(de).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw me=new E.$Do((0,R.$0)(de),le),me}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:ue.elapsed(),success:!!fe&&(0,c.$lp)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:me?.code,count:String(we)})}}async reportStatistic(z,T,H,G){if(!this.isEnabled())return;const ee=L.$o?this.x(`/itemName/${z}.${T}/version/${H}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${T}/${H}/stats?statType=${G}`),ue=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:ue};try{await this.k.request({type:"POST",url:ee,headers:me},D.CancellationToken.None)}catch{}}async download(z,T,H){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,d.$$o)(z),ee=new Date().getTime(),ue=le=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:le}),fe=H===2?"install":H===3?"update":"",me=fe?{uri:`${z.assets.download.uri}${h.URI.parse(z.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${z.assets.download.fallbackUri}${h.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:z.assets.download,we=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,de=await this.D(me,we?{headers:we}:void 0);await this.q.writeFile(T,de.stream),ue(new Date().getTime()-ee)}async downloadSignatureArchive(z,T){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const H=await this.D(z.assets.signature);await this.q.writeFile(T,H.stream)}async getReadme(z,T){if(z.assets.readme){const H=await this.D(z.assets.readme,{},T);return await(0,c.$op)(H)||""}return""}async getManifest(z,T){if(z.assets.manifest){const H=await this.D(z.assets.manifest,{},T),G=await(0,c.$op)(H);return G?JSON.parse(G):null}return null}async C(z,T){const H=oe(z,o.Manifest);if(!H)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},ee=await this.D(H,{headers:G});return await(0,c.$pp)(ee)}async getCoreTranslation(z,T){const H=z.assets.coreTranslations.filter(G=>G[0]===T.toUpperCase())[0];if(H){const G=await this.D(H[1]),ee=await(0,c.$op)(G);return ee?JSON.parse(ee):null}return null}async getChangelog(z,T){if(z.assets.changelog){const H=await this.D(z.assets.changelog,{},T);return await(0,c.$op)(H)||""}return""}async getAllCompatibleVersions(z,T,H){let G=new y().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(s.ExtensionId,z.identifier.uuid):G=G.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:ee}=await this.B(G,D.CancellationToken.None);if(!ee.length)return[];const ue=V(ee[0]);if((0,E.$yo)(ue,H))return[];const fe=[];await Promise.all(ee[0].versions.map(async de=>{try{await this.y(de,T?"any":"release",!0,ue,H)&&fe.push(de)}catch{}}));const me=[],we=new Set;for(const de of X(fe,H))we.has(de.version)||(we.add(de.version),me.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:ce(de)}));return me}async D(z,T={},H=D.CancellationToken.None){const G=await this.j,ee={type:"GET"},ue={...G,...T.headers||{}};T={...T,...ee,headers:ue};const fe=z.uri,me=z.fallbackUri,we={...T,url:fe};try{const de=await this.k.request(we,H);if(de.res.statusCode===200)return de;const le=await(0,c.$op)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${le}`)}catch(de){if((0,R.$4)(de))throw de;const le=(0,R.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:fe,message:le});const pe={...T,url:me};return this.k.request(pe,H)}}async E(z){let T=he(z);if(!T){const H=await this.C(z,D.CancellationToken.None);if(!H)throw new Error("Manifest was not found");T=H.engines.vscode}return T}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const T=await(0,c.$pp)(z),H=[],G={},ee=[];if(T){for(const ue of T.malicious)H.push({id:ue});if(T.migrateToPreRelease)for(const[ue,fe]of Object.entries(T.migrateToPreRelease))(!fe.engine||(0,$.$ip)(fe.engine,this.u.version,this.u.date))&&(G[ue.toLowerCase()]={disallowInstall:!0,extension:{id:fe.id,displayName:fe.displayName,autoMigrate:{storage:!!fe.migrateStorage},preRelease:!0}});if(T.deprecated)for(const[ue,fe]of Object.entries(T.deprecated))fe&&(G[ue.toLowerCase()]=(0,k.$Pf)(fe)?{}:fe);if(T.search)for(const ue of T.search)ee.push(ue)}return{malicious:H,deprecated:G,search:ee}}};F=$e([se(1,c.$jp),se(2,P.$pj),se(3,v.$ci),se(4,u.$wl),se(5,w.$sk),se(6,b.$Hj),se(7,a.$Bi)],F);let C=class extends F{constructor(z,T,H,G,ee,ue,fe,me){super(z,T,H,G,ee,ue,fe,me)}};e.$Fp=C,e.$Fp=C=$e([se(0,m.$wp),se(1,c.$jp),se(2,P.$pj),se(3,v.$ci),se(4,u.$wl),se(5,w.$sk),se(6,b.$Hj),se(7,a.$Bi)],C);let f=class extends F{constructor(z,T,H,G,ee,ue,fe){super(void 0,z,T,H,G,ee,ue,fe)}};e.$Gp=f,e.$Gp=f=$e([se(0,c.$jp),se(1,P.$pj),se(2,v.$ci),se(3,u.$wl),se(4,w.$sk),se(5,b.$Hj),se(6,a.$Bi)],f)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,N,D,R,L,A,k,h,a,v){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=void 0;let $=class extends h.$8k{static{E=this}static{this.a="profileAssociationsMigration"}constructor(c,p,m,u,g){super(m,u,p,g),this.U=c,this.W=m}O(){return this.U.getItem(E.b,[]).map(p=>({...p,location:(0,a.$Jf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):N.URI.revive(p.location)}))}Q(){const c=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(N.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$HO=$,e.$HO=$=E=$e([se(0,A.$CO),se(1,k.$3k),se(2,D.$di),se(3,R.$sk),se(4,L.$pj)],$);let w=d=class extends ${constructor(c,p,m,u,g){super(c,p,m,u,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",p=this.$.getItem(c,void 0);if(p){this.$.removeItem(c);const u=p.reduce((g,{workspace:i,profile:r})=>(g[N.URI.revive(i).toString()]=N.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:u})}const m=super.Q();return this.$.getItem(d.a,!1)||(this.R(m),this.$.setItem(d.a,!0)),m}};e.$IO=w,e.$IO=w=d=$e([se(0,A.$DO),se(1,k.$3k),se(2,D.$di),se(3,R.$sk),se(4,L.$pj)],w);let P=class extends w{constructor(c,p,m,u){super(new v.$GO(0,p,u,m),c,p,m,u)}async init(){return await this.$.init(),super.init()}};e.$JO=P,e.$JO=P=$e([se(0,k.$3k),se(1,D.$di),se(2,R.$sk),se(3,L.$pj)],P)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=void 0;let w=class extends E.$kp{constructor(p,m,u,g){super(g),this.m=p,this.n=m,this.r=u,this.s(),this.B(p.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,m){const{f:u,g}=this;let i;try{i=await(0,a.$bm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(n)))}const r={...process.env,...i},t=p.agent?p.agent:await(0,d.$or)(p.url||"",r,{proxyUrl:u,strictSSL:g});return p.agent=t,p.strictSSL=g,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>b(p,m))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((m,u)=>{J(["@vscode/proxy-agent"],m,u)})).loadSystemCertificates({log:this.r})}};e.$pr=w,e.$pr=w=$e([se(0,k.$Bi),se(1,h.$di),se(2,v.$pj),se(3,v.$qj)],w);async function P(c){return((0,N.parse)(c.url).protocol==="https:"?await new Promise((u,g)=>{J(["https"],u,g)}):await new Promise((u,g)=>{J(["http"],u,g)})).request}async function b(c,p){return D.Promises.withAsyncBody(async(m,u)=>{const g=(0,N.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await P(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$Pf)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,A.$Nf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)b({...c,url:n.headers.location,followRedirects:s-1},p).then(m,u);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,$.createGunzip)())),m({res:n,stream:(0,R.$ze)(o)})}});t.on("error",u),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),p.onCancellationRequested(()=>{t.abort(),u(new L.$5)})})}e.$qr=b}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(J,e,N,D,R,L,A,k,h,a,v,E,d,$,w,P,b,c,p,m,u,g,i,r,t,n,s,o,l,I,O,y,j,W,te,_,oe,re,he,ce,ae,q,Z,M,U,V,X,Y,Q,F,C,f,S,z,T,H,G,ee,ue,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends A.$Tc{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,pe]=await this.f();return le.invokeFunction(async be=>{const ke=be.get(_.$pj),je=be.get(o.$sk),B=be.get(c.$di),K=be.get(S.$5k);ke.info("CLI main",this.b),this.g(ke),await this.h(B,je,K,le),await Promise.all(pe.map(x=>{(0,D.$Yg)(x.flush(),1e3)}))})}async f(){const le=new j.$6h,pe={_serviceBrand:void 0,...ce.default};le.set(ae.$Hj,pe);const be=new p.$Em(this.b,pe);le.set(c.$di,be),await Promise.all([be.appSettingsHome.with({scheme:k.Schemas.file}).fsPath,be.extensionsPath].map(Le=>Le?d.Promises.mkdir(Le,{recursive:!0}):void 0));const ke=new ee.$BO((0,_.$Dj)(be),be.logsHome);le.set(_.$qj,ke);const je=this.B(ke.createLogger("cli",{name:(0,ue.localize)(0,null)})),B=[];ke.getLogLevel()===_.LogLevel.Trace&&B.push(new _.$xj(ke.getLogLevel()));const K=this.B(new G.$LO(je,B));le.set(_.$pj,K);const x=this.B(new l.$eq(K));le.set(o.$sk,x);const ge=this.B(new I.$Dq(K));x.registerProvider(k.Schemas.file,ge);const ye=new f.$4r(x);le.set(C.$3k,ye);const De=new M.$FO(1,be,K,x),Se=new z.$HO(De,ye,be,x,K);le.set(S.$5k,Se),x.registerProvider(k.Schemas.vscodeUserData,new fe.$1$b(k.Schemas.file,ge,k.Schemas.vscodeUserData,Se,ye,K));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$Y$b(K,pe.win32RegValueName)):be.policyFile?this.B(new oe.$Z$b(be.policyFile,x,K)):new re.$On;le.set(re.$Mn,ze);const Ie=this.B(new w.$co(Se.defaultProfile.settingsResource,x,ze,K));le.set($.$Bi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,T.$C$b)(De,K)}catch(Le){Le.code!=="ENOENT"&&K.error(Le)}const Ue=await(0,T.$D$b)(De,K);Se.init(),le.set(C.$3k,new f.$4r(x));const Oe=new Z.$pr(Ie,be,K,ke);le.set(q.$jp,Oe),le.set(P.$go,new O.$5h(b.$1O,void 0,!0)),le.set(r.$Xp,new O.$5h(H.$KO,void 0,!0)),le.set(t.$2p,new O.$5h(s.$z$b,void 0,!0)),le.set(g.$Hp,new O.$5h(g.$Ip,void 0,!0)),le.set(n.$_p,new O.$5h(n.$aq,void 0,!0)),le.set(u.$Bo,new O.$5h(m.$Gp,void 0,!0)),le.set(W.$jr,new O.$5h(te.$lr,void 0,!1));const Ae=[],Ce=(0,Y.$Zo)(pe,Ie);if((0,Y.$Uo)(pe,be)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new Q.$zO(Oe,Ce,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,U.$Lo)((0,N.release)(),(0,N.hostname)(),process.arch,pe.commit,pe.version,Ne,Ue,Ce),piiPaths:(0,Y.$1o)(be)};le.set(V.$wl,new O.$5h(X.$rr,[Le],!1))}else le.set(V.$wl,Y.$Po);return[new y.$Gq(le),Ae]}g(le){(0,L.setUnexpectedErrorHandler)(pe=>{const be=(0,R.$Si)(pe,!0);be&&le.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",pe=>{(0,L.$Z)(pe)||(0,L.$1)(pe)}),process.on("unhandledRejection",pe=>(0,L.$1)(pe))}async h(le,pe,be,ke){let je;if(le.args.profile&&(je=be.profiles.find(K=>K.name===le.args.profile),!je))throw new Error(`Profile '${le.args.profile}' not found.`);const B=(je??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Jp,new _.$xj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,B);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const K={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:B};return ke.createInstance(i.$Jp,new _.$xj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),K,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Jp,new _.$xj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,B);if(this.b["update-extensions"])return ke.createInstance(i.$Jp,new _.$xj(_.LogLevel.Info,!1)).updateExtensions(B);if(this.b["locate-extension"])return ke.createInstance(i.$Jp,new _.$xj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$m_b)(le.appRoot,le.extensionsPath))}}j(le){return le.map(pe=>/\.vsix$/i.test(pe)?E.URI.file((0,h.$ic)(pe)?pe:(0,h.$jc)((0,v.cwd)(),pe)):pe)}}async function we(de){const le=new me(de);try{await le.run()}finally{le.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e19ef7be65f0c25685f1f4886e4333e7472051aa/core/vs/code/node/cliProcessMain.js.map
